SystemOrganization addCategory: #Nautilus!

!TestCase class methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/7/2011 18:37'!
correspondingClass

	(self name endsWith: 'Test')
		ifTrue: [| index na symbol class |
			index := self name findString: 'Test'.
			na := self name copyFrom: 1 to: (index - 1) .
			symbol := Symbol readFromString: '#',na.
			^ Smalltalk at: symbol ifAbsent: [ nil ]].
	^ nil! !

!RecentMessageList methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/27/2011 21:08'!
lastClasses: anInteger

	"I return the last anInteger classes modified"
	| result tempList |
	result := OrderedCollection new.
	tempList := self methodReferenceList copy sort: [:a :b | a timeStamp >= b timeStamp].
	
	tempList do: [:method || class |
		result size = anInteger ifTrue: [^result].
		class := method actualClass theNonMetaClass.
		(result includes: class) ifFalse: [result add: class]].
	^ result! !

!SystemNavigation methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/4/2011 15:00'!
browsedEnvironment: aBrowserEnvironment

	| classes env globalsNames |
	classes := aBrowserEnvironment classes.
	env := SystemDictionary new.
	classes do: [:each | 
		env add: ( Smalltalk globals associationAt: each theNonMetaClass name )].
	globalsNames := Smalltalk globals keys asOrderedCollection.
	globalsNames removeAll: ( Smalltalk globals classNames ).
	 globalsNames removeAll: ( Smalltalk globals traitNames ).
	globalsNames do: [:each | 
		env add: ( Smalltalk globals associationAt: each )].
	environment := env! !

!SystemNavigation methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 15:53'!
selectorFromPattern: pattern withCaption: aCaption startingFrom: aClass
	"I look after a selector matching the given pattern in the withSuperclasses of the given class"

	| toMatch potentialSelectorsList potentialSelectorsListNames methodsNames exactMatch index foundSelector separatorIndex className separatorName class |
	(toMatch := pattern
		copyWithoutAll:
			{(Character space).
			(Character cr).
			(Character tab)}) isEmpty
		ifTrue: [ ^ nil ].
	potentialSelectorsList := aClass withAllSuperclasses reverse gather: [:each | each methodDict ].
	Symbol
		hasInterned: toMatch
		ifTrue: [ :patternSymbol || result |
			"Exact symbol provided"
			result := OrderedCollection new.
			potentialSelectorsList do: [:each | 
				(each selector = patternSymbol)
				ifTrue: [result add: each]].
			result size = 1 ifTrue: [^ result first ]].
	toMatch := (toMatch copyWithout: $.) asLowercase.
	potentialSelectorsListNames := potentialSelectorsList collect: [:each | each methodClass name, '>>#', each selector ].
	methodsNames := pattern last = $.
		ifTrue: [ potentialSelectorsListNames select: [ :nm | nm asLowercase = toMatch ] ]
		ifFalse: [ potentialSelectorsListNames select: [ :n | n includesSubstring: toMatch caseSensitive: false ] ].
	methodsNames isEmpty
		ifTrue: [ ^ nil ].
	exactMatch := methodsNames detect: [ :each | each asLowercase = toMatch ] ifNone: [ nil ].
	index := methodsNames size = 1
		ifTrue: [ 1 ]
		ifFalse: [ 
			exactMatch
				ifNil: [ UIManager default chooseFrom: methodsNames lines: #() title: aCaption ]
				ifNotNil: [ 
					methodsNames addFirst: exactMatch.
					UIManager default chooseFrom: methodsNames lines: #(1) title: aCaption ] ].
	index = 0
		ifTrue: [ ^ nil ].
	foundSelector := methodsNames at: index.
	separatorIndex := foundSelector findString: '>>#'.
	className := foundSelector copyFrom: 1 to: separatorIndex-1.
	separatorName := foundSelector copyFrom: separatorIndex + 2 to: foundSelector size.
	class := Smalltalk at: (Symbol readFromString: '#',className).

	
	^ class methodDict at: (Symbol readFromString: separatorName)
"
	self default selectorFromPattern: 'op' withCaption: '' startingFrom: Boolean
	self default selectorFromPattern: 'zork' withCaption: '' startingFrom: Boolean
	self default selectorFromPattern: 'op' withCaption: '' startingFrom: NautilusWindow
	self default selectorFromPattern: 'openInWorld' withCaption: '' startingFrom: NautilusWindow
"! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 11:27'!
<= aRPackage 

	^ self name <= aRPackage name! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/25/2011 14:51'!
fileOut

	self error: 'I should be implemented somehow'! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 12:40'!
orderedClasses

	| tmp |
	tmp := self definedClasses asArray sort: [:a :b | a name <= b name].
	tmp := tmp, (self extendedClasses asArray sort: [:a :b | a name <= b name]).
	^tmp
! !

PragmaMenuBuilder subclass: #NautilusPragmaMenuBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusPragmaMenuBuilder methodsFor: 'registrations handling' stamp: 'BenjaminVanRyseghem 4/11/2011 19:07'!
collectRegistrations
	"Retrieve all pragma methods and evaluate them by passing the 
	MenuRegistration class as argument. The result is a list of trees
	stored in my itemList inst var"
	self pragmaCollector
		do: [:prg | self
				currentRoot: self
				while: [ model perform: prg selector with: (MenuRegistration owner: self)]].
! !

!ClassEnvironment methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/25/2011 17:02'!
packages

	^ (self classes gather: [:each | each packages]) asSet! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/14/2011 16:26'!
createPackageNamed: aString

	| instance |
	(packages includesKey: (Symbol readFromString:  '#', aString ))
		ifTrue: [ 
			self openAreadyExistingError.
			^ nil ].
	
	instance := RPackage named: aString.
	self registerPackage: instance.
	^ instance! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 16:51'!
openAreadyExistingError

	StandardWindow new alert: 'A package with this name already exists' title: 'Already exists'! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 18:04'!
renamePackage: aPackage in: aString

	self haltIf: [aPackage isNil].
	(packages includesKey: (Symbol readFromString: '#', aString))
		ifTrue: [ ^ self openAreadyExistingError ].
	self unregisterPackage: aPackage.
	aPackage name: aString.
	self registerPackage: aPackage.
	^ aPackage! !

!MenuRegistration methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/31/2011 01:45'!
enabled: aBoolean

	self spec enabled: aBoolean! !

!MenuRegistration methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/31/2011 01:50'!
enabledBlock: aBlock

	self spec enabledBlock: aBlock! !

!SystemMethodModifiedAnnouncement methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/1/2011 16:03'!
item

	^ event item! !

!SystemMethodModifiedAnnouncement methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/1/2011 16:02'!
oldItem

	^ event oldItem! !

StandardWindow subclass: #A
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!A methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 4/7/2011 13:39'!
b

	! !

!A methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 4/6/2011 18:57'!
foo! !

A subclass: #B
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!B methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 4/6/2011 19:06'!
bar

! !

!B methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/26/2011 00:35'!
foo! !

B subclass: #C
	instanceVariableNames: 'button status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!C methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/26/2011 00:36'!
bar! !

!C methodsFor: 'test' stamp: 'BenjaminVanRyseghem 4/12/2011 17:10'!
buildButton

	button := ToogleIconicButton new
					model: self;
					actionSelector: #click;
					color: Color transparent;
					borderWidth: 0;
					statusSelector: #status;
					enabledIcon: (NautilusIcons iconNamed: #sourceSelectedIcon);
					disabledIcon: (NautilusIcons iconNamed: #sourceUnselectedIcon).
		
	^ button! !

!C methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:21'!
button

		^ button! !

!C methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:21'!
button: anObject
	
		button := anObject! !

!C methodsFor: 'test' stamp: 'BenjaminVanRyseghem 4/12/2011 17:11'!
click

	self status: self status not.! !

!C methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/26/2011 00:36'!
foo! !

!C methodsFor: 'test' stamp: 'BenjaminVanRyseghem 4/12/2011 16:38'!
status

		^ status ifNil: [ status := true ]! !

!C methodsFor: 'test' stamp: 'BenjaminVanRyseghem 4/12/2011 17:11'!
status: aBoolean

	status := aBoolean.
	self changed: #status! !

StandardWindow subclass: #NautilusWindow
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusWindow commentStamp: '<historical>' prior: 0!
I am a subclass of StandardWindow with my own icon

Maybe I'm useless, but right now I'm not on the top of the to do list!

!NautilusWindow methodsFor: 'thumbnail' stamp: 'BenjaminVanRyseghem 4/5/2011 14:22'!
icon

	^ NautilusUI icon! !

!NautilusWindow methodsFor: 'open/close' stamp: 'BenjaminVanRyseghem 4/11/2011 17:43'!
initialExtent

	^ 700@500! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/7/2011 18:51'!
containsFlag

	^ self literals includesAnyOf: #( flag flag: ).! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/7/2011 18:50'!
containsHalt

	^ self literals includesAnyOf: #( halt halt: halt:onCount: haltIf: haltIfNil haltIfShiftPressed haltOnCount: haltOnce haltOnce:).! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/7/2011 17:16'!
correspondingTestMethod

	((self methodClass inheritsFrom: TestCase) and: [ self selector beginsWith: 'test' ] )
		ifTrue: [ ^ self ]
		ifFalse: [| sel |
			(self selector endsWith: ':')
				ifTrue: [ sel := self selector allButLast asLowercase ]
				ifFalse:[  sel := self selector asLowercase ].
			(sel beginsWith: 'test')
				ifFalse: [ sel := 'test', sel].
			^ self methodClass correspondingTestClass
				ifNotNil:[:class| class methodDict values detect: [:each |
					each selector asLowercase = sel ] ifNone: [ nil ]]]! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/7/2011 18:10'!
hasErrorTest

	^ self methodClass methodRaisedError: (self selector)! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/7/2011 18:11'!
hasFailedTest

	^ self methodClass methodFailed: (self selector)! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/7/2011 18:11'!
hasPassedTest

	^ self methodClass methodPassed: (self selector)! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/26/2011 00:29'!
isOverride
	
	| selectors |
	selectors := self methodClass allSuperclasses gather: [:each | each selectors ].
	^ selectors includes: self selector! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/26/2011 00:32'!
isOverriden
	
	| selectors |
	selectors := self methodClass allSubclasses gather: [:each | each selectors ].
	^ selectors includes: self selector! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/6/2011 17:43'!
isTestMethod

	^ (self methodClass inheritsFrom: TestCase) and: [ self selector beginsWith: 'test' ]! !

!BrowserEnvironment methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/27/2011 15:45'!
packageOrganizer

	^ RPackageOrganizer default! !

!BrowserEnvironment methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 18:16'!
packages

	^ self packageOrganizer packages! !

!SystemClassRenamedAnnouncement methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/1/2011 17:51'!
newName
	
	^ self event newName! !

!SystemClassRenamedAnnouncement methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/1/2011 17:50'!
oldName
	
	^ self event oldName! !

IconicButton subclass: #ToogleIconicButton
	instanceVariableNames: 'model statusSelector enabledIcon disabledIcon helpText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:41'!
balloonText

	^ helpText! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:05'!
borderRaised
	self borderStyle: (BorderStyle raised width: 0).! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:12'!
disabledIcon

		^ disabledIcon! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:36'!
disabledIcon: anObject
	
		disabledIcon := anObject.
		self updateStatus.! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:12'!
enabledIcon

		^ enabledIcon! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:36'!
enabledIcon: anObject
	
		enabledIcon := anObject.
		self updateStatus.! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:08'!
extraBorder

	^ 0! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 16:26'!
getStatus

	self model 
		ifNotNil: [:mod | 
			self statusSelector
				ifNotNil:[:selector | 
					^ mod perform: selector ]].
	^ true! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 17:40'!
helpText

		^ helpText! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 17:40'!
helpText: anObject
	
		helpText := anObject! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:08'!
labelGraphic: aForm
	"Changed to look for any image morph rather than just a sketch."
	
	| oldLabel |
	graphicalMorph ifNotNil: [graphicalMorph delete].
	graphicalMorph := ImageMorph new image: aForm.
	self extent: graphicalMorph extent + (self borderWidth + self extraBorder).
	graphicalMorph position: self center - (graphicalMorph extent // 2).
	self addMorph: graphicalMorph.
	graphicalMorph lock
! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:25'!
model

	^ model! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 17:10'!
model: anObject
	
	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject.
	self target: anObject! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:12'!
statusSelector

		^ statusSelector! !

!ToogleIconicButton methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 16:12'!
statusSelector: anObject
	
		statusSelector := anObject! !

!ToogleIconicButton methodsFor: 'updating' stamp: 'BenjaminVanRyseghem 4/12/2011 16:31'!
update: aSymbol

	aSymbol = self statusSelector
		ifTrue: [ self updateStatus ].
	super update: aSymbol! !

!ToogleIconicButton methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 16:37'!
updateStatus

	self getStatus
		ifTrue: [
			self enabledIcon
				ifNotNil: [:icon |
					 self labelGraphic: icon ]]
		ifFalse: [
			self disabledIcon
				ifNotNil: [:icon | 
					self labelGraphic: icon ]].! !

!Trait methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/14/2011 21:40'!
correspondingTestClass

	(self name endsWith: 'Test')
		ifTrue: [ ^ self ]
		ifFalse: [| symbol |
			symbol := Symbol readFromString: ('#', self name, 'Test').
			^ Smalltalk at: symbol ifAbsent: [ nil ]]! !

!Trait methodsFor: '*Nautilus' stamp: 'BenjaminVanRysghem 3/17/2011 16:32'!
superclass
	" use to be polymorphic with classes "

	^ nil! !

Object subclass: #AbstractBrowserTools
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!AbstractBrowserTools commentStamp: '<historical>' prior: 0!
I'm an abstract class grouping generical methods for managing packages/classes/groups/methods from a browser!

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:12'!
addCategoryIn: aClass

	self addCategoryIn: aClass before: nil! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:11'!
addCategoryIn: aClass before: aCategory

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| labels reject lines oldIndex newName |
	
	labels := OrderedCollection new.
	reject := Set new.
	reject
		addAll: aClass organization categories;
		add: ClassOrganizer nullCategory;
		add: ClassOrganizer default.
	lines := OrderedCollection new.
	aClass allSuperclasses do: [:cls | | cats |
		cls = Object ifFalse: [
			cats := cls organization categories reject:
				 [:cat | reject includes: cat].
			cats isEmpty ifFalse: [
				lines add: labels size.
				labels addAll: cats asSortedCollection.
				reject addAll: cats ]]].
	
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: 'Add Category'.
	newName ifNil: [ ^self ].
	newName := newName asSymbol.

	aClass organization
		addCategory: newName
		before: aCategory.
	self selectedCategory: newName.
	
	^ newName! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:14'!
addClassIn: aPackage
	" add a new class in the provided package. A dialog will be opened to let the user set the class definition "

	| classSymbol systemCategory classDefinition |
	classSymbol := #NameOfSubclass.
	systemCategory := aPackage
		ifNil: [ 'Unknown' ].
	classDefinition := 'Object subclass: #' , classSymbol , '
		instanceVariableNames: '''' 
		classVariableNames: ''''
		poolDictionaries: ''''
		category: ''' , systemCategory name , ''''.
	classDefinition := UIManager default 
		multiLineRequest: 'Define class definition:'
		centerAt: Sensor cursorPoint
		initialAnswer: classDefinition
		answerHeight: 250.
	(classDefinition isNil or: [ classDefinition isEmpty ])
		ifTrue: [ ^ self ].
	Compiler evaluate: classDefinition.! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:16'!
addClassInGroup: aClass

	(DialogGroupAdder new
		groups:	self groupsManager;
		elementsToAdd: { aClass })
		open! !

!AbstractBrowserTools methodsFor: 'package' stamp: 'BenjaminVanRyseghem 4/13/2011 12:20'!
addPackageBasedOn: aPackage

	| name initialAnswer package |
	initialAnswer := aPackage ifNil: [''] ifNotNil: [:p | p name].
	name := UIManager default request: 'Name of the new package:' initialAnswer: initialAnswer title: 'Create a new package'.
	(name isNil or: [name isEmpty])
		ifFalse: [ package := self browsedEnvironment packageOrganizer createPackageNamed: name ].
	^ package! !

!AbstractBrowserTools methodsFor: 'package' stamp: 'BenjaminVanRyseghem 4/14/2011 22:47'!
addPackagesAsGroup: aCollection

	aCollection
		ifNotEmpty: [| packages list blocks name | 
			packages := aCollection sort: [:a :b | a name <= b name ].
			blocks := OrderedCollection new.
			packages do: [:package | blocks add: [ package orderedClasses]].
			name := ( packages collect: [:package | package name]) joinUsing: ' + '.
			^ (self groupsManager	
					addADynamicGroupSilentlyNamed: name
					blocks: blocks)]! !

!AbstractBrowserTools methodsFor: 'package' stamp: 'BenjaminVanRyseghem 4/13/2011 12:21'!
addPackagesAsGroup: aCollection named: aString

	aCollection
		ifNotEmpty: [:packages || blocks | 
			blocks := OrderedCollection new.
			packages do: [:package | blocks add: [ package orderedClasses]].
			^ (self groupsManager	
					addADynamicGroupSilentlyNamed: aString 
					blocks: blocks)]! !

!AbstractBrowserTools methodsFor: 'package' stamp: 'BenjaminVanRyseghem 4/13/2011 12:24'!
addPackagesInGroup: aCollection
	
	aCollection
		ifNotEmpty: [:packages || classes |
			classes := packages gather: [:package | package classes ].
			(DialogGroupAdder new
				groups:	self groupsManager;
				elementsToAdd: (self model classes intersection: classes))
				open]! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/14/2011 21:48'!
addTraitIn: aPackage
	" add a new class in the provided package. A dialog will be opened to let the user set the class definition "

	| classSymbol systemCategory classDefinition |
	classSymbol := #NameOfSubclass.
	systemCategory := aPackage
		ifNil: [ 'Unknown' ].
	classDefinition := 'Trait named: #TSortable
	uses: {}
	category: ''' , systemCategory name , ''''.
	classDefinition := UIManager default 
		multiLineRequest: 'Define class definition:'
		centerAt: Sensor cursorPoint
		initialAnswer: classDefinition
		answerHeight: 250.
	(classDefinition isNil or: [ classDefinition isEmpty ])
		ifTrue: [ ^ self ].
	Compiler evaluate: classDefinition.! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:25'!
browseClassRefsOf: aClass

	| class |
	class := aClass theNonMetaClass ifNil: [^self].
	class isTrait 
		ifTrue: [self systemNavigation browseAllUsersOfTrait: class]
		ifFalse: [self systemNavigation browseAllCallsOnClass: class]
! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:26'!
browseClassVarRefsOf: aClass

	| cls |
	cls := aClass theNonMetaClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation browseClassVarRefs: cls]! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:27'!
browseCommentVersionsOf: aCollection

	aCollection do: [:class | ClassCommentVersionsBrowser browseCommentOf: class ]! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:28'!
browseInstVarDefsOf: aClass

	(aClass notNil and: [aClass isTrait not])
		ifTrue: [self systemNavigation browseInstVarDefs: aClass]! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:29'!
browseInstVarRefsOf: aClass

	(aClass notNil and: [aClass isTrait not])
		ifTrue: [self systemNavigation browseInstVarRefs: aClass]! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/13/2011 12:34'!
browseMessagesFrom: aMethod
	" badly named, it browses implementors "

	self getSelectorAndSendQuery: #browseAllImplementorsOf: to: self systemNavigation with: {} method: aMethod! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/13/2011 12:34'!
browseSendersOfMessagesFrom: aMethod
	"Present a menu of the currently selected message, as well as all messages sent by it.  Open a message set browser of all senders of the selector chosen."

	self getSelectorAndSendQuery: #browseAllCallsOn: to: self systemNavigation with: {} method: aMethod! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:35'!
browseUnusedMethodsOf: aClass
	
	aClass
		ifNil: [^ self]
		ifNotNil: [:cls || classes unsent messageList |
			classes := Array with: cls with: cls class.
			unsent := Set new.
			classes
				do: [:c | unsent addAll: c selectors ].
			unsent := self systemNavigation allUnsentMessagesIn: unsent.
			messageList := OrderedCollection new.
			classes
				do: [:c | (c selectors
						select: [:s | unsent includes: s]) asSortedCollection
						do: [:sel | messageList add: c name , ' ' , sel]].
			self systemNavigation browseMessageList: messageList name: 'Unsent Methods in ' , cls name]! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 5/3/2011 15:55'!
browseVersionsFrom: aMethod
	"Create and schedule a Versions Browser, showing all versions of the 
	currently selected message. Answer the browser or nil."
	| selector class | 

	(selector := aMethod selector)
		ifNil:[ self inform: 'Sorry, only actual methods have retrievable versions.'. ^nil ]
		ifNotNil: [
			class := aMethod methodClass.
			
			(VersionsBrowser
				browseVersionsOf: aMethod
				class: class
				meta: class isMeta
				category: aMethod category
				selector: selector)]! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:37'!
categorizeAllUncategorizedMethodsOf: aClass
	"Categorize methods by looking in parent classes for a method category."

	| organizer organizers |
	organizer := aClass organization.
	organizers := aClass withAllSuperclasses collect: [:ea | ea organization].
	(organizer listAtCategoryNamed: ClassOrganizer default) do: [:sel | | found |
		found := (organizers collect: [ :org | org categoryOfElement: sel])
			detect: [:ea | ea ~= ClassOrganizer default and: [ ea ~= nil]]
			ifNone: [].
		found ifNotNil: [organizer classify: sel under: found]].! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/14/2011 11:28'!
categorizeMethods: aCollection of: aClass from: aCategory

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| labels reject lines oldIndex newName |
	aCollection ifEmpty: [^ self].
	aClass ifNil: [^self].
	
	labels := OrderedCollection new.
	labels
		addAll: aClass organization categories copy sort;
		add: ClassOrganizer default.
	lines := OrderedCollection new.
	lines add: labels size -1.
	
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: ('Change Protocol (current: ', aCategory, ')').
	newName ifNil: [ ^self ].
	newName := newName asSymbol.
	
	aCollection do: [:item | 
		item methodClass organization
					classify: item selector
					under: newName 
					suppressIfDefault: true ].! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/14/2011 14:59'!
compileANewClassFrom: aString

	^ Compiler evaluate: aString! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/14/2011 15:09'!
compileANewMethodInClass: aClass categorized: aCategory from: aString notifyng: aController

	^ aClass compile: aString classified: aCategory notifying: aController.! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:46'!
copyClasses: aCollection
	
	aCollection
		ifNotEmpty:[:classes || needsRefresh lastDuplicate | 
			needsRefresh := false.
			classes do: [:class || copysName |
				copysName := UIManager default request: 'Please type new class name' initialAnswer: class name.
				copysName isEmptyOrNil
					ifFalse: [
						needsRefresh ifFalse: [ needsRefresh := true ].
						lastDuplicate := class duplicateClassWithNewName: copysName ]].

			^(needsRefresh -> lastDuplicate)].
	^ false -> nil! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 12:48'!
createInstVarAccessorsOf: aClass
	"Create getters and setters for all inst vars defined at the level of the current class selection, except do NOT clobber or override any selectors already understood by the instances of the selected class"

	aClass
		ifNotNil:	[
			aClass instVarNames do: [:aName || setter newMessage |
				(aClass canUnderstand: aName asSymbol)
					ifFalse: [
						newMessage := self buildGetterFor: aName.
						aClass compile: newMessage classified: 'accessing' notifying: nil].
				(aClass canUnderstand: (aName, ':') asSymbol)
					ifFalse:[
						newMessage :=self buildSetterFor: aName.
						aClass compile: newMessage classified: 'accessing' notifying: nil]]]! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 5/3/2011 11:27'!
fileOutClasses: aCollection
	"Print a description of the selected class onto a file whose name is the 
	category name followed by .st."

	Cursor write 
		showWhile: [
			aCollection
				ifNotEmpty: [
					aCollection do: [:class | class theNonMetaClass fileOut ]]]! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/13/2011 12:52'!
fileOutMethods: aCollection

	Cursor write 
		showWhile:[
			aCollection
				ifNotEmpty: [:methods |
					 methods do: [:method |
						method methodClass fileOutMethod: method selector ]]]! !

!AbstractBrowserTools methodsFor: 'package' stamp: 'BenjaminVanRyseghem 4/13/2011 12:52'!
fileOutPackages: aCollection

	Cursor write 
		showWhile:[
			aCollection
				ifNotEmpty: [
					aCollection do: [:package | package fileOut ]]]! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/14/2011 16:38'!
findMethodIn: aClass

	| recentList pattern foundMethod |
	aClass ifNil: [^ nil ].
	recentList := aClass selectors.
	recentList size == 0
		ifTrue: [pattern := UIManager default request: 'Message name or fragment?']
		ifFalse: [pattern := UIManager default 
				enterOrRequestFrom: recentList 
				lines: #() 
				title: 'Message name or fragment?'].
			
	pattern isEmptyOrNil ifTrue: [^ nil ].
	foundMethod := self systemNavigation selectorFromPattern: pattern withCaption: '' startingFrom: self selectedClass.
	foundMethod ifNil: [^ nil ].
	^ foundMethod! !

!AbstractBrowserTools methodsFor: 'package' stamp: 'BenjaminVanRyseghem 4/13/2011 12:57'!
findPackageIn: aPackageNamesList

	| pattern foundPackage |
	aPackageNamesList size == 0
		ifTrue: [pattern := UIManager default request: 'Package name or fragment?']
		ifFalse: [pattern := UIManager default 
				enterOrRequestFrom: aPackageNamesList 
				lines: #() 
				title: 'Package name or fragment?'].
	pattern isEmptyOrNil ifTrue: [^ self flashPackage ].
	foundPackage := self systemNavigation packageFromPattern: pattern withCaption: ''.
	foundPackage ifNil: [^ self flashPackage].
	^ foundPackage! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/13/2011 12:32'!
getSelectorAndSendQuery: querySelector to: queryPerformer with: queryArgs method: aMethod
	"Obtain a selector relevant to the current context, and then send the querySelector to the queryPerformer with the selector obtained and queryArgs as its arguments.  If no message is currently selected, then obtain a method name from a user type-in"

	| strm array |
	strm := (array := Array new: queryArgs size + 1) writeStream.
	strm nextPut: nil.
	strm nextPutAll: queryArgs.

	aMethod ifNil: [ | selector |
		selector := UIManager default request: 'Type selector:' initialAnswer: 'flag:'.
		selector ifNil: [selector := String new].
		selector := selector copyWithout: Character space.
		^ selector isEmptyOrNil ifFalse: [
			(Symbol hasInterned: selector
				ifTrue: [ :aSymbol |
					array at: 1 put: aSymbol.
					queryPerformer perform: querySelector withArguments: array])
				ifFalse: [ self inform: 'no such selector']
		]
	].

	array at: 1 put: aMethod selector.
	queryPerformer perform: querySelector withArguments: array! !

!AbstractBrowserTools methodsFor: 'group' stamp: 'BenjaminVanRyseghem 4/13/2011 12:59'!
mergeGroups: aCollection

	aCollection
		ifNotEmpty: [:groups || group |
			group := groups reduce: [:a :b | a or: b].
			groups do: [:gp | 
				gp removable
					ifTrue: [self groupsManager removeAGroupSilently: gp]].
				^ group].
	^ nil! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/13/2011 13:00'!
methodHierarchyFrom: aMethod
	"Create and schedule a method browser on the hierarchy of implementors."

	self systemNavigation 
			methodHierarchyBrowserForClass: aMethod methodClass
			selector: aMethod selector! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/14/2011 16:30'!
moveInNewPackage: aCollection

	| labels reject lines oldIndex newName item aPackage |
	aCollection ifEmpty: [^self].
	aPackage := aCollection first package.	
	labels := self model packages collect: [:each | each name].
	lines := {0}.
		
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: ('Change Package (current: ', aPackage name,')').
	newName ifNil: [ ^self ].
	newName := newName asSymbol.

	item := self browsedEnvironment packageOrganizer packageNamed: newName.
	aCollection do: [:aClass |
		aPackage removeClass: aClass.
		item addClassDefinition: aClass.
		aClass category: item name ].
	^ item! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/13/2011 13:06'!
moveMethod: aMethod inPackage: aPackage

	aMethod methodClass organization
				classify: aMethod selector
				under: '*', aPackage name
				suppressIfDefault: true.! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/13/2011 13:05'!
moveMethodsToPackage: aCollection in: packagesList from: aPackage

	"Search for a package from a pattern or from the recent list"
	| pattern foundPackage |

	aCollection ifEmpty: [^ self ].

	packagesList size == 0
		ifTrue: [pattern := UIManager default request: 'Package name or fragment?']
		ifFalse: [pattern := UIManager default 
				enterOrRequestFrom: packagesList 
				lines: #() 
				title: 'Package name or fragment?'].
	pattern isEmptyOrNil ifTrue: [^ self flashPackage ].
	foundPackage := self systemNavigation packageFromPattern: pattern withCaption: ''.
	foundPackage ifNil: [^ self flashPackage].
	
	aPackage = foundPackage ifTrue: [ ^ self ].
	
	aCollection do: [:each |
		self moveMethod: each inPackage: foundPackage ].
		
! !

!AbstractBrowserTools methodsFor: 'category' stamp: 'BenjaminVanRyseghem 4/13/2011 13:09'!
removeCategory: aCategory inClass: aClass

	| messageCategoryName |
	aCategory ifNil: [^ self].
	self okToChange ifFalse: [^ self].
	messageCategoryName := aCategory.
	(self confirm: 'Are you sure you want to
remove the protocol ', aCategory,'
and all its methods?')
		ifTrue: 
			[aClass removeCategory: messageCategoryName.
			"self selectedCategory: nil.
			methodsTree update"
			^ true].
	^ false! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 16:15'!
removeClass: aClass
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	| message  className classToRemove result |
	classToRemove := aClass ifNil: [Beeper beep. ^ false].
	classToRemove := classToRemove theNonMetaClass.
	className := classToRemove name.
	message := 'Are you certain that you
want to REMOVE the class ', className, '
from the system?'.
	(result := self confirm: message)
		ifTrue: 
			[classToRemove subclasses size > 0
				ifTrue: [(self confirm: 'class has subclasses: ' , message)
					ifFalse: [^ false]].
			classToRemove removeFromSystem ].
	^ result! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 16:18'!
removeClasses: aCollection
	"Remove the selected classes from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	| result |
	result := false.
	aCollection
		ifNotEmpty: [
			aCollection do: [:class | (self removeClass: class)
										ifTrue: [ result := true ]]].
	^ result! !

!AbstractBrowserTools methodsFor: 'category' stamp: 'BenjaminVanRyseghem 4/13/2011 13:10'!
removeEmptyCategoriesFrom: aClass

	aClass organization removeEmptyCategories.! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/13/2011 13:12'!
removeMethod: aMethod inClass: aClass
	"If a message is selected, create a Confirmer so the user can verify that  
	the currently selected message should be removed from the system. If 
	so, remove it. "
	| messageName confirmation |
	aMethod ifNil: [^ false].
	messageName := aMethod selector.
	confirmation := self systemNavigation confirmRemovalOf: messageName on: aClass.
	confirmation == 3
		ifTrue: [^ false].
	(aClass includesLocalSelector: messageName)
		ifTrue: [ aClass removeSelector: messageName ]
		ifFalse: [ self removeNonLocalSelector: messageName ].

	"In case organization not cached"
	confirmation == 2
		ifTrue: [self systemNavigation browseAllCallsOn: messageName].
	^ true! !

!AbstractBrowserTools methodsFor: 'method' stamp: 'BenjaminVanRyseghem 4/13/2011 13:13'!
removeNonLocalSelector: aSymbol from: aClass
	| traits isAlias |
	traits := aClass traitsProvidingSelector: aSymbol.
	isAlias := aClass isLocalAliasSelector: aSymbol.
	isAlias
		ifTrue: [
			[traits size = 1] assert.
			aClass removeAlias: aSymbol of: traits first]
		ifFalse: [
			traits do: [:each |
				aClass addExclusionOf: aSymbol to: each ]]! !

!AbstractBrowserTools methodsFor: 'category' stamp: 'BenjaminVanRyseghem 4/13/2011 13:20'!
renameCategory: aCategory from: aClass
	"Prompt for a new category name and add it before the
	current selection, or at the end if no current selection"
	
	| oldIndex oldName newName |
	aClass ifNil: [^ self].
	aCategory ifNil: [^ self].
	oldName := aCategory.
	newName := UIManager default
		request: 'Please type new category name'
		initialAnswer: oldName.
	newName isEmptyOrNil
		ifTrue: [^ self]
		ifFalse: [newName := newName asSymbol].
	newName = oldName ifTrue: [^ self].
	aClass organization
		renameCategory: oldName
		toBe: newName.
	^ newName! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 16:06'!
renameClass: aClass
	| oldName newName obs |

	aClass ifNil: [ ^ self ].
	
	oldName := aClass name.
	newName := UIManager default  request: 'Please type new class name' initialAnswer: oldName.
	newName isEmptyOrNil ifTrue: [ ^ self ].	"Cancel returns"
	newName := newName asSymbol.
	newName = oldName ifTrue: [ ^ self ].
	(self class environment includesKey: newName)
		ifTrue: [ ^ self error: newName , ' already exists' ].
	aClass rename: newName.

	obs := self systemNavigation allReferencesTo: (aClass environment associationAt: newName).
	obs isEmpty
		ifFalse: [ self systemNavigation browseMessageList: obs name: 'Obsolete References to ' , oldName autoSelect: oldName ].
	^ newName! !

!AbstractBrowserTools methodsFor: 'package' stamp: 'BenjaminVanRyseghem 4/13/2011 16:08'!
renamePackages: aCollection

	| name |
	aCollection
		 ifNotEmpty: [:packages |
			packages do: [:selectedPackage | 
				name := UIManager default request: 'New name of the package' initialAnswer: selectedPackage name title: 'Rename a package'.
				(name isNil or: [name isEmpty])
					ifFalse: [ | package |
						package := self browsedEnvironment packageOrganizer renamePackage: selectedPackage in: name ]]]! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 16:11'!
showUnreferencedClassVarsOf: aClass
	"Search for all class variables known to the selected class, and put up a 
	list of those that have no references anywhere in the system. The 
	search includes superclasses, so that you don't need to navigate your 
	way to the class that defines each class variable in order to determine 
	whether it is unreferenced"
	| aList aReport |
	( aClass isNil or: [aClass isTrait]) ifTrue: [^ self].
	aList := self systemNavigation allUnreferencedClassVariablesOf: aClass.
	aList size == 0
		ifTrue: [^ UIManager default inform: 'There are no unreferenced
class variables in
' , aClass name].
	aReport := String
				streamContents: [:aStream | 
					aStream nextPutAll: 'Unreferenced class variable(s) in ' translated, aClass name;
						 cr.
					aList
						do: [:el | aStream tab; nextPutAll: el; cr]].
	UIManager default inform: aReport! !

!AbstractBrowserTools methodsFor: 'class' stamp: 'BenjaminVanRyseghem 4/13/2011 16:11'!
showUnreferencedInstVarsOf: aClass
	"Search for all instance variables known to the selected class, and put up a list of those that have no references anywhere in the system.  The search includes superclasses, so that you don't need to navigate your way to the class that defines each inst variable in order to determine whether it is unreferenced"

	|  aList aReport |
	(aClass isNil or: [aClass isTrait]) ifTrue: [^ self].
	aList := aClass allUnreferencedInstanceVariables.
	aList size == 0 ifTrue: [^ UIManager default inform: 'There are no unreferenced
instance variables in
', aClass name].
	aReport := String streamContents:
		[:aStream |
			aStream nextPutAll: 'Unreferenced instance variable(s) in ' translated, aClass name; cr.
			aList do: [:el | aStream tab; nextPutAll: el; cr]].
	UIManager default inform: aReport! !

AbstractBrowserTools subclass: #NautilusUI
	instanceVariableNames: 'model window methodsTree hierarchyClass cachedHierarchy sourceTextArea firstColumn secondColumn commentPane listSelection groupsSelection packagesSelection classesSelection list list2 sourceCodePanel commentTextArea currentDisplayChoice sourceTextAreaLimit'
	classVariableNames: 'Icon'
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusUI commentStamp: '<historical>' prior: 0!
I'm a new browser based on RPackage and Announcements with fancy goodies:

	- groups ( you can create groups with your favorite classes)
	- multi-selections
	- environments
	- iconic buttons
	- hierarchy
	- pragma based menus!

!NautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/17/2011 17:51'!
buildIcon

	| bitmap |
	bitmap :=  (Bitmap new: 256) copyFromByteArray:   #[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 249 235 15 254 248 233 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 183 102 33 13 162 147 126 14 199 176 153 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 143 187 142 101 94 197 140 89 0 0 0 0 208 181 135 93 108 190 134 85 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 144 159 121 84 174 168 127 90 119 181 140 104 194 182 128 81 24 207 148 99 4 252 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 159 170 119 70 255 200 124 58 253 189 122 63 60 148 118 91 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 199 157 91 59 255 222 129 64 255 201 118 48 178 152 100 49 73 138 112 54 106 168 135 62 167 206 169 100 193 191 158 105 115 172 143 97 0 0 0 0 5 155 136 98 55 204 190 157 10 236 223 187 0 0 0 0 21 105 87 68 91 162 123 78 240 187 126 60 255 212 131 43 253 227 148 48 255 218 157 63 255 233 175 78 255 235 176 64 255 224 167 68 255 232 171 81 255 216 168 74 109 181 145 85 21 154 136 98 245 194 174 137 33 211 209 190 81 172 145 107 241 194 152 81 255 207 158 80 255 243 176 64 254 246 176 67 254 208 141 49 255 221 156 81 255 200 123 54 255 209 137 56 255 187 124 56 254 204 128 48 255 248 183 62 230 171 125 65 0 0 0 0 198 196 161 122 135 198 161 130 238 191 139 90 255 227 158 63 254 234 165 51 254 244 172 65 255 227 160 65 254 170 105 26 255 209 144 65 254 185 117 40 253 213 143 55 252 221 143 58 248 238 144 58 255 223 134 39 250 163 97 51 20 231 255 255 185 186 137 106 255 181 122 80 255 162 85 36 255 221 124 53 255 234 154 50 255 234 170 61 255 232 168 69 255 220 149 53 255 238 159 56 255 241 163 59 255 231 158 59 255 226 151 64 255 198 120 54 215 166 91 43 57 133 68 38 13 210 220 210 83 199 158 129 209 203 160 125 129 184 139 102 235 161 83 47 255 190 102 41 255 203 112 40 255 208 117 47 253 213 121 50 251 208 122 55 222 185 106 44 175 159 100 50 139 141 103 65 53 156 105 65 9 99 69 79 0 0 0 0 0 0 0 0 0 0 0 0 143 155 129 114 0 0 0 0 10 138 135 170 65 108 49 22 87 138 77 48 93 129 70 41 45 93 34 6 26 68 32 26 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 197 179 174 0 0 0 0 93 197 180 176 4 202 182 170 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 180 88 18 2 146 92 49 1 128 100 73 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0].
	^ Form extent: 16@16 depth: 32 bits: bitmap! !

!NautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/25/2011 23:21'!
icon 

	^ Icon ifNil: [ Icon := self buildIcon ]! !

!NautilusUI class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
on: aNautilus

	^ self new model: aNautilus! !

!NautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/17/2011 17:48'!
resetIcon

	Icon := nil! !

!NautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/27/2011 20:39'!
test! !

!NautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 4/14/2011 17:00'!
aGroupHasBeenAdded: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!NautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 4/14/2011 16:01'!
aGroupHasBeenRegistered: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!NautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 4/14/2011 17:23'!
aGroupHasBeenRemoved: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	(self groupsManager =  anAnnouncement holder)
		ifTrue: [ 
			self selectedGroup = anAnnouncement group
				ifTrue: [ self selectedGroup: nil ].
			self updateGroupView.
			self update ]! !

!NautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 4/14/2011 17:06'!
aGroupHasBeenRenamed: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!NautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 4/14/2011 15:59'!
aGroupHasBeenUnregistered: anAnnouncement

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 5/2/2011 15:41'!
addAll: aWindow
			
			
	| column row |
	aWindow
		addMorph: (self buildFirstColumn: aWindow)
		frame: (0@0 corner: 0.33@0.5).		
				
	aWindow
		addMorph: (self buildSecondColumn: aWindow)
		frame: (0.33@0 corner: 0.66@0.5).

	aWindow 
		addMorph: (self buildMethodsTree)
		frame: (0.66@0 corner: 1@0.5).
	
	sourceCodePanel := PanelMorph new.
	sourceCodePanel 
		layoutPolicy: TableLayout new;
		listDirection: #bottomToTop.
		
	self showAnnotationPane
		ifTrue: [ sourceCodePanel addMorph: self buildAnnotationPane ].
		
	sourceCodePanel addMorph: self buildCodePane.
	"self buildCommentPane."
	sourceCodePanel 
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	row := PanelMorph new.
	row 
		changeTableLayout;
		listDirection: #leftToRight.

	{	sourceCodePanel.
		self buildTextAreaButtonsColumn: aWindow} reverse do: [:each | row addMorph: each].
		
	
	
	aWindow
		addMorph: row
		frame: (0@0.5 corner: 1@1).! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:13'!
addCategory

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| newName |
	self okToChange ifFalse: [^ self].
	self selectedClass ifNil: [^ self].

	newName := self addCategoryIn: self selectedClass before: self selectedCategory.

	self update.
	methodsTree setSelectedNodeItem: newName.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:17'!
addClass

	self selectedPackage ifNotNil: [:package | self addClassIn: package ]
	
	" No need of update, announcements will do the job "! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:17'!
addClassInGroup

	self selectedClass ifNotNil: [:class | self addClassInGroup: class ].! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/2/2011 11:08'!
addComment: aText notifying: aController

	self selectedClass
		ifNil: [
			self selectedPackage
				ifNotNil: [:package | 
					"commentTextArea update: #clearUserEdits.
					package comment: aText"]]
		ifNotNil: [:class |
			commentTextArea update: #clearUserEdits.
			class comment: aText ]! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/7/2011 15:19'!
addModelItemsToWindowMenu: aMenu
	"Add model-related items to the window menu"
	"super addModelItemsToWindowMenu: aMenu."
	SystemBrowser addRegistryMenuItemsTo: aMenu inAccountOf: self model.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:20'!
addPackage

	| package |
	package := self addPackageBasedOn: self selectedPackage.
	package ifNotNil: [
			self selectedPackage: package.
			self updatePackageView ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/14/2011 11:24'!
addPackageAsGroup

	^ self addPackagesAsGroup: self selectedPackages! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 14:44'!
addPackageAsGroupAndBrowse

	self addPackageAsGroup
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:24'!
addPackageInGroup
	
	self addPackagesInGroup: self selectedPackages! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
addSubclassesOf: aClass in: result withIndex: index

	(aClass subclasses sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
addSubclassesOf: aClass in: result withIndex: index fromRestrictedCollection: aCollection

	| classes |
	
	classes := aClass subclasses intersection: aCollection.
	(classes sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1 fromRestrictedCollection: aCollection]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/14/2011 21:49'!
addTrait

	self selectedPackage ifNotNil: [:package | self addTraitIn: package ]
	
	" No need of update, announcements will do the job "! !

!NautilusUI methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 5/2/2011 15:35'!
annotation

	|  aSelector aClass |
	(aClass := self selectedClass) == nil ifTrue: [^ '------'].

	(aSelector := self selectedMethod ) ifNil: [^ '------'].
	aSelector := aSelector selector.
	^ self annotationForSelector: aSelector ofClass: aClass! !

!NautilusUI methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 5/2/2011 15:37'!
annotationForSelector: aSelector ofClass: aClass 
	"Provide a line of content for an annotation pane, representing  
	information about the given selector and class"
	| separator aStream requestList |
	
	aStream := ReadWriteStream on: ''.
	requestList := self annotationRequests.
	separator := requestList size > 1
				ifTrue: [self annotationSeparator]
				ifFalse: [''].
	requestList
		do: [:aRequest | | sendersCount aComment implementorsCount aString aList stamp aCategory | 
			aRequest == #firstComment
				ifTrue: [aComment := aClass firstCommentAt: aSelector.
					aComment isEmptyOrNil
						ifFalse: [aStream nextPutAll: aComment , separator]].
			aRequest == #masterComment
				ifTrue: [aComment := aClass supermostPrecodeCommentFor: aSelector.
					aComment isEmptyOrNil
						ifFalse: [aStream nextPutAll: aComment , separator]].
			aRequest == #documentation
				ifTrue: [aComment := aClass precodeCommentOrInheritedCommentFor: aSelector.
					aComment isEmptyOrNil
						ifFalse: [aStream nextPutAll: aComment , separator]].
			aRequest == #timeStamp
				ifTrue: [stamp := self selectedMethod 
									ifNil: ['']
									ifNotNil: [:meth | meth timeStamp].
					aStream
						nextPutAll: (stamp size > 0
								ifTrue: [stamp , separator]
								ifFalse: ['no timeStamp' , separator])].
			aRequest == #messageCategory
				ifTrue: [aCategory := aClass organization categoryOfElement: aSelector.
					aCategory
						ifNotNil: ["woud be nil for a method no longer present,  
							e.g. in a recent-submissions browser"
							aStream nextPutAll: aCategory , separator]].
			aRequest == #sendersCount
				ifTrue: [sendersCount := (self systemNavigation allCallsOn: aSelector) size.
					sendersCount := sendersCount == 1
								ifTrue: ['1 sender']
								ifFalse: [sendersCount printString , ' senders'].
					aStream nextPutAll: sendersCount , separator].
			aRequest == #implementorsCount
				ifTrue: [implementorsCount := self systemNavigation numberOfImplementorsOf: aSelector.
					implementorsCount := implementorsCount == 1
								ifTrue: ['1 implementor']
								ifFalse: [implementorsCount printString , ' implementors'].
					aStream nextPutAll: implementorsCount , separator].
			aRequest == #priorVersionsCount
				ifTrue: [self
						addPriorVersionsCountForSelector: aSelector
						ofClass: aClass
						to: aStream].
			aRequest == #priorTimeStamp
				ifTrue: [stamp := VersionsBrowser
								timeStampFor: aSelector
								class: aClass
								reverseOrdinal: 2.
					stamp
						ifNotNil: [aStream nextPutAll: 'prior time stamp: ' , stamp , separator]].
			aRequest == #recentChangeSet
				ifTrue: [aString := ChangeSet mostRecentChangeSetWithChangeForClass: aClass selector: aSelector.
					aString size > 0
						ifTrue: [aStream nextPutAll: aString , separator]].
			aRequest == #allChangeSets
				ifTrue: [aList := ChangeSet allChangeSetsWithClass: aClass selector: aSelector.
					aList size > 0
						ifTrue: [aList size = 1
								ifTrue: [aStream nextPutAll: 'only in change set ']
								ifFalse: [aStream nextPutAll: 'in change sets: '].
							aList
								do: [:aChangeSet | aStream nextPutAll: aChangeSet name , ' ']]
						ifFalse: [aStream nextPutAll: 'in no change set'].
					aStream nextPutAll: separator]].
	^ aStream contents! !

!NautilusUI methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 5/2/2011 15:34'!
annotationRequests
	^ self model annotationRequests! !

!NautilusUI methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 5/2/2011 15:36'!
annotationSeparator
	"Answer the separator to be used between annotations"

	^ '  '! !

!NautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 4/7/2011 15:01'!
arrowDown: aMethod

	| methods methodsNames index |
	methods := aMethod methodClass allSubclasses gather: [:each | each methodDict values ].
	methods := methods select: [:each | each selector = aMethod selector ].
	methods size = 1
		 ifTrue: [ ^ self model class openOnMethod: methods first ].
	methodsNames := methods collect: [:each | each methodClass name, '>>#', each selector ].
	index := UIManager default chooseFrom: methodsNames.
	index = 0 ifTrue: [ ^ self ].
	^ self model class openOnMethod: (methods at: index)
	! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 4/13/2011 16:19'!
arrowKey2: aCharacter from: aPluggableListMorph 

	aCharacter == $f
		ifTrue: [
			^ self 
				ifPackages: [ self findMethod ]
				ifClasses:[ self findClass ]].
			
	aCharacter == $F
		ifTrue: [
			^ self 
				ifPackages: [ self findClass ]
				ifClasses:[ self findPackage ]].

	aCharacter == $b
		ifTrue: [ ^ self fullBrowse ].

	aCharacter == $N
		ifTrue: [ 
			self showPackages
				ifTrue: [ self browseClassRefs ]].
		
	aCharacter == $B
		ifTrue: [
			^ self 
				ifPackages: [ self restrictedBrowseClass ]
				ifClasses:[ self restrictedBrowsePackage ]].

	aCharacter == $N
		ifTrue: [
			^ self 
				ifPackages: [  ]
				ifClasses:[ self browseClassRefs ]].
			
	aCharacter == $n
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addClass ]
						ifClasses:[ ^ self addPackage ]]].

	(aCharacter == $r and: [ self selectedClasses size <= 1 ])
		ifTrue: [
			^ self 
				ifPackages: [ self renameClass ]
				ifClasses:[ self renamePackage ]].
				
	aCharacter == $x
		ifTrue: [
			^self 
				ifPackages: [ self removeClasses ]
				ifClasses:[ self removePackage ]].
			
	aCharacter == $c
		ifTrue: [
			self showPackages
				ifTrue: [ ^ self copyClass ]].
	
	aCharacter == $g
		ifTrue: [
			self 
				ifPackages: [  ]
				ifClasses:[ ^ self addPackageAsGroupAndBrowse ]].
				
	aCharacter == $G
		ifTrue: [
			self 
				ifPackages: [  ]
				ifClasses:[ ^ self addPackageAsGroup ]].
				
	aCharacter == $e
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addClassInGroup ]
						ifClasses:[ ^ self addPackageInGroup ]]].! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 4/13/2011 16:19'!
arrowKey: aCharacter from: aPluggableListMorph 

	aCharacter == $f
		ifTrue: [
			^ self 
				ifPackages: [ self findClass ]
				ifClasses:[ self findMethod ]].

	aCharacter == $F
		ifTrue: [
			^ self 
				ifPackages: [ self findPackage ]
				ifClasses:[ self findClass ]].

	aCharacter == $b
		ifTrue: [ ^ self fullBrowse ].

	aCharacter == $B
		ifTrue: [
			^ self showGroups
				ifTrue: [ self restrictedBrowseGroup: self selectedGroups ]
				ifFalse: [
					self 
						ifPackages: [ self restrictedBrowsePackage ]
						ifClasses:[ self restrictedBrowseClass ]]].
				
	aCharacter == $N
		ifTrue: [ 
			self showPackages
				ifFalse: [ self browseClassRefs ]].

	(aCharacter == $r and: [ self enableSingleMenuItems ])
		ifTrue: [
			^ self showGroups
				ifTrue: [ self renameGroup ]
				ifFalse: [
					self 
						ifPackages: [ self renamePackage ]
						ifClasses:[ self renameClass ]]].
				
	aCharacter == $x
		ifTrue: [
			self showGroups
				ifTrue: [ self removeGroup ]
				ifFalse: [
					self 
						ifPackages: [ self removePackage ]
						ifClasses:[ self removeClasses ]]].
				
	aCharacter == $c
		ifTrue: [
			self showPackages
				ifFalse: [ ^ self copyClass ]].
	
	aCharacter == $g
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addPackageAsGroupAndBrowse ]
						ifClasses:[ ]]].
	aCharacter == $n
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addPackage ]
						ifClasses:[ ^ self addClass ]]].
							
	aCharacter == $G
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addPackageAsGroup ]
						ifClasses:[ ]]].
				
	aCharacter == $e
		ifTrue: [
			self showGroups
				ifFalse: [
					self 
						ifPackages: [ ^ self addPackageInGroup ]
						ifClasses:[ ^ self addClassInGroup ]]].! !

!NautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 4/7/2011 13:57'!
arrowUp: aMethod

	| newMethod |
	newMethod := aMethod methodClass superclass lookupSelector: aMethod selector.
	self model class openOnMethod: newMethod! !

!NautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 4/7/2011 13:56'!
arrowUpAndDown: aMethod! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 23:28'!
asYetUnclassifiedString

	^ ClassOrganizer default! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:26'!
browseClassRefs

	self browseClassRefsOf: self selectedClass
! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:26'!
browseClassVarRefs

	self browseClassVarRefsOf: self selectedClass! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/13/2011 12:03'!
browseClassVars

	| cls |
	cls := self selectedClass theNonMetaClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation browseClassVarRefs: cls]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:28'!
browseInstVarDefs 

	self browseInstVarDefsOf: self selectedClass! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:29'!
browseInstVarRefs 

	self browseInstVarRefsOf: self selectedClass! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/13/2011 12:02'!
browseInstVars

	| cls |
	cls := self selectedClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation browseInstVarRefs: cls]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:34'!
browseMessages

	self browseMessagesFrom: self selectedMethod! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:35'!
browseSendersOfMessages
	"Present a menu of the currently selected message, as well as all messages sent by it.  Open a message set browser of all senders of the selector chosen."

	self browseSendersOfMessagesFrom: self selectedMethod! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:35'!
browseUnusedMethods
	
	self browseUnusedMethodsOf: self selectedClass! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:36'!
browseVersions
	"Create and schedule a Versions Browser, showing all versions of the 
	currently selected message. Answer the browser or nil."

	self browseVersionsFrom: self selectedMethod! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 12:27'!
browsedEnvironment

	^ self model browsedEnvironment! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/2/2011 15:29'!
buildAnnotationPane

	| pane |
	pane := CodeAnnotationMorph
		on: self.

"	pane
		vResizing: #rigid;
		hResizing: #spaceFill."

	^ pane! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/13/2011 12:02'!
buildBrowseClassVarsButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #browseClassVars;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #isAClassSelected;
			enabledIcon: (NautilusIcons iconNamed: #classVarsSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #classVarsUnselectedIcon);
			helpText: 'Show class variables'.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/13/2011 11:59'!
buildBrowseInstVarsButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #browseInstVars;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #isAClassSelected;
			enabledIcon: (NautilusIcons iconNamed: #instVarsSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #instVarsUnselectedIcon);
			helpText: 'Show instance variables'.! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/3/2011 13:57'!
buildCodePane

	sourceTextArea := PluggableTextMorphWithLimits
				on: self
				text: #sourceCode
				accept: #compileSource:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
				
	sourceTextArea beStyled.
	sourceTextArea
		askBeforeDiscardingEdits: true;
		vResizing: #spaceFill;
		hResizing: #spaceFill.

	sourceTextArea spaceFillWeight: 3.
	sourceTextAreaLimit := sourceTextArea warningLimit.

	^ sourceTextArea! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 4/11/2011 13:15'!
buildCommentButton

	^ (PluggableButtonMorph
			on: self 
			getState: #commentButtonState
			action: #commentButtonAction
			label: #commentButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 4/12/2011 18:05'!
buildCommentPane

	commentTextArea := PluggableTextMorph
							on: self
							text: #getComments
							accept: #addComment:notifying:
							readSelection: nil
							menu: #codePaneMenu:shifted:.
				
	commentTextArea color: Color white.
	commentTextArea
		askBeforeDiscardingEdits: true;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
		
	commentTextArea spaceFillWeight: 1.

	^ commentTextArea! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/26/2011 13:28'!
buildFirstColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ firstColumn := GroupboxMorph new
			addContentMorph: self buildList;
			addContentMorph: (aWindow newRow: {self buildToogleButton. self buildGroupsButton});
			label: self labelText;
			hResizing: #spaceFill;
			vResizing: #spaceFill
			! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 16:08'!
buildGetterFor: aString

	^ aString,'

		^ ', aString! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:33'!
buildGroupHierarchyFor: aGroup

	| result coll1 |
	result := OrderedCollection new.
	self browsedEnvironment isSystem
		ifTrue: [ coll1 := aGroup elements ]
		ifFalse:[ coll1 := aGroup elements intersection: self model classes ].
	
	aGroup ifNil: [^ result ].
	((self rootsOfGroup: aGroup) asArray) do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: coll1 ].
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildGroupsButton

	^ (PluggableButtonMorph
			on: self 
			getState: #groupsButtonState
			action: #groupsButtonAction
			label: #groupsButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildHierarchyFor: aClass

	| result tmp index |
	
	aClass ifNil: [^ {}].
	result := OrderedCollection new.
	tmp := aClass withAllSuperclasses reverse.
	1 to: tmp size do: [:i | result add: (tmp at: i) -> (i-1)].

	index := (tmp size -1).
	self addSubclassesOf: aClass in: result withIndex: index + 1.
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 4/11/2011 13:14'!
buildInstanceButton

	^ (PluggableButtonMorph
			on: self 
			getState: #instanceButtonState
			action: #instanceButtonAction
			label: #instanceButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 4/11/2011 11:04'!
buildList

	list := PluggableIconListMorphOfMany
			on: self 
			list: #getList 
			primarySelection: #selected
			changePrimarySelection: #selected:
			listSelection: #listSelectionAt:
			changeListSelection: #listSelectionAt:put:
			menu: #menu:shifted:.
		
	list getIconSelector: #listIcon:.		
	list resetListSelector: #resetListSelection.
	list autoDeselect: true.
	list doubleClickSelector: #doubleClick.
	list wrapSelector: #listWrapper:.
	list hResizing: #spaceFill.
	list vResizing: #spaceFill.
	^ list! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/3/2011 13:25'!
buildList2

	list2 := PluggableIconListMorphOfMany
				on: self
				list: #getList2
				primarySelection: #selected2
				changePrimarySelection: #selected2:
				listSelection: #listSelection2At:
				changeListSelection: #listSelection2At:put:
				menu: #menu2:shifted:.
							
	list2 keystrokeActionSelector: #arrowKey2:from:.
	list2 getIconSelector: #listIcon2:.
	list2 resetListSelector: #resetListSelection2.
	list2 autoDeselect: true.
	list2 doubleClickSelector: #doubleClick2.
	list2 wrapSelector: #listWrapper2:.
	list2 hResizing: #spaceFill.
	list2 vResizing: #spaceFill.
	^ list2! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 4/6/2011 18:07'!
buildMethodsTree

	methodsTree := SwitchableCategoriesTreeWithLabel
							on: self
							rootsSelector: #roots
							elementsForCategorySelector: #methodsForCategory:
							categoriesLabelSelector: #categoriesLabel
							elementsLabelSelector: #methodsLabel
							categoriesButtonLabelSelector: #categoriesButtonLabel
							elementsButtonLabelSelector: #methodsButtonLabel
							getSwitchSelector: #getSwitch
							setSwitchSelector: #setSwitch:
							getSelectedElementSelector: #selectedMethod
							setSelectedElementSelector: #selectedMethod:
							getSelectedCategorySelector: #selectedCategory
							setSelectedCategorySelector: #selectedCategory:
							setCategoryWrapperSelector: #categoryWrapper:
							setElementWrapperSelector: #methodWrapper:.
	methodsTree moveFromToIsCopySelector: #move:from:to:isCopy:.
	
	methodsTree elementIconSelector: #methodIconFor:.
	methodsTree categoryIconSelector: #categoryIconFor:.
	
	methodsTree keyPressedOnElementSelector: #keyPressedOnElement:.
	methodsTree keyPressedOnCategorySelector: #keyPressedOnCategory:.
	
	methodsTree
		categoriesMenuSelector: #categoriesMenu:shifted:;
		elementsMenuSelector: #elementsMenu:shifted:.
	^ methodsTree build: [:tree | tree indentGap: 0 ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:32'!
buildPackageHierarchyFor: aPackage

	| result coll1 coll2 |

	result := OrderedCollection new.
	self browsedEnvironment isSystem
		ifTrue: [
			coll1 := aPackage definedClasses.
			coll2 := aPackage extendedClasses ]
		ifFalse: [
			coll1 := self model classes intersection: aPackage definedClasses.
			coll2 := self model classes intersection: aPackage extendedClasses ].
	
	
	((self rootsOf: aPackage) asArray sort: [:a :b | a name <= b name ] )do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: coll1].
	( coll2 asArray sort: [:a :b | a name <= b name ]) do:[:class |
		result add: (class -> 0)].
	^ result! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildPackagesClassesColumn: aWindow


	"container := PanelMorph new."
	"to fix in order to avoid the resize"
	
	"^ aWindow newColumn: {
			(aWindow newRow: {
				self buildFirstColumn: aWindow.
				self buildSecondColumn: aWindow})
				hResizing: #spaceFill; vResizing: #spaceFill.
			self buildToogleButton}"! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/12/2011 15:26'!
buildRefactoringSubMenu: aBuilder
	<nautilusClassMenu>

	self selectedClass ifNil: [^self].

	(aBuilder item: #'Inst var refs...')
		action: [self browseInstVarRefs];
		parent: #Analyzing;
		order: 0.

	(aBuilder item: #'Inst var defs...')
		action: [self browseInstVarDefs];
		parent: #Analyzing;
		order: 100.

	(aBuilder item: #'Create inst var accessors')
		action: [self createInstVarAccessors];
		parent: #Analyzing;
		order: 200;
		withSeparatorAfter.

	(aBuilder item: #'Class var refs...')
		action: [self browseClassVarRefs];
		parent: #Analyzing;
		order: 300.
		
	(aBuilder item: #'Class refs... (N)')
		action: [self browseClassRefs];
		parent: #Analyzing;
		order: 400.
		
	(aBuilder item: #'Browse comment versions... (v)')
		action: [ self browseCommentVersionsOf: {self selectedClass} ];
		parent: #Analyzing;
		order: 500;
		withSeparatorAfter.
		
	(aBuilder item: #'Unsent methods...')
		action: [self browseUnusedMethods.];
		parent: #Analyzing;
		order: 600.
	
	(aBuilder item: #'Unreferenced inst vars...')
		action: [self showUnreferencedInstVars.];
		parent: #Analyzing;
		order: 700.
		
	(aBuilder item: #'Unreferenced class vars...')
		action: [self showUnreferencedClassVars.];
		parent: #Analyzing;
		order: 800.! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:57'!
buildSecondColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph2.
		self buildList2.
		aWindow newRow: {self buildInstanceButton. self buildCommentButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ secondColumn := GroupboxMorph new
			addContentMorph: self buildList2;
			addContentMorph: (aWindow newRow: {self buildInstanceButton. self buildCommentButton});
			label: self labelText2;
			hResizing: #spaceFill;
			vResizing: #spaceFill! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 4/13/2011 11:47'!
buildSeparator

	^ ImageMorph new newForm: (self iconClass iconNamed: #separatorIcon)! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 16:10'!
buildSetterFor: aString

	^ aString, ': anObject
	
		', aString, ' := anObject'! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:46'!
buildSwitchToByteCodeButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #switchToByteCodeButton;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #showByteCode;
			enabledIcon: (NautilusIcons iconNamed: #byteCodeSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #byteCodeUnselectedIcon);
			helpText: 'Show byteCode'.! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 4/12/2011 17:48'!
buildSwitchToDecompileButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #switchToDecompileButton;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #showDecompile;
			enabledIcon: (NautilusIcons iconNamed: #decompileSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #decompileUnselectedIcon);
			helpText: 'Show decompiled method'.! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 4/12/2011 17:45'!
buildSwitchToSourceCodeButton

	^ ToogleIconicButton new
			model: self;
			actionSelector: #switchToSourceCodeButton;
			color: Color transparent;
			extent: 24@24;
			borderWidth: 0;
			statusSelector: #showSource;
			enabledIcon: (NautilusIcons iconNamed: #sourceSelectedIcon);
			disabledIcon: (NautilusIcons iconNamed: #sourceUnselectedIcon);
			helpText: 'Show source code'.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildTabbedNameOf: anElement
			
	| tab result assoc |
	
	tab := '   '.
	result := ''.
	assoc := cachedHierarchy detect: [:each | each key == anElement ] ifNone: [''->0].
	1 to: assoc value do: [:i | result := tab, result].
	^ self selectedPackage 
		ifNil: [result, anElement name]
		ifNotNil: [:package | 
			(package extendedClasses includes: anElement)
				ifTrue: [ result , '*', anElement name ]
				ifFalse: [ result, anElement name ]]! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 4/13/2011 12:01'!
buildTextAreaButtonsColumn: aWindow

	| column |
	column := PanelMorph new.
	column 
		changeTableLayout;
		listDirection: #topToBottom.
		
		{	self buildSwitchToSourceCodeButton.
			self buildSwitchToByteCodeButton.
			self buildSwitchToDecompileButton.
			self buildSeparator.
			self buildBrowseInstVarsButton.
			self buildBrowseClassVarsButton.
			self buildSeparator} reverse do: [:each | column addMorph: each ].
	
	column 
		vResizing: #spaceFill;
		width: 24;
		hResizing: #rigid.
	
	^ column! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildToogleButton

	^ (PluggableButtonMorph
			on: self 
			getState: #toogleButtonState
			action: #toogleButtonAction
			label: #toogleButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 4/7/2011 14:28'!
buildUpAndDownArrowIcon: aMethod

	| container up down |
	
	container := Morph new.
	container 
		extent: 12@12;
		color: Color transparent.
		
	up := IconicButton new 
				target: self;
				actionSelector: #arrowUp:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleUp);
				color: Color transparent;
				extent: 12 @ 6;
				borderWidth: 0.
				
	down :=  IconicButton new 
				target: self;
				actionSelector: #arrowDown:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleDown);
				color: Color transparent;
				extent: 12 @ 6;
				borderWidth: 0.
				
	^ container
		changeTableLayout;
		listDirection: #topToBottom;
		addMorph: down;
		addMorph: up;
		yourself! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:16'!
byteCodeSymbol

	^ #ByteCode! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
categoriesButtonLabel

	^ 'Switch to methods'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/21/2011 18:46'!
categoriesLabel

	^ self showInstance
		ifTrue: ['Instance protocols:']
		ifFalse: ['Class protocols:']! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/31/2011 14:07'!
categoriesMenu: aBuilder
	<nautilusProtocolMenu>
	
	self selectedCategory ifNil: [ ^ self ].
	
	(aBuilder item: #'Rename... (r)')
		action: [ self renameCategory ];
		order: 1000;
		enabledBlock: [ self enableTreeSingleSelection ].
		
	(aBuilder item: #'Remove empty protocols')
		action: [ self removeEmptyCategories ];
		order: 1100.
		
	(aBuilder item: #'Remove... (x)')
		action: [ self removeCategoriesOrMethods ];
		order: 1200;
		icon: (self iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
		(aBuilder item: #'File Out')
		action: [ self fileOutMethods ];
		order: 1300.! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/31/2011 13:32'!
categoriesMenu: aMenu shifted: b

	^ aMenu becomeForward: (self categoryMenuBuilder menu)! !

!NautilusUI methodsFor: 'menus extensions' stamp: 'BenjaminVanRyseghem 3/21/2011 14:20'!
categoriesRefactoringMenu: aMenu shifted: b! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:38'!
categorizeAllUncategorizedMethods
	"Categorize methods by looking in parent classes for a method category."

	self categorizeAllUncategorizedMethodsOf: self selectedClass.

	" no need to update, announcements do the job "! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:43'!
categorizeMethod

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| aCollection aClass |
	self okToChange ifFalse: [^ self].
	(aCollection := self selectedTreeMethods) ifEmpty: [^ self].
	(aClass := self selectedClass) ifNil: [^self].	

	self categorizeMethods: aCollection of: aClass from: self selectedCategory.

	self update.
	methodsTree setSelectedNodeItem: self selectedMethod.! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/30/2011 10:58'!
categoryIconFor: aCategory

	^ nil! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 14:02'!
categoryMenuBuilder

	^ NautilusPragmaMenuBuilder withAllPragmaKeywords: {self commonPragma. self categoryPragma} model: self! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 13:17'!
categoryPragma

	^'nautilusProtocolMenu'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
categoryWrapper: anItem

	^ anItem! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:58'!
changedLabels

	firstColumn label: self labelText.
	secondColumn label: self labelText2.! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/13/2011 17:38'!
classAdded: anAnnouncement
	
	| class |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	class := anAnnouncement item.
	self updateClassView! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/12/2011 15:04'!
classCommented: anAnnouncement
	" announcement handled when a class has been commented " 

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	((self selectedClass = anAnnouncement item) and: [ self showComment ])
		ifTrue: [ self changed: #getComments ]! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 4/5/2011 15:06'!
classFixPragma

	^'nautilusClassFixMenu'! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 4/11/2011 18:29'!
classIconFor: aClass

	^ self iconClass iconNamed: #blank! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
classLabel

	^'Class'! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 4/5/2011 15:06'!
classMenuBuilder

	^NautilusPragmaMenuBuilder withAllPragmaKeywords: {self classFixPragma. self classPragma} model: self! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 02:07'!
classPragma

	^'nautilusClassMenu'! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/5/2011 15:18'!
classRecategorized: anAnnouncement
	
	window isDisplayed ifFalse: [ ^ self ].
	self selectedClass = anAnnouncement item
		ifTrue: [ self update ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/1/2011 19:05'!
classRemoved: anAnnouncement
	
	| class |
	class := anAnnouncement item.
	window isDisplayed ifFalse: [ ^ self ].
	(self
		ifPackages: [ self getRawList2 includes: class ]
		ifClasses: [ self getRawList includes: class ])
			ifTrue: [
				self selectedClass = class
					ifTrue: [ self selectedClass: nil ].
				window isDisplayed ifFalse: [ ^ self ].
				self updateClassView ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/1/2011 17:57'!
classRenamed: anAnnouncement
	
	| class |
	class := anAnnouncement item.
	window isDisplayed ifFalse: [ ^ self ].
	(self
		ifPackages: [ self getRawList2 includes: class ]
		ifClasses: [ self getRawList2 includes: class ])
			ifTrue: [ self updateClassView ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/11/2011 17:43'!
classReorganized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	anAnnouncement item = self selectedClass
		ifTrue: [	self update ].! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/14/2011 21:47'!
classesFixMenu: aBuilder
	<nautilusClassFixMenu>
	
	(aBuilder item: #'Find Method... (f)')
		action: [self findMethod];
		order: 0;
		help: 'Search for a method by selector'.
		
	(aBuilder item: #'Find Class... (F)')
		action: [ self findClass ];
		order: 100;
		help: 'Search for a method by selector';
		withSeparatorAfter.
	
	(aBuilder item: #'Add class... (n)')
		action: [ self addClass ];
		order: 200;
		help: 'Create a new class'.
	(aBuilder item: #'Add trait...')
		action: [ self addTrait ];
		order: 300;
		withSeparatorAfter.
		
	(aBuilder item: #'Browse full (b)')
		action: [self fullBrowse];
		order: 999;
		help: 'Open the same browser'.! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/13/2011 16:19'!
classesMenu: aBuilder
	<nautilusClassMenu>

	self selectedClass ifNil: [^self].
		
	(aBuilder item: #'Browse restricted (B)')
		action: [self restrictedBrowseClass];
		order: 1000;
		help: 'Open a browser on a restricted view';
		withSeparatorAfter.
		
	(aBuilder item: #Analyzing)
		enabledBlock: [ self selectedClasses size <= 1 ];
		order: 1100.
	
	(aBuilder item: #'Move to package...')
		action: [ self moveInNewPackage ];
		order: 1200.	

	(aBuilder item: #'Rename... (r)')
		action: [ self renameClass ];
		enabledBlock: [ self selectedClasses size <= 1 and: [ self showInstance ]];
		order: 1300.	
			
	(aBuilder item: #'Copy... (c)')
		action: [ self copyClass ];
		order: 1400.	
			
	(aBuilder item: #'Remove... (x)')
		action: [ self removeClasses ];
		icon: (self iconClass iconNamed: #removeIcon);
		order: 1500;
		withSeparatorAfter.
			
	(aBuilder item: #'File Out')
		action: [ self fileOutClass ];
		withSeparatorAfter;
		order: 1600.	
			
	self showGroups
		ifTrue: [
			self selectedGroup isReadOnly 
				ifFalse: [
					(aBuilder item: #'Remove from Group (X)')
						action: [ self removeClassFromGroup ];
						order: 1700]]
		ifFalse: [
			(aBuilder item: #'Add in Group... (e)')
						action: [ self addClassInGroup ];
						order: 1700]! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 02:03'!
classesMenu: aMenu shifted: aBoolean 

	^ aMenu becomeForward: (self classMenuBuilder menu)! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 4/13/2011 11:34'!
clearUserEditFlag
	
	self changed: #clearUserEdits! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 04:54'!
codePaneMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:, 
	PluggableTextController will respond to all menu items in a 
	text pane"
	| donorMenu |
	donorMenu := shifted
				ifTrue: [SmalltalkEditor shiftedYellowButtonMenu]
				ifFalse: [SmalltalkEditor yellowButtonMenu].
	^ aMenu addAllFrom: donorMenu! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 4/12/2011 15:01'!
commentButtonAction

	self toogleShowComment.! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonLabel

	^ self commentLabel! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonState

	^ self showComment! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2011 09:57'!
commentLabel

	^ 'Comments'! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/11/2011 16:56'!
commonMenu: aBuilder
	<nautilusCommonMenu>
.
	(aBuilder item: #'Find Method... (f)')
		action: [ self findMethod ];
		order: 0;
		help: 'Search for a method by name';
		withSeparatorAfter.
		
	(aBuilder item: #'Add protocol...')
		action: [ self addCategory ];
		order: 100;
		withSeparatorAfter.
	
	(aBuilder item: #'Browse full (b)')
		action: [ self fullBrowse ];
		order: 200;
		withSeparatorAfter.
		
	(aBuilder item: #'Categorize all uncategorized')
		action: [ self categorizeAllUncategorizedMethods ];
		order: 999;
		withSeparatorAfter.! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 13:50'!
commonPragma

	^'nautilusCommonMenu'! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/2/2011 15:20'!
compileAClassFrom: aString

	sourceTextArea update: #clearUserEdits.
	(self compileANewClassFrom: aString)
		ifNil: [^self]
		ifNotNil: [:class | 
			
			self selectedPackage: class package.
			self selectedClass: class.
			self showHierarchy
						ifTrue: [	self hierarchyClass: class ].
			self showGroups
				ifTrue: [ self updateClassView ]
				ifFalse: [ self updateBothView ]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 4/14/2011 15:06'!
compileAMethodFromCategory: aCategory withSource: aString notifying: aController

	| category selector |
	category := aCategory.
	self selectedClass
		ifNil: ["should never happened" self error]
		ifNotNil: [:class || cat |
			cat := category.
			category = self noMethodsString
				ifTrue: [ cat := self asYetUnclassifiedString ].
			selector := self compileANewMethodInClass: class categorized: cat from: aString notifyng: aController.
			selector
				ifNil: [^ self ]
				ifNotNil: [| method |
					sourceTextArea update: #clearUserEdits.
					method := class methodDict at: selector.
					methodsTree setSelectedNodeItem: method.
					( self selectedMethod notNil and: [(self selectedClass = class) and: [ self selectedMethod selector = selector]])
						ifFalse: [
							self selectedMethod: method.
							self update ]]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 4/14/2011 15:24'!
compileSource: aText notifying: aController

	| source |
	source := aText asString.
	self selectedCategory
		ifNil: [ self compileAClassFrom: source ]
		ifNotNil: [:category | self compileAMethodFromCategory: category withSource: source notifying: aController ]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 00:54'!
contentsSelection

	self selectedClass isNil
		ifFalse:[	
			self selectedMethod isNil
				ifTrue: [
					self selectedCategory notNil
						ifTrue: [^ (1 to: self defaultMethodSource size) ]]].
	^ (1 to: 0)! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:46'!
copyClass
	
	| association |
	self okToChange ifFalse: [^ self].
	association := self copyClasses: self selectedClasses.
	association key
		ifTrue: [
			self selectedClass: association value.
			self updateClassView]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:48'!
createInstVarAccessors
	"Create getters and setters for all inst vars defined at the level of the current class selection, except do NOT clobber or override any selectors already understood by the instances of the selected class"

	self createInstVarAccessorsOf: self selectedClass! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 17:38'!
currentDisplayChoice

	^ currentDisplayChoice ifNil: [ currentDisplayChoice := self sourceCodeSymbol ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 17:49'!
currentDisplayChoice: aSymbol

	currentDisplayChoice := aSymbol.
	
	self changed: #showSource.
	self changed: #showByteCode.
	self changed: #showDecompile.
	self changed: #sourceCode.! !

!NautilusUI methodsFor: 'remove me' stamp: 'BenjaminVanRyseghem 3/29/2011 16:02'!
debug

	self halt.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:17'!
decompileSymbol

	^ #Decompile! !

!NautilusUI methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 5/2/2011 15:32'!
defaultAnnotationInfo
	"see annotationRequests comment"
	^ #(timeStamp messageCategory sendersCount implementorsCount allChangeSets)! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
defaultClassDescriptor

	| string |
	string := 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: '''.
	^ self selectedPackage
		ifNil: [string, '''' ]
		ifNotNil: [:package | string, package name, '''' ]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 00:46'!
defaultMethodSource


	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 07:11'!
doItContext

	^ nil! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 07:12'!
doItReceiver

	^ self selectedClass theNonMetaClass! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 4/5/2011 11:29'!
doubleClick

	self 
		ifGroups: [ self doubleClickOnGroup ]
		ifNot: [
			self ifPackages: [ self doubleClickOnPackage ] ifClasses: [ self doubleClickOnClass ]]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/22/2011 14:02'!
doubleClick2

	self 
		ifPackages: [ self doubleClickOnClass ] 
		ifClasses: [ self doubleClickOnPackage ]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/25/2011 14:59'!
doubleClickOnClass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [:class |
			self showGroups
				ifTrue: [ self model class openOnClass: class onGroup: self selectedGroup ]
				ifFalse: [ self model class openOnClass: class ]]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/22/2011 13:45'!
doubleClickOnGroup

	self selectedGroup 
		ifNil: [ ^self ]
		ifNotNil:[:group | self model class openOnGroup: group ]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/28/2011 18:58'!
doubleClickOnPackage

	self selectedPackage
		ifNil: [ ^ self ]
		ifNotNil:[:package | self model class openOnPackage: package ]! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/31/2011 14:07'!
elementsMenu: aBuilder
	<nautilusMethodMenu>	

	self selectedMethod ifNil: [ ^ self ].
	
	(aBuilder item: #'Senders of...(n)')
		action: [ self browseSendersOfMessages ];
		order: 1000;
		enabledBlock: [ self enableTreeSingleSelection ].
		
	(aBuilder item: #'Implementors of... (m)')
		action: [ self browseMessages ];
		order: 1100;
		enabledBlock: [ self enableTreeSingleSelection ].
		
	(aBuilder item: #'Inheritance (i)')
		action: [ self methodHierarchy ];
		order: 1200;
		enabledBlock: [ self enableTreeSingleSelection ].
		
	(aBuilder item: #'Versions (v)')
		action: [ self browseVersions ];
		order: 1300;
		enabledBlock: [ self enableTreeSingleSelection ];
		withSeparatorAfter.
	
	(aBuilder item: #'Categorize method (C)')
		action: [ self categorizeMethod ];
		order: 1400.
		
	(aBuilder item: #'Move to package...')
		action: [ self moveMethodToPackage ];
		order: 1500.
		
	(aBuilder item: #'Remove... (x)')
		action: [ self removeCategoriesOrMethods ];
		order: 1600;
		icon: (self iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
	(aBuilder item: #'File Out')
		action: [ self fileOutMethods ];
		order: 1700
	! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/31/2011 13:33'!
elementsMenu: aMenu shifted: b

	^ aMenu becomeForward: (self methodMenuBuilder menu)! !

!NautilusUI methodsFor: 'menus extensions' stamp: 'BenjaminVanRyseghem 3/21/2011 14:20'!
elementsRefactoringMenu: aMenu shifted: b! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/28/2011 16:48'!
enableMultipleMenuItems

	^ self selectedItems size > 1! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/28/2011 16:48'!
enableSingleMenuItems

	^ self selectedItems size <= 1! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/29/2011 16:06'!
enableTreeMultipleSelection

	^ self isTreeSelectionMultiple! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/29/2011 16:06'!
enableTreeSingleSelection

	^ self isTreeSelectionMultiple not! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:50'!
fileOutClass
	"Print a description of the selected class onto a file whose name is the 
	category name followed by .st."

	self fileOutClasses: self selectedClasses! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:50'!
fileOutMethods

	self fileOutMethods: self selectedTreeMethods! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:52'!
fileOutPackage

	self fileOutPackages: self selectedPackage! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/4/2011 14:26'!
findClass
	"Search for a class from a pattern or from the recent list"
	| pattern recentList |
	self okToChange ifFalse: [^ self flashPackage ].
	recentList := self model recentClasses elements intersection: self model classes.
	recentList size == 0
		ifTrue: [pattern := UIManager default request: 'Class name or fragment?']
		ifFalse: [pattern := UIManager default 
				enterOrRequestFrom: recentList 
				lines: #() 
				title: 'Class name or fragment?'].
	pattern isBehavior
		ifTrue: [
			self showInstance: pattern isMeta not.
			self selectedPackage: pattern package.
			self selectedClass: pattern]
		ifFalse:[
			pattern isEmptyOrNil ifTrue: [^ self flashPackage ].
			pattern := self systemNavigation classFromPattern: pattern withCaption: ''.
			pattern ifNil: [^ self flashPackage]].
	self showGroups: false.
	self selectedPackage: pattern package.
	self selectedClass: pattern.
	self updateBothView! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/14/2011 16:38'!
findMethod
	"Search for a method in the lookup of the selected class"

	| foundMethod class |
	self okToChange ifFalse: [^ self flashPackage ].

	foundMethod := self findMethodIn: self selectedClass.
	foundMethod ifNil: [^ self ].
	class := foundMethod methodClass.
	self showGroupsSilently: false.
 	self model package: class package class: class category: foundMethod category method: foundMethod.
	self showPackages ifFalse: [
		classesSelection removeAll.
		classesSelection at: class put: true ].
	self updateBothView.
	self update.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 12:58'!
findPackage

	"Search for a package from a pattern or from the recent list"
	| foundPackage packagesList |
	self okToChange ifFalse: [^ self flashPackage ].
	packagesList := (self model recentClasses elements collect: [:each | each package name]) asSet asArray sort.

	foundPackage := self findPackageIn: packagesList.

	self selectedPackage = foundPackage ifTrue: [ ^ self ].
	
	self selectedPackage: foundPackage.
	self selectedClass: nil.
	self updatePackageView.
! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 14:43'!
flashPackage

	"self 
		ifPackages: [ list flash ]
		ifClasses: [ list2 flash ]"! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 4/11/2011 12:43'!
forceSelectedMethod: aMethod 

	 | category |
	category := nil.
	aMethod ifNotNil: [ category := aMethod category ].
	
	self model package: self selectedPackage class: self selectedClass category: category method: aMethod.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
foundPackageOf: aClass

	aClass ifNil: [^ nil].
	^ aClass package! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/30/2011 16:27'!
fullBrowse

	self model class 
		openOnPackage: self selectedPackage
		class: self selectedClass
		category: self selectedCategory
		method: self selectedMethod
		group: self selectedGroup
		showGroups: self showGroups
		showHierarchy: self showHierarchy
		showPackages: self showPackages
		showComment: self showComment 
		showInstance: self showInstance 
		showCategories: self getSwitch
! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 14:33'!
getClassHierarchy

	self hierarchyClass
		ifNil: [^self getClassesList].

	^ cachedHierarchy collect: [:each | each key ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/26/2011 01:15'!
getClassHierarchy2

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil:[:package |
			cachedHierarchy := self buildPackageHierarchyFor: package.
			cachedHierarchy collect: [:each | each key ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 14:33'!
getClassesList

	^ self model classes! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassesList2

	^ self model packagesUsedByTheSelectedClass! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/2/2011 11:09'!
getComments

	^ self selectedClass
		ifNil: [
			self selectedPackage
				ifNil: [ '' ]
				ifNotNil: [:package | '' "package comment" ]]
		ifNotNil: [:class | class comment ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getGroupHierarchy

	^ self selectedGroup 
		ifNil: [^ {}]
		ifNotNil: [:group |
			cachedHierarchy := self buildGroupHierarchyFor: group.
			cachedHierarchy collect: [:assoc | assoc key] ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
getGroupsKeyList

	^ self groupsManager groups! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 14:10'!
getGroupsValuesList

	^ self selectedGroup 
		ifNil: [{}]
		ifNotNil: [:group | group elements ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:25'!
getList
	
	^ self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					cachedHierarchy
						ifNil: [ self getClassHierarchy ]
						ifNotNil: [:col | col collect: [:assoc | assoc key]]]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:25'!
getList2

	^ self 
		ifGroups: [
			self showHierarchy
				ifTrue: [ self getGroupHierarchy ]
				ifFalse: [ self getGroupsValuesList ]]
		ifNot: [
			 self 
				ifPackages: [
					self showHierarchy
						ifTrue: [ self getClassHierarchy2 ]
						ifFalse: [ self getPackagesList2 ]]
				ifClasses: [self getClassesList2 ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/27/2011 20:27'!
getPackagesList

	^ self model packages reverse sort: [:a :b | a name first = $_ ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getPackagesList2

	^ self model classesInTheSelectedPackage! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2011 14:43'!
getRawList
	
	^ self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					cachedHierarchy
						ifNil: [ self getClassHierarchy ]
						ifNotNil: [:col | col collect: [:assoc | assoc key]]]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 14:13'!
getRawList2

	self showPackages
		ifTrue: [
			cachedHierarchy
				ifNotNil:[:col | ^col collect: [:each | each key]]]
		ifFalse: [
			^ self 
				ifGroups: [ self getGroupsValuesList ]
				ifNot: [
					 self 
						ifPackages: [self getPackagesList2 ]
						ifClasses: [self getClassesList2 ]]]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
getSwitch 

	^ self model showCategories! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 4/5/2011 15:11'!
groupFixPragma

	^'nautilusGroupFixMenu'! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 4/12/2011 16:35'!
groupIconFor: aGroup

	^  IconicButton new 
		target: self;
		actionSelector: #restrictedBrowseGroup:;
		arguments: {{aGroup}};
		labelGraphic: (self iconClass iconNamed: #groupIcon);
		color: Color transparent;
		extent: 15 @ 16;
		borderWidth: 0! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 4/5/2011 15:12'!
groupMenuBuilder

	^NautilusPragmaMenuBuilder withAllPragmaKeywords: {self groupFixPragma. self groupPragma} model: self! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 03:03'!
groupPragma

	^'nautilusGroupMenu'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonAction

	self toogleShowGroups! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 17:04'!
groupsButtonLabel

	^ 
		self showGroups
			ifTrue: [ self packageLabel ]
			ifFalse: [ self groupsLabel ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonState

	^ self showGroups! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/11/2011 16:57'!
groupsFixMenu: aBuilder
	<nautilusGroupFixMenu>

	(aBuilder item: #'Find Class... (f)')
		action: [self findClass];
		order: 0;
		help: 'Search for a class by name';
		withSeparatorAfter.
	
	(aBuilder item: #'Browse full (b)')
		action: [self fullBrowse];
		order: 999.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2011 09:57'!
groupsLabel

	^ 'Groups'! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:52'!
groupsManager

	^ self model groupsManager! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/11/2011 16:57'!
groupsMenu: aBuilder
	<nautilusGroupMenu>

	self selectedGroup ifNil: [ ^ self ].
		
	(aBuilder item: #'Browse restricted (B)')
		action: [ self restrictedBrowseGroup: self selectedGroups ];
		order: 1000;
		withSeparatorAfter.
		
	(aBuilder item: #'Merge groups')
		action: [self mergeGroups];
		enabledBlock: [ self selectedGroups size > 1];
		order: 1100.

	self selectedGroup isNil
		ifFalse: [
			self selectedGroup isReadOnly
				ifFalse: [
					(aBuilder item: #'Rename... (r)')
						action: [self renameGroup];
						enabledBlock: [ self selectedGroups size <= 1];
						order: 1200 ].
			self selectedGroup removable
				ifTrue: [
					(aBuilder item: #'Remove... (x)')
						icon: (self iconClass iconNamed: #removeIcon);
						action: [self removeGroup];
						order: 1200 ]]! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 4/11/2011 18:49'!
groupsMenu: aMenu shifted: aBoolean 
	" Morphic's menus are filled up when pragma's one are returned from a method, so I have to substitute the morphic menu by the pragma one "
	
	^ aMenu becomeForward: (self groupMenuBuilder menu)! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
hierarchyClass

	^ hierarchyClass! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
hierarchyClass: aClass

	hierarchyClass := aClass.
	cachedHierarchy := self buildHierarchyFor: aClass.! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/30/2011 11:18'!
iconClass

	^ NautilusIcons! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
ifGroups: aBlock ifNot: anotherBlock

	^self showGroups
			ifTrue: aBlock
			ifFalse: anotherBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
ifPackages: pBlock ifClasses: cBlock

	^ self showPackages
		ifTrue: pBlock
		ifFalse: cBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/14/2011 13:05'!
initialize

	super initialize.
	cachedHierarchy := OrderedCollection new.
	groupsSelection := Dictionary new.
	packagesSelection := Dictionary new.
	classesSelection := Dictionary new.
	
	self registerToAnnouncements! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceButtonAction

	self toogleShowInstance! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 18:43'!
instanceButtonLabel

	^ self showInstance
		ifTrue: [ self classLabel ]
		ifFalse: [ self instanceLabel ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 18:45'!
instanceButtonState

	^ false! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceLabel

	^'Instance'! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/13/2011 12:00'!
isAClassSelected

	^ self selectedClass notNil! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/29/2011 16:04'!
isTreeSelectionMultiple

	^ self selectedTreeItems size > 1! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 4/11/2011 16:42'!
keyPressedOnCategory: anEvent

	anEvent keyCharacter == $b
		ifTrue: [ ^ self fullBrowse ].
		
	anEvent keyCharacter == $f
		ifTrue: [ ^ self findMethod ].
		
	anEvent keyCharacter == $n
		ifTrue: [ ^ self addCategory ].
			
	(anEvent keyCharacter == $r and:[ self enableTreeSingleSelection ])
		ifTrue: [ ^ self renameCategory ].
		
	anEvent keyCharacter == $x
		ifTrue: [ ^ self removeCategoriesOrMethods ].
	! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 4/11/2011 16:42'!
keyPressedOnElement: anEvent

	anEvent keyCharacter == $b
		ifTrue: [ ^ self fullBrowse ].
		
	anEvent keyCharacter == $f
		ifTrue: [ ^ self findMethod ].
		
	(anEvent keyCharacter == $n and:[ self enableTreeSingleSelection ])
		ifTrue: [ ^ self browseSendersOfMessages ].
		
	(anEvent keyCharacter == $m and:[ self enableTreeSingleSelection ])
		ifTrue: [ ^ self browseMessages ].
		
	(anEvent keyCharacter == $i and:[ self enableTreeSingleSelection ])
		ifTrue: [ ^ self methodHierarchy ].
		
	(anEvent keyCharacter == $v and:[ self enableTreeSingleSelection ])
		ifTrue: [ ^ self browseVersions ].
		
	anEvent keyCharacter == $C
		ifTrue: [ ^ self categorizeMethod ].
		
	anEvent keyCharacter == $x
		ifTrue: [ ^ self removeCategoriesOrMethods ].! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 01:07'!
labelText

	^ self showGroups
		ifTrue: [ 'Groups:']
		ifFalse: [self ifPackages: ['Packages:'] ifClasses: ['Classes:']]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
labelText2

	^ self ifPackages: ['Classes:'] ifClasses: ['Packages:']! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/30/2011 11:20'!
listIcon2: anItem

	^ self 
		ifPackages: [ self classIconFor: anItem ]
		ifClasses: [ self packageIconFor: anItem ]! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 4/12/2011 15:54'!
listIcon: anItem
	" I return the icon corresponding to anItem in the leftmost list "


	^ self showGroups
		ifTrue: [ self groupIconFor: anItem ]
		ifFalse: [
			" if I do not show groups, I have to know if I show packages or classes "
			self 
				ifPackages: [ self packageIconFor: anItem ]
				ifClasses: [ self classIconFor: anItem ]]! !

!NautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 3/30/2011 16:37'!
listSelection

	^ self showGroups
		ifTrue: [ groupsSelection ]
		ifFalse: [
			self
				ifPackages: [ packagesSelection ]
				ifClasses: [ classesSelection  ]]! !

!NautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 3/31/2011 22:33'!
listSelection2

	^ self
		ifPackages: [ classesSelection ]
		ifClasses: [ packagesSelection ]! !

!NautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 4/4/2011 17:05'!
listSelection2At: anIndex

	| elt |
	elt := self getRawList2 at: anIndex ifAbsent: [nil].
	elt ifNil: [^false].
	^ self listSelection2 at: elt ifAbsent: [ false ]! !

!NautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 3/31/2011 22:33'!
listSelection2At: anIndex put: aBoolean

	| elt |
	elt := self getRawList2 at: anIndex.
	self listSelection2 at: elt put: aBoolean.
	self changed: #hasSelectedSelections! !

!NautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 3/30/2011 17:16'!
listSelectionAt: anIndex

	| elt |
	elt := self getRawList at: anIndex.
	^ self listSelection at: elt ifAbsent: [ false ]! !

!NautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 3/30/2011 17:17'!
listSelectionAt: anIndex put: aBoolean

	| elt |
	elt := self getRawList at: anIndex.
	self listSelection at: elt put: aBoolean.
	self changed: #hasSelectedSelections! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 13:59'!
listWrapper2: anElement

	^ self 
		ifPackages:	[
			"anElement is a Class"
			self showHierarchy
				ifTrue: [ self buildTabbedNameOf: anElement ]
				ifFalse: [
					self selectedPackage 
						ifNil: [ anElement name ]
						ifNotNil: [:package | 
							(package extendedClasses includes: anElement)
								ifTrue: [ '*', anElement name ]
								ifFalse: [ anElement name ]]]]
		ifClasses: [
			"anElement is a RPackage"
			(self selectedClass package == anElement)
				ifTrue: [anElement name]
				ifFalse: ['*', anElement name]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/22/2011 14:17'!
listWrapper: anElement

	anElement = 0 ifTrue: [^''].
	^ self 
		ifGroups: [ anElement name ]
		ifNot: [ self 
				ifPackages: [ anElement name  ] 
				ifClasses: [ self buildTabbedNameOf: anElement ]]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/14/2011 14:46'!
mcPackageModified: anAnnouncement
	" handled when a package become dirty "
	
	| rpackage |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	rpackage := anAnnouncement package correspondingRPackage.
	(self model packages includes: rpackage )
		ifTrue: [ self updatePackageView ]! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/21/2011 15:11'!
menu2: aMenu shifted: aBoolean 
	self
		ifPackages: [self classesMenu: aMenu shifted: aBoolean]
		ifClasses: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]].
	^ aMenu! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/21/2011 15:11'!
menu: aMenu shifted: aBoolean 
	self
		ifPackages: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]]
		ifClasses: [self classesMenu: aMenu shifted: aBoolean].
	^ aMenu! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 13:00'!
mergeGroups

	| group |
	group := self mergeGroups: self selectedGroups.
	group
		ifNotNil: [ 
			self groupsManager addAGroup: group.
			self selectedGroup: group.
			self updateBothView]
! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/11/2011 17:56'!
methodAdded: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
		
	(anAnnouncement item methodClass = self selectedClass)
		ifTrue: [ self update ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 13:01'!
methodHierarchy
	"Create and schedule a method browser on the hierarchy of implementors."

	self methodHierarchyFrom: self selectedMethod! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 4/7/2011 18:51'!
methodIconFor: aMethod

	aMethod containsHalt
		ifTrue: [ ^ self iconClass iconNamed: #breakpoint ].
		
	aMethod containsFlag
		ifTrue: [ ^ self iconClass iconNamed: #flag ].
		
	aMethod isTestMethod
		ifTrue: [| icon |
			icon :=  self iconClass iconNamed: #testNotRun.

			aMethod hasPassedTest
				ifTrue: [	icon :=  self iconClass iconNamed: #testGreen ].

			aMethod hasFailedTest
				ifTrue: [	icon :=  self iconClass iconNamed: #testYellow ].

			aMethod hasErrorTest
				ifTrue: [	icon :=  self iconClass iconNamed: #testRed ].
			^ IconicButton new 
						target: self;
						actionSelector: #runTestFor:;
						arguments: { aMethod };
						labelGraphic: icon ;
						color: Color transparent;
						extent: 12 @ 12;
						borderWidth: 0 ].
		
	aMethod correspondingTestMethod
		ifNotNil: [:testMethod || icon |
			icon :=  self iconClass iconNamed: #testNotRun.

			testMethod hasPassedTest
				ifTrue: [	icon :=  self iconClass iconNamed: #testGreen ].

			testMethod hasFailedTest
				ifTrue: [	icon :=  self iconClass iconNamed: #testYellow ].

			testMethod hasErrorTest
				ifTrue: [	icon :=  self iconClass iconNamed: #testRed ].
			^ IconicButton new 
						target: self;
						actionSelector: #runTestFor:;
						arguments: { aMethod };
						labelGraphic: icon ;
						color: Color transparent;
						extent: 12 @ 12;
						borderWidth: 0 ].	
						
		

	aMethod isOverride
		ifTrue: [ 
			aMethod isOverriden
				ifTrue: [ ^ self buildUpAndDownArrowIcon: aMethod ]
				ifFalse:[	^  IconicButton new 
								target: self;
								actionSelector: #arrowUp:;
								arguments: { aMethod };
								labelGraphic: (self iconClass iconNamed: #arrowUp);
								color: Color transparent;
								extent: 12 @ 12;
								borderWidth: 0 ]].
	aMethod isOverriden
				ifTrue: [ ^ IconicButton new 
								target: self;
								actionSelector: #arrowDown:;
								arguments: { aMethod };
								labelGraphic: (self iconClass iconNamed: #arrowDown);
								color: Color transparent;
								extent: 12 @ 12;
								borderWidth: 0 ].
							
	^ self iconClass iconNamed: #blank.! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 13:49'!
methodMenuBuilder

	^ NautilusPragmaMenuBuilder withAllPragmaKeywords: {self commonPragma. self methodPragma} model: self! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/11/2011 17:30'!
methodModified: anAnnouncement 

	window isNil ifTrue: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].

	( anAnnouncement itemClass = self selectedClass )
		ifTrue: [ 
			self selectedMethod = anAnnouncement oldItem
				ifTrue: [ 
					sourceTextArea hasUnacceptedEdits
						ifTrue: [ | sourceCode |
							sourceCode := sourceTextArea text.
							self forceSelectedMethod: (anAnnouncement item).
							self update.
							sourceTextArea setText: sourceCode.
							sourceTextArea hasEditingConflicts: true.
							sourceTextArea update: #codeChangedElsewhere ]
						ifFalse: [ 
							self selectedMethod: (anAnnouncement item).
							self update ]]]! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 13:17'!
methodPragma

	^'nautilusMethodMenu'! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/11/2011 19:27'!
methodRecategorized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
		
	(anAnnouncement item methodClass = self selectedClass)
		ifTrue: [ self update ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/11/2011 17:43'!
methodRemoved: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
		
	(anAnnouncement item methodClass = self selectedClass)
		ifTrue: [ 
			self selectedMethod = anAnnouncement item
				ifTrue: [ self selectedMethod: nil ].
			self update ]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 4/6/2011 15:19'!
methodWrapper: anItem

	^ anItem selector! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
methodsButtonLabel

	^ 'Switch to categories'! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/7/2011 15:58'!
methodsForCategory: aCategory

	self selectedClass ifNil: [ ^ {} ].
	^ (self selectedClass organization listAtCategoryNamed: aCategory) collect: [:each | self selectedClass methodDict at: each ]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/21/2011 18:46'!
methodsLabel

	^ self showInstance
		ifTrue: ['Instance methods']
		ifFalse: ['Class methods']! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/26/2011 13:23'!
methodsTree
	
	^ methodsTree! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
model

	^ model! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
model: anObject

	model := anObject! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/25/2011 23:21'!
move: item from: oldCategory to: newCategory isCopy: isCopy

	isCopy
		ifFalse: [
			item methodClass organization
				classify: item selector
				under: newCategory 
				suppressIfDefault: true.
			self selectedMethod: item ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/14/2011 16:30'!
moveInNewPackage

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| item |
	self okToChange ifFalse: [^ self].

	item := self moveInNewPackage: self selectedClasses.

	self selectedPackage: item.
	self updateBothView! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 13:08'!
moveMethodToPackage
	"Search for a package from a pattern or from the recent list"	
	
	| packagesList  |	
	self okToChange ifFalse: [^ self flashPackage ].
	packagesList := self model packages collect: [:each | each name ].
	
	self moveMethodsToPackage: self selectedTreeMethods in: packagesList  from: self selectedPackage.

	self update.
		
! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/14/2011 17:46'!
newMCVersion: anAnnouncement

	| rpackage |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	rpackage := anAnnouncement version package correspondingRPackage.
	rpackage ifNil: [ ^ self ].
	( self model packages includes: rpackage )
		ifTrue: [ self updatePackageView ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 23:28'!
noMethodsString

	^ ClassOrganizer nullCategory! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/2/2011 15:16'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits
! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 4/12/2011 16:07'!
open

	window := NautilusWindow new model: self.
	self addAll: window.
	window openInWorld.
	self setWindowTitle! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/5/2011 15:19'!
packageChanged: anAnnouncement

	window isDisplayed ifFalse: [ ^ self ].

	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/11/2011 18:59'!
packageCreated: anAnnouncement

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 4/5/2011 15:12'!
packageFixPragma

	^ 'nautilusPackageFixMenu'! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 4/7/2011 15:26'!
packageIconFor: aPackage

	aPackage classes isEmpty ifTrue: [^ self iconClass iconNamed: #emptyPackageIcon ].
	
	aPackage isDirty
		ifTrue: [ ^ IconicButton new 
						target: self;
						actionSelector: #saveDirtyPackages:;
						arguments: {{ aPackage }};
						labelGraphic: (self iconClass iconNamed: #dirtyPackageIcon);
						color: Color transparent;
						extent: 15 @ 16;
						borderWidth: 0 ].

	^ self iconClass iconNamed: #packageIcon! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 17:05'!
packageLabel

	^'Packages'! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 4/5/2011 15:12'!
packageMenuBuilder

	^ NautilusPragmaMenuBuilder withAllPragmaKeywords: {self packageFixPragma. self packagePragma} model: self! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 00:46'!
packagePragma

	^ 'nautilusPackageMenu'! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/1/2011 17:09'!
packageRenamed: anAnnouncement

	window isDisplayed ifFalse: [ ^ self ].
	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/6/2011 18:53'!
packageUnregistred: anAnnouncement

	self showGroups not
		ifTrue: [ | package |
			package := anAnnouncement package.
			self selectedPackage = package
				ifTrue: [ self selectedPackage: nil ].
			packagesSelection at: package put: false.
			window isDisplayed ifFalse: [ ^ self ].
			self updatePackageView ]! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/11/2011 16:57'!
packagesFixMenu: aBuilder
	<nautilusPackageFixMenu>

	(aBuilder item: #'Find Class... (f)')
		action: [self findClass];
		order: 0;
		help: 'Search for a class by name'.
		
	(aBuilder item: #'Find Package... (F)')
		action: [ self findPackage ];
		order: 100;
		help: 'Search for a package by name';
		withSeparatorAfter.
		
	(aBuilder item: #'Add package... (n)')
		action: [self addPackage];
		order: 200;
		help: 'Add a package';
		withSeparatorAfter.
		
	(aBuilder item: #'Browse full (b)')
		action: [self fullBrowse];
		order: 999;
		help: 'Open the same browser'.! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 4/11/2011 16:58'!
packagesMenu: aBuilder
	<nautilusPackageMenu>

	self selectedPackage ifNil: [ ^ self ].
	
	(aBuilder item: #'Browse restricted (B)')
		action: [self restrictedBrowsePackage];
		order: 1000;
		help: 'Open a browser on a restricted view';
		withSeparatorAfter.
				
	(aBuilder item: #'Rename... (r)')
		action: [self renamePackage];
		order: 1100;
		help: 'Rename a package';
		enabledBlock: [ self selectedPackages size = 1 ].
		
	(aBuilder item: #'Remove... (x)')
		action: [self removePackage];
		order: 1200;
		help: 'Remove a package';
		icon: (self iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
	(aBuilder item: #'File Out')
		action: [self fileOutPackage];
		order: 1300;
		help: 'File out a package';
		withSeparatorAfter.
		
	(aBuilder item: #'Add as Group & Browse (g)')
		action: [self addPackageAsGroupAndBrowse];
		order: 1400;
		help: 'Create a group based on the current package and browse it'.
		
	(aBuilder item: #'Add as Group (G)')
		action: [self addPackageAsGroup];
		order: 1500;
		help: 'Create a group based on the current package'.
		
	(aBuilder item: #'Add in Group... (e)')
		action: [self addPackageInGroup];
		order: 1600;
		help: 'Add current package in a group'.! !

!NautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 3/31/2011 01:15'!
packagesMenu: aMenu shifted: aBoolean 

	^ aMenu becomeForward: (self packageMenuBuilder menu)! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/3/2011 14:08'!
putSourceTextAreaLimit

	sourceTextArea ifNotNil: [ sourceTextArea warningLimit: sourceTextAreaLimit ]! !

!NautilusUI methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 5/3/2011 14:07'!
registerToAnnouncements

	SystemAnnouncer announcer weak
		on: RPackageCreated send: #packageCreated: to: self;"
		on: RPackageUnregistred send: #packageUnregistred: to: self;"
		on: RPackageRenamed send: #packageRenamed: to: self;
	
		on: SystemClassAddedAnnouncement send: #classAdded: to: self;
		on: SystemClassCommentedAnnouncement send: #classCommented: to: self;
		on: SystemClassRecategorizedAnnouncement send: #classRecategorized: to: self;
		on: SystemClassRemovedAnnouncement send: #classRemoved: to: self;
		on: SystemClassRenamedAnnouncement send: #classRenamed: to: self;
		on: SystemClassReorganizedAnnouncement send: #classReorganized: to: self;
		
		on: SystemMethodAddedAnnouncement send: #methodAdded: to: self;
		on: SystemMethodModifiedAnnouncement send: #methodModified: to: self;
		on: SystemMethodRecategorizedAnnouncement send: #methodRecategorized: to: self;
		on: SystemMethodRemovedAnnouncement send: #methodRemoved: to: self;
		
		on: SystemProtocolAddedAnnouncement send: #classRecategorized: to: self;
		on: SystemProtocolRemovedAnnouncement send: #classRecategorized: to: self.

"	TestAnnouncer announcer weak
		on: ATestHasBeenRan send: #testRunned: to: self."
		
	MonticelloAnnouncer announcer weak	
		on: AMCVersionHasBeenCreated send: #newMCVersion: to: self;
		on: AMCPackageHasBeenModified send: #mcPackageModified: to: self.
		
	GroupAnnouncer announcer weak
		on: AGroupHasBeenRegistered send: #aGroupHasBeenRegistered: to: self;
		on: AGroupHasBeenUnregistered send: #aGroupHasBeenUnregistered to: self;
		on: AGroupHasBeenAdded send: #aGroupHasBeenAdded: to: self;
		on: AGroupHasBeenRemoved send: #aGroupHasBeenRemoved: to: self;
		on: AGroupHasBeenRenamed send: #aGroupHasBeenRenamed: to: self! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/30/2011 18:28'!
removeCategoriesOrMethods

	self selectedClass 
		ifNotNil: [:class |
			self selectedTreeItems 
				ifNotEmpty: [:items || removeACategory removeAMethod |
					removeACategory := false.
					removeAMethod := false.
					items do: [:item || needToUpdate |
						needToUpdate := item isCompiledMethod
								ifTrue: [ | b | 
									b := self removeMethod: item inClass: class.
									(b and: [ removeACategory not ]) ifTrue: [ removeACategory := true].
									b]
								ifFalse:[ | b |
									b := self removeCategory: item inClass: class.
									(b and: [ removeAMethod not ]) ifTrue: [ removeAMethod := true].
									b ].
						needToUpdate ifTrue: [ self update ]].
					
					removeAMethod ifTrue: [ self selectedMethod: nil ].
					removeACategory ifTrue: [ self selectedCategory: nil ].
					self update ]]
! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/24/2011 15:16'!
removeClassFromGroup

	self groupsManager remove: self selectedClass from: self selectedGroup.
	self updateClassView.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/14/2011 17:12'!
removeClasses
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	| result |
	self okToChange ifFalse: [^ false].
	result := self removeClasses: self selectedClasses.
	result
		ifTrue: [	
		classesSelection removeAll.
		self selectedClass: nil ].
	^ result! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 13:10'!
removeEmptyCategories

	self okToChange ifFalse: [^ self].
	(self methodsForCategory: self selectedCategory) 
		ifEmpty: [ self selectedCategory: nil ].
		
	self removeEmptyCategoriesFrom: self selectedClass.
	
	self update.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/14/2011 17:14'!
removeGroup

	self okToChange ifFalse: [ ^ self ].
	self selectedGroups
		ifNotEmpty:[:groups |
			groupsSelection removeAll.
			groups do: [:group | self groupsManager removeAGroup: group ].
			self selectedGroup: nil].
		! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 13:12'!
removeMethod: aMethod inClass: aClass
	"If a message is selected, create a Confirmer so the user can verify that  
	the currently selected message should be removed from the system. If 
	so, remove it. "

	self okToChange ifFalse: [^ false].
	^ super removeMethod: aMethod inClass: aClass! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 13:13'!
removeNonLocalSelector: aSymbol

	self selectedClass ifNotNil: [:class | self removeNonLocalSelector: aSymbol from: class ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/31/2011 02:49'!
removePackage

	| names |
	self selectedPackages 
		ifNotEmpty: [:packages |
			names := packages collect: [:package | package name ].
			names := names joinUsing: String cr.
			(UIManager default confirm: ('Are you sure you want to delete the package(s) named ', String cr, names, ' ?'))
				ifTrue: [
					packages do: [:package |
						self browsedEnvironment packageOrganizer unregisterPackage: package].
					self selectedPackage: nil.
					self updatePackageView]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/3/2011 14:08'!
removeSourceTextAreaLimit

	sourceTextArea ifNotNil: [ sourceTextArea warningLimit: -1 ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 13:21'!
renameCategory
	"Prompt for a new category name and add it before the
	current selection, or at the end if no current selection"

	| newName |	
	self okToChange ifFalse: [^ self].

	newName := self renameCategory: self selectedCategory from: self selectedClass.
	
	self selectedCategory: newName.
	self update.
	methodsTree setSelectedNodeItem: newName.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 16:06'!
renameClass

	self okToChange ifFalse: [ ^ self ].
	self renameClass: self selectedClass.
	self changed: #sourceCode.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/30/2011 15:57'!
renameGroup

	| newName |
	self groupsManager renameAGroup: self selectedGroup.
	self updateBothView! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 16:08'!
renamePackage

	self renamePackages: self selectedPackages.
	self updatePackageView.
	! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/31/2011 22:37'!
resetListSelection

	self listSelection removeAll.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/31/2011 22:37'!
resetListSelection2

	self listSelection2 removeAll.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:58'!
restrictedBrowseClass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil:[:class || newEnvironment |
			newEnvironment := self browsedEnvironment forClasses: {class}.
			 self model class openOnClass: class inEnvironment: newEnvironment ]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/31/2011 14:51'!
restrictedBrowseGroup: aCollection

	aCollection
		ifNotEmpty: [:groups || elements newEnvironment |
			elements := groups gather: [:group | group elements].
			newEnvironment := self browsedEnvironment forClasses: elements.
			self model class openOnGroup: groups first inEnvironment: newEnvironment ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/31/2011 02:49'!
restrictedBrowsePackage

	self selectedPackages
		ifEmpty: [ ^ self ]
		ifNotEmpty: [:packages || newEnvironment |
			newEnvironment := self browsedEnvironment forPackages: packages.
			 self model class openOnPackage: self selectedPackage inEnvironment: newEnvironment ]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 4/7/2011 14:34'!
roots
		
	self selectedClass ifNil: [^ {} ].
	^ self getSwitch
		ifTrue: [ self selectedClass organization categories copy sort ]
		ifFalse: [ self selectedClass methodDict values sort: [:a :b | a selector <= b selector ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:29'!
rootsOf: aPackage

	| list |
	self browsedEnvironment isSystem
		ifTrue: [ list := aPackage definedClasses ]
		ifFalse: [ list := self model classes intersection: aPackage definedClasses ].
		
	^ list select: [:each |
		(list includes: each superclass)  not]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 13:22'!
rootsOfGroup: aGroup

	| classes |
	self browsedEnvironment isSystem
		ifTrue: [ classes := aGroup elements ]
		ifFalse: [ classes := aGroup elements intersection: self model classes ].
	
	^ classes select: [:each |
		(classes includes: each superclass)  not]! !

!NautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 4/7/2011 18:06'!
runTestFor: aMethod

	| testMethod testClass testResult |

	testMethod := aMethod correspondingTestMethod.
	testClass := aMethod methodClass correspondingTestClass.
	testResult := testClass run: testMethod selector.
	
	testResult updateResultsInHistory
	
	"#(failures errors passed) do:[:symbol |
		(testClass history at: symbol) addAll: ( (testResult perform: symbol) collect: [:each | each selector ])]."! !

!NautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 4/7/2011 17:07'!
saveDirtyPackages: aCollection 
	
	
	aCollection isEmptyOrNil ifTrue: [ ^ self ].
	aCollection do: [:package || workCopy browser wrap index |
		
		workCopy := MCWorkingCopy forPackage: (MCPackage named: package name).
		browser :=MCWorkingCopyBrowser new.
		browser
			show;
			workingCopy: workCopy.
		"wrap := MCDependentsWrapper with: workCopy model: browser.
		self halt.
		index := browser workingCopySelectionWrapper: wrap.
		browser workingCopyTreeMorph selectionIndex: index"]
	! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 16:25'!
selected

	| item |
	item :=  self 
				ifGroups: [ self selectedGroup ]
				ifNot: [ self ifPackages: [ self selectedPackage ] ifClasses: [ self selectedClass ]].
				
	^self getList indexOf: item.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/7/2011 18:08'!
selected2

	| item |
	item :=  self 
		ifPackages: [ | tmp |
			tmp := self selectedClass.
			self showInstance ifFalse: [ tmp ifNotNil: [tmp := tmp theNonMetaClass]].
			tmp ] 
		ifClasses: [ self selectedPackage ].
	.
	^self getRawList2 indexOf: item.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 15:39'!
selected2: anInteger

	| selection |
	selection := self getRawList2 at: anInteger ifAbsent: [nil].
	self 
		ifPackages: [ 
			self showInstance ifFalse: [selection ifNotNil: [selection := selection class]].
			self selectedClassWithoutChangingSelection: selection ] 
		ifClasses: [	self selectedPackageWithoutChangingSelection: selection ].
	self changed: #selected2.
	self showAnnotationPane
		ifTrue: [ self changed: #contents ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:51'!
selected: anInteger

	| selection |
	
	selection := self getList at: anInteger ifAbsent: [nil].
	self 
		ifGroups: [ self selectedGroupWithoutChangingSelection: selection ]
		ifNot: [ 
			self 
				ifPackages: [ self selectedPackageWithoutChangingSelection: selection] 
				ifClasses: [ 
					self showInstance ifFalse: [selection ifNotNil: [selection := selection class]].
					self selectedClassWithoutChangingSelection: selection] ].

	self changed: #selected.! !

!NautilusUI methodsFor: 'SmalltalkEditor compatibility' stamp: 'BenjaminVanRyseghem 4/14/2011 14:03'!
selectedBehavior

	^ self selectedClass! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/26/2011 00:37'!
selectedCategory

	^ self model selectedCategory! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 4/11/2011 11:01'!
selectedCategory: anObject

	self okToChange
		ifTrue: [
			self model package: self selectedPackage class: self selectedClass category: anObject method: nil.
			self changed: #sourceCode.
			^ true].
	^ false! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 14:52'!
selectedClass

	| class |
	class := self model selectedClass.
	self selectedCategory
		ifNil: [ self setStylerClass: nil ]
		ifNotNil: [ self setStylerClass: class ].
	^ class! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:36'!
selectedClass: aClass 

	self okToChange
		ifTrue: [
			classesSelection removeAll.
			classesSelection at: aClass put: true.
			self selectedClassWithoutChangingSelection: aClass ]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 07:19'!
selectedClassComments

	^ self selectedClass
		ifNil: ['']
		ifNotNil: [:class| class comment]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 4/14/2011 16:49'!
selectedClassDescription

	^ self selectedClass definition! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:37'!
selectedClassWithoutChangingSelection: aClass 

	self okToChange
		ifTrue: [| package packageChanged |
			package := self selectedPackage.
			(self showPackages not or: [self showGroups ])
				ifTrue: [ aClass ifNotNil: [ package := aClass package ]].
			aClass 
				ifNil: [ classesSelection removeAll ].
			packageChanged := (package ~= self selectedPackage).
			self model package: package class: aClass category: nil method: nil.
			self setWindowTitle.
			
			packageChanged ifTrue: [
				packagesSelection removeAll.
				packagesSelection at: package put: true.
				self showGroups
					ifTrue: [ self updateClassView ]
					ifFalse: [ self updateBothView ]].
			
			self update.
			self changed: #isAClassSelected.
			self changed: #getComments.
			self changed: #sourceCode]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/31/2011 22:41'!
selectedClasses

	| associations |
	associations := classesSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedGroup
	
	^ self model selectedGroup! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 13:45'!
selectedGroup: anObject

	self okToChange
		ifTrue: [
			groupsSelection removeAll.
			groupsSelection at: anObject put: true.
			self selectedGroupWithoutChangingSelection: anObject ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 13:45'!
selectedGroupWithoutChangingSelection: anObject

	self okToChange
		ifTrue: [
			anObject ifNil: [ groupsSelection removeAll ].
			self model selectedGroup: anObject.
			self selectedClass: nil.
			self updateClassView ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/31/2011 02:54'!
selectedGroups

	| associations |
	associations := groupsSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/30/2011 17:25'!
selectedItems

	| associations |
	associations := self listSelection associations select: [:assoc | assoc value ].
	^ associations collect: [:assoc | assoc key ].! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 5/2/2011 15:30'!
selectedMethod

	^ self model selectedMethod ! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 5/2/2011 15:40'!
selectedMethod: aMethod 

	self okToChange
		ifTrue: [
			self forceSelectedMethod: aMethod.
			self setWindowTitle.
			
			self changed: #sourceCode.
			self showAnnotationPane
				ifTrue: [ self changed: #contents ].
			^ true].
	^false ! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedMethodComments

	^ self selectedMethod comment! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/3/2011 14:48'!
selectedMethodSource

	self selectedMethod
		ifNil: [ ^ '' ]
		ifNotNil: [:method |
			self showSource
				ifTrue: [ 
					self styled: true.
					^ method getSource ].
			self showByteCode
				ifTrue: [ 
					self styled: false.
					^ method symbolic asText].
			self showDecompile
				ifTrue: [ 
					self styled: false.
					^  method decompileWithTemps decompileString asText makeSelectorBoldIn: method methodClass ].
			^ 'error']			! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedPackage

	^ self model selectedPackage! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 13:44'!
selectedPackage: aPackage

	self okToChange
		ifTrue: [
			packagesSelection removeAll.
			packagesSelection at: aPackage put: true.
			self selectedPackageWithoutChangingSelection: aPackage]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 22:11'!
selectedPackageWithoutChangingSelection: aPackage

	self okToChange
		ifTrue: [| class |
			class := self selectedClass.
			(self showPackages and: [class notNil and: [class package ~= aPackage]])
				ifTrue: [ self selectedClass: nil ].
			self model package: aPackage class: self selectedClass category: nil method: nil.

			self updateClassView.
			self update.
			self changed: #getComments.
			self changed: #sourceCode]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/31/2011 02:54'!
selectedPackages

	| associations |
	associations := packagesSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/29/2011 16:03'!
selectedTreeItems

	^ self methodsTree selection selectedNodes collect: [:each | each item ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/29/2011 16:22'!
selectedTreeMethods

	| result |
	result := OrderedCollection new.
	self methodsTree selection selectedNodes do: [:each | 
		each isCategory
			ifTrue: [ result addAll: each childrenItems]
			ifFalse:[ result add: each item ]].
	^ result! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 17:11'!
setCachedHierarchy: aDict

	cachedHierarchy := aDict.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 17:11'!
setCachedHierarchyClass: aClass

	cachedHierarchy := self buildHierarchyFor: aClass.! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/2/2011 14:47'!
setStylerClass: aClass

	sourceTextArea
		ifNotNil: [ sourceTextArea stylerClassOrMetaClass: aClass ]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
setSwitch: aBoolean

	^ self model showCategories: aBoolean! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 4/1/2011 15:30'!
setWindowTitle

	| title |
	title := self selectedClass 
				ifNil: [ self title ]
				ifNotNil: [:class |
					self selectedMethod
						ifNil: [ class name asString ]
						ifNotNil: [:method |
							method methodClass name asString, '>>#', method selector ]].
	window title: title.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/2/2011 15:41'!
showAnnotationPane

	^ self model showAnnotationPane! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:45'!
showByteCode

	^ self currentDisplayChoice = self byteCodeSymbol! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showComment

	^ self model showComment! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/12/2011 15:02'!
showComment: aBoolean

	self model showComment: aBoolean.
	
	commentTextArea
		ifNil: [ self buildCommentPane ].
		
	aBoolean
		ifTrue: [ sourceCodePanel addMorph: commentTextArea ]
		ifFalse: [ sourceCodePanel removeMorph: commentTextArea ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 4/12/2011 17:48'!
showDecompile

	^ self currentDisplayChoice = self decompileSymbol! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showGroups

	^ self model showGroups! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/31/2011 22:39'!
showGroups: aBoolean

	self okToChange
		ifTrue: [
			self showPackages 
				ifFalse: [ self showPackagesSilently: true ].
			self selectedGroup
				ifNil: [ self selectedClass: nil ]
				ifNotNil: [:group |
					(group elements includes: self selectedClass)
						ifFalse: [ self selectedClass: nil ].
			aBoolean 
				ifTrue: [ groupsSelection at: group put: true ]
				ifFalse: [ packagesSelection at: self selectedPackage put: true ]].
			self model showGroups: aBoolean.
			self changed: #groupsButtonLabel.
			self changedLabels.
			self updateBothView ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:36'!
showGroupsSilently: aBoolean

	self model showGroups: aBoolean! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showHierarchy

	^ self model showHierarchy! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
showHierarchy: aBoolean

	self model showHierarchy: aBoolean.
	aBoolean 
		ifTrue: [self hierarchyClass: self selectedClass]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showInstance

	^ self model showInstance! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 16:48'!
showInstance: aBoolean

	self model showInstance: aBoolean.
	classesSelection removeAll.
	self selectedClass 
		ifNotNil: [:class | 
			aBoolean 
				ifTrue: [self selectedClass: class theNonMetaClass]
				ifFalse: [self selectedClass: class class]].
	self update.
	self changed: #instanceButtonLabel! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showPackages

	^ self model showPackages! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/7/2011 17:06'!
showPackages: aBoolean

	self okToChange
		ifTrue: [
			aBoolean
				ifFalse: [| class |
					class := self selectedClass.
					classesSelection at: class put: true.
					self hierarchyClass: class .
					self showGroups
						ifTrue: [self showGroupsSilently: false]].
			self model showPackages: aBoolean.
			self changed: #groupsButtonLabel.
			self updateBothView.
			self changed: #toogleButtonState.
			self changedLabels ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:35'!
showPackagesSilently: aBoolean

	self model showPackages: aBoolean.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:45'!
showSource

	^ self currentDisplayChoice = self sourceCodeSymbol! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 16:09'!
showUnreferencedClassVars
	"Search for all class variables known to the selected class, and put up a 
	list of those that have no references anywhere in the system. The 
	search includes superclasses, so that you don't need to navigate your 
	way to the class that defines each class variable in order to determine 
	whether it is unreferenced"
	self showUnreferencedClassVarsOf: self selectedClass.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 16:11'!
showUnreferencedInstVars
	"Search for all instance variables known to the selected class, and put up a list of those that have no references anywhere in the system.  The search includes superclasses, so that you don't need to navigate your way to the class that defines each inst variable in order to determine whether it is unreferenced"

	self showUnreferencedInstVarsOf: self selectedClass! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/3/2011 14:09'!
sourceCode

	self styled: true.
	self removeSourceTextAreaLimit.
	^self selectedClass isNil
		ifTrue: [ self defaultClassDescriptor]
		ifFalse:[ self selectedMethod isNil
				ifTrue: [ self selectedCategory notNil
						ifTrue: [ self defaultMethodSource]
						ifFalse: [ self selectedClassDescription]]
				ifFalse: [ 
					self putSourceTextAreaLimit.
					self selectedMethodSource]].
		! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 4/13/2011 11:27'!
sourceCodeOkToChange

	sourceTextArea canDiscardEdits ifTrue: [^ true].
	sourceTextArea update: #wantToChange.  "Solicit cancel from view"
	^ sourceTextArea canDiscardEdits
! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/12/2011 17:14'!
sourceCodeSymbol

	^ #SourceCode! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/3/2011 14:09'!
styled: aBoolean

	sourceTextArea ifNotNil: [:sta | 
		aBoolean 
			ifTrue: [ 
				self putSourceTextAreaLimit.
				sta beStyled ]
			ifFalse: [ 
				self removeSourceTextAreaLimit.
				sta beUnStyled ]]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 11:31'!
switchToByteCodeButton

	self sourceCodeOkToChange ifTrue: [ self currentDisplayChoice: self byteCodeSymbol ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 11:31'!
switchToDecompileButton

	self sourceCodeOkToChange ifTrue: [ self currentDisplayChoice: self decompileSymbol ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 4/13/2011 11:31'!
switchToSourceCodeButton

	self sourceCodeOkToChange ifTrue: [ self currentDisplayChoice: self sourceCodeSymbol ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/4/2011 15:01'!
systemNavigation

	^ SystemNavigation new 
			browsedEnvironment: self browsedEnvironment;
			yourself! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 17:41'!
taskbarIcon

	^ self class icon! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 4/11/2011 18:24'!
testRunned: anAnnouncement

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	( anAnnouncement result = self selectedClass or: [ anAnnouncement result correspondingClass = self selectedClass]) 
		ifTrue: [ self update ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
title

	^'Nautilus'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 17:00'!
toogleButtonAction

	self selectedClass ifNil: [^self].
	self toogleShowPackages! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleButtonLabel

	^ 'Hierarchy'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 16:47'!
toogleButtonState

	^ self showPackages not! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowComment

	self showComment: self showComment not! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowGroups

	self showGroups: self showGroups not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 15:16'!
toogleShowHierarchy

	self showHierarchy: self showHierarchy not.
	self updateBothView
! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowInstance

	self showInstance: self showInstance not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowPackages

	self showPackages: self showPackages not.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/4/2011 15:34'!
update

	self selectedCategory ifNil: [ methodsTree selection: MorphTreeMorphMultipleSelection new ].
	methodsTree ifNotNil: [:tree | 
		tree update.
		tree tree scrollSelectionIntoView]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:08'!
updateBothView

	self changed: #getList.
	self changed: #getList2! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:08'!
updateClassView

	self	
		ifPackages:  [ self changed: #getList2 ]
		ifClasses: [ self changed: #getList ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/14/2011 14:12'!
updateGroupView

	self changed: #getList! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/11/2011 13:25'!
updatePackageView

	| vScrollValue |
	self	
		ifPackages: [ self changed: #getList ]
		ifClasses: [ self changed: #getList2 ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/11/2011 13:25'!
updatePackageViewContent

	| vScrollValue |
	self	
		ifPackages: [ 
			vScrollValue := list scrollValue y.
			self changed: #getList.
			list vScrollValue: vScrollValue ]
		ifClasses: [ 
			vScrollValue := list2 scrollValue y.
			self changed: #getList2.
			list2 vScrollValue: vScrollValue ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
window

	^ window! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
window: anObject

	window := anObject! !

Object subclass: #Nautilus
	instanceVariableNames: 'browsedEnvironment ui selectedPackage selectedCategory selectedMethod selectedClass selectedGroup showPackages showGroups showHierarchy showComment showInstance showCategories browsingHistory'
	classVariableNames: 'AnnotationRequests Groups HistoryMaxSize OpenOnGroups RecentClasses ShowAnnotationPane ShowHierarchy'
	poolDictionaries: ''
	category: 'Nautilus'!

Nautilus class
	instanceVariableNames: 'maxSize cachedLastClasses'!

!Nautilus commentStamp: 'BenjaminVanRyseghem 3/17/2011 16:20' prior: 0!
Nautilus new open !

Nautilus class
	instanceVariableNames: 'maxSize cachedLastClasses'!

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 15:33'!
annotationRequests
	"Answer a list of symbol characterizing all the available kinds of annotations; 
	Each symbol represents the info type:
		#timeStamp	: 
			The time stamp of the last submission of the method.
		#firstComment: 
			The first comment in the method, if any.
		#masterComment: 
			The comment at the beginning of the supermost implementor 
			of the method if any.
		#documentation: 
			Comment at beginning of the method or, if it has none, 
			comment at the beginning of a superclass's implementation of the method.
		#messageCategory: 
			Which method category the method lies in.
		#sendersCount: 
			A report of how many senders there of the message.
		#implementorsCount: 
			A report of how many implementors there are of the message.
		#recentChangeSet	: 
			The most recent change set bearing the method.
		#allChangeSets	: 
			A list of all change sets bearing the method.
		#priorVersionsCount: 
			A report of how many previous versions there are of the method.
		#priorTimeStamp: 
			The time stamp of the penultimate submission of the method, if any.
		"
	 ^ AnnotationRequests ifNil: [AnnotationRequests := self defaultAnnotationInfo]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 15:33'!
annotationRequests: anArray
	"Answer a list of symbol characterizing all the available kinds of annotations; 
	Each symbol represents the info type:
		#timeStamp	: 
			The time stamp of the last submission of the method.
		#firstComment: 
			The first comment in the method, if any.
		#masterComment: 
			The comment at the beginning of the supermost implementor 
			of the method if any.
		#documentation: 
			Comment at beginning of the method or, if it has none, 
			comment at the beginning of a superclass's implementation of the method.
		#messageCategory: 
			Which method category the method lies in.
		#sendersCount: 
			A report of how many senders there of the message.
		#implementorsCount: 
			A report of how many implementors there are of the message.
		#recentChangeSet	: 
			The most recent change set bearing the method.
		#allChangeSets	: 
			A list of all change sets bearing the method.
		#priorVersionsCount: 
			A report of how many previous versions there are of the method.
		#priorTimeStamp: 
			The time stamp of the penultimate submission of the method, if any.
		"
	 AnnotationRequests := anArray! !

!Nautilus class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/22/2011 11:37'!
browsedEnvironment: anEnvironment

	^ self new browsedEnvironment: anEnvironment! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/28/2011 13:17'!
buildGroupManager

	| holder |
	holder := GroupsHolder new.
	(holder 
		addADynamicGroupSilentlyNamed: 'Most Viewed Classes' 
		block: [ self recentClassesElements ]) removable: false.
	(holder
		addADynamicGroupSilentlyNamed: 'Last Modified Classes'
		block: [ self lastModifiedClasses ]) removable: false.
	^ holder
			! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/2/2011 15:36'!
defaultAnnotationInfo
	"see annotationRequests comment"
	^ #(timeStamp messageCategory sendersCount implementorsCount allChangeSets)! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 13:27'!
defaultBrowsedEnvironment

	^ BrowserEnvironment new! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/19/2011 11:06'!
defaultMaxSize

	^ NavigationHistory defaultMaxSize! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/7/2011 15:22'!
fullOnClass: aClass selector: aSelector 

	aSelector
		ifNil: [ self openOnClass: aClass ]
		ifNotNil: [| method |
			method := aClass methodDict at: aSelector ifAbsent: [ nil ].
			method ifNotNil: [ self openOnMethod: method ]]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:15'!
groupsManager

	^ Groups ifNil: [ Groups := self buildGroupManager]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/19/2011 11:05'!
historyMaxSize

	^ HistoryMaxSize ifNil: [ HistoryMaxSize := self defaultMaxSize ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/19/2011 11:07'!
historyMaxSize: anInteger

	(anInteger isKindOf: Integer) ifFalse: [ ^ self ].
	anInteger > 0 ifFalse: [ ^ self ].
	HistoryMaxSize := anInteger! !

!Nautilus class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/20/2011 01:27'!
icon 

	^ NautilusUI icon! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/29/2011 11:25'!
importAGroup: aGroup

	self groupsManager addAGroup: aGroup! !

!Nautilus class methodsFor: 'accessing' stamp: 'bvr 5/4/2011 13:24'!
initialize

	Groups := self buildGroupManager! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:26'!
lastModifiedClasses

	^ cachedLastClasses ifNil: [ cachedLastClasses := RecentMessageList uniqueInstance lastClasses: 10 ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:45'!
maxSize

	^ maxSize ifNil: [ maxSize := 10]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
maxSize: anInteger

	maxSize := anInteger.
	self recentClasses maxSize: anInteger.! !

!Nautilus class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 3/23/2011 13:06'!
nautilusMenuOn: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: #Nautilus)
		action: [self open];
		order: 0;
		help: 'Ready to browse the deeps of the system ?';
		icon: self icon! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 5/2/2011 15:00'!
nautilusSettingsOn: aBuilder
	<systemsettings>
	
	(aBuilder group: #Nautilus)
		target: self;
		label: 'Nautilus' translated;
		description: 'Settings related to the browser' translated;
		with: [
			(aBuilder setting: #openOnGroups)
				label: 'Open the browser on groups ?' translated;
				description: 'If true, Nautilus will show groups when opened' translated ];
		with: [
			(aBuilder setting: #showHierarchy)
				label: 'Show hierarchy by default ?' translated;
				description: 'If false, Nautilus will show a flat list of classes' translated ];
		with: [
			(aBuilder setting: #showAnnotationPane)
				label: 'Show an annotation pane ?' translated;
				description: 'If true, Nautilus will show a pane with annotation on selected method' translated ];
		with: [
			(aBuilder setting: #historyMaxSize)
				label: 'Set the max size of the navigation history' translated;
				description: ('By default, the value is ', self defaultMaxSize printString) translated ]! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/23/2011 13:06'!
open
	^ self openInEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/7/2011 15:48'!
openBrowserView: aNautilus label: aByteString 
	
	aNautilus open.
	aNautilus ui selectedMethod: aNautilus selectedMethod.
	aNautilus ui update! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/23/2011 13:05'!
openInEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 13:46'!
openOnCategory: aCategory ofClass: aClass

	^ self openOnCategory: aCategory ofClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 13:45'!
openOnCategory: aCategory ofClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: false.
	instance package: aClass package class: aClass category: aCategory method: nil.
	instance open.
	
	instance ui methodsTree setSelectedNodeItem: aCategory.
	
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:49'!
openOnClass: aClass

	^ self openOnClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/25/2011 17:18'!
openOnClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: false.
	instance package: aClass package class: aClass category: nil method: nil.
	instance open.
	instance ui showPackages: false.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/25/2011 14:56'!
openOnClass: aClass onGroup: aGroup
	
	^ self openOnClass: aClass onGroup: aGroup inEnvironment: self defaultBrowsedEnvironment.! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/25/2011 14:55'!
openOnClass: aClass onGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance package: aClass package class: aClass category: nil method: nil.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:28'!
openOnGroup: aGroup

	^ self openOnGroup: aGroup inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:28'!
openOnGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 13:18'!
openOnGroups

	^ OpenOnGroups ifNil: [ OpenOnGroups := false ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 13:20'!
openOnGroups:aBoolean

	OpenOnGroups := aBoolean! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 13:19'!
openOnMethod: aMethod
	
	^ self openOnMethod: aMethod inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 14:12'!
openOnMethod: aMethod inEnvironment: anEnvironment

	| instance class |
	class := aMethod methodClass.
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: class isMeta not.
	instance showGroups: false.
	instance package: class package class: class category: aMethod category asString method: aMethod.
	instance open.
	
	instance ui methodsTree forceSelection: aMethod category.
	instance ui methodsTree forceSelection: aMethod.
	
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:43'!
openOnPackage: aPackage

	^ self openOnPackage: aPackage inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/30/2011 16:28'!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories

	^ self openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/30/2011 16:26'!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance
		showGroups: showGroups;
		showHierarchy: showHierarchy;
		showComment: showComment;
		showInstance: showInstance;
		showCategories: showCategories.
	
	instance package: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod.
	instance selectedGroup: selectedGroup.
	
	instance open.
	instance ui showPackages: showPackages.
	instance ui methodsTree forceSelection: selectedCategory.
	instance ui methodsTree forceSelection: selectedMethod.
	
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:42'!
openOnPackage: aPackage inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: false.
	instance selectedPackage: aPackage.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
recentClasses

	^ RecentClasses ifNil: [ RecentClasses := HistoryCollection maxSize: self maxSize ]! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:50'!
recentClassesElements

	^ self recentClasses mostViewedlements! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:44'!
resetCachedLastClasses

	^ cachedLastClasses := nil! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 14:55'!
showAnnotationPane

	^ ShowAnnotationPane ifNil: [ ShowAnnotationPane := false ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 14:55'!
showAnnotationPane: aBoolean

	ShowAnnotationPane := aBoolean! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:05'!
showHierarchy

	^ ShowHierarchy ifNil: [ ShowHierarchy := true ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:06'!
showHierarchy: aBoolean

	ShowHierarchy := aBoolean! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 06:44'!
stopNotifications
	" self stopNotifications "
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!Nautilus methodsFor: 'comparing' stamp: 'BenjaminVanRyseghem 4/11/2011 15:56'!
= aNautilus

	self class = aNautilus class ifFalse: [ ^ false ].
	1 to: self class instVarNames size do: [:index |
		(self instVarAt: index) = (aNautilus instVarAt: index)
			ifFalse: [ ^ false ]].
	^ true! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 15:33'!
annotationRequests

	^ self class annotationRequests! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 11:36'!
browsedEnvironment

	^ browsedEnvironment ifNil: [ browsedEnvironment := BrowserEnvironment new ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 11:36'!
browsedEnvironment: anEnvironment

	browsedEnvironment := anEnvironment! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/11/2011 13:39'!
browsingHistory

	^ browsingHistory ifNil: [ browsingHistory := NavigationHistory new ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:19'!
classes
	
	^ self browsedEnvironment classes! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 12:07'!
classesInTheSelectedPackage

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil: [:package | 
			(package definedClasses asArray sort: [:a :b | a name <= b name]), (package extendedClasses asArray sort: [:a :b | a name <= b name])]! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 17:11'!
foundExtentionsIn: aClass

	| result |
	result :=  aClass extendingPackages.
	"self haltIf: [result isEmpty not]."
	^ result! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:49'!
groupsManager
	
	^ self class groupsManager! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/7/2011 15:41'!
labelString

	^ self ui
		ifNil: [ 'Nautilus' ]
		ifNotNil: [:UI | UI title ]! !

!Nautilus methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/20/2011 05:49'!
open

	ui := (self uiClass on: self) open! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/7/2011 15:42'!
openEditString: aString 

	" Dunno what to do"! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 3/24/2011 11:05'!
package: aPackage class: aClass category: aCategory method: aMethod

	self 
		selectedPackage: aPackage;
		selectedClass: aClass;
		selectedCategory: aCategory;
		selectedMethod: aMethod.
		
	self registerHistoryNewEntry.! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:19'!
packages

	^ self browsedEnvironment packages asArray sort! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 09:59'!
packagesUsedByTheSelectedClass

	| result class |
	result := OrderedCollection new.
	class := self selectedClass.
	
	class ifNil: [^{}].
	result add: class package.
	result addAll: (self foundExtentionsIn: class).
	result := result intersection: self packages.
	^ result select:[:each | each notNil]! !

!Nautilus methodsFor: 'accessing' stamp: 'StephaneDucasse 3/17/2011 15:25'!
recentClasses

	^ self class recentClasses! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 4/19/2011 11:00'!
registerHistoryNewEntry

	| wrapper |
	wrapper := NautilusWrapper with: self.
	self browsingHistory add: wrapper.
	"should take care of ui's"! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory

	^ selectedCategory! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory: anObject

	selectedCategory := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedClass

	^ selectedClass! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/28/2011 13:24'!
selectedClass: aClass

	selectedClass := aClass.
	aClass ifNotNil: [ self recentClasses add: aClass theNonMetaClass ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:55'!
selectedGroup

	^ selectedGroup! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:48'!
selectedGroup: anObject

	selectedGroup := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod

	^ selectedMethod! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod: anObject

	selectedMethod := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedPackage

	^ selectedPackage! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 14:09'!
selectedPackage: anObject

	selectedPackage := anObject! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/11/2011 19:47'!
setClass: aClass selector: aSelector 
	
	| method category |
	method := aClass methodDict at: aSelector ifAbsent: [ nil ].
	category := method 
					ifNil: [ nil ]
					ifNotNil: [ method category ].
	self 
		showGroups: false;
		selectedPackage: aClass package;
		selectedClass: aClass;
		showInstance: aClass isMeta not;
		selectedCategory: category;
		selectedMethod: method
	! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 14:54'!
showAnnotationPane
	
	^ self class showAnnotationPane! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showCategories

	^ showCategories ifNil: [ showCategories := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:52'!
showCategories: aBoolean

	showCategories := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:54'!
showComment

	^ showComment ifNil: [ showComment := false ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:52'!
showComment: aBoolean

	showComment := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 13:18'!
showGroups

	^ showGroups ifNil: [ showGroups := self class openOnGroups ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showGroups: aBoolean

	showGroups := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:07'!
showHierarchy

	^ showHierarchy ifNil: [ showHierarchy := self class showHierarchy ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showHierarchy: aBoolean

	showHierarchy := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showInstance

	^ showInstance ifNil: [ showInstance := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showInstance: aBoolean

	showInstance := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showPackages

	^ showPackages ifNil: [ showPackages := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/25/2011 17:17'!
showPackages: aBoolean
	showPackages := aBoolean.! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/7/2011 16:33'!
spawnHierarchy

	self 
		showHierarchy:true;
		open.
	self ui showPackages: false! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/25/2011 17:15'!
ui

	^ ui! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:59'!
uiClass

	^ NautilusUI! !

Object subclass: #NautilusIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons Instance'
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusIcons commentStamp: 'lr 7/10/2009 11:12' prior: 0!
Most of these icons come from http://www.famfamfam.com/lab/icons. They are licensed under the Creative Commons Attribution 3.0 License by Mark James.!

!NautilusIcons class methodsFor: 'accessing' stamp: 'lr 3/28/2009 16:15'!
default
   ^ Instance ifNil: [ Instance := self new ]! !

!NautilusIcons class methodsFor: 'accessing' stamp: 'dr 9/4/2008 16:35'!
iconNamed: aSymbol
	^ Icons at: aSymbol ifAbsentPut: [self default perform: aSymbol]! !

!NautilusIcons class methodsFor: 'initialization' stamp: 'lr 3/21/2009 19:49'!
initialize
	Instance := nil.
	Icons := IdentityDictionary new! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 7/10/2009 11:17'!
announcement
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 168300858 976894522 976888885 34288443 993737531 993722369 959979575 673982238 103889690 87761712 705236742 120273668 87758851 152641799 789920516 959985427 204284436 488586007 34289723 993723152 926613505 168311098 976632635 473311541 1010580540 1007826230 840318012 1010580540 456396046 1010580540 1010580526 623262780 1010580540 1010580540 1010580540 1010580540)
	offset: 0@0)
	colorsFromArray: #(#(0.706 0.788 0.875) #(0.439 0.596 0.761) #(0.545 0.674 0.807) #(0.887 0.934 0.996) #(0.538 0.667 0.804) #(0.423 0.585 0.753) #(0.859 0.918 0.992) #(0.844 0.91 0.992) #(0.577 0.694 0.819) #(0.879 0.93 0.996) #(0.953 0.969 0.98) #(0.663 0.757 0.855) #(0.863 0.922 0.992) #(0.372 0.549 0.733) #(0.71 0.792 0.879) #(0.867 0.926 0.996) #(0.815 0.891 0.992) #(0.361 0.542 0.729) #(0.435 0.592 0.761) #(0.875 0.926 0.996) #(0.827 0.902 0.992) #(0.819 0.894 0.992) #(0.678 0.768 0.863) #(0.49 0.635 0.784) #(0.898 0.941 0.996) #(0.867 0.922 0.996) #(0.482 0.628 0.78) #(0.639 0.741 0.848) #(0.937 0.953 0.973) #(0.815 0.894 0.992) #(0.871 0.926 0.996) #(0.819 0.894 0.988) #(0.941 0.965 0.996) #(0.855 0.914 0.992) #(0.84 0.906 0.992) #(0.91 0.945 0.996) #(0.522 0.655 0.796) #(0.431 0.592 0.757) #(0.745 0.815 0.891) #(0.883 0.934 0.996) #(0.902 0.945 0.996) #(0.458 0.612 0.768) #(0.891 0.937 0.996) #(0.836 0.902 0.992) #(0.894 0.937 0.996) #(0.851 0.914 0.992) #(0.914 0.937 0.965) #(0.831 0.902 0.992) #(0.902 0.941 0.996) #(0.863 0.918 0.992) #(0.365 0.545 0.729) #(0.984 0.988 0.992) #(0.6 0.714 0.831) #(0.906 0.934 0.961) #(0.616 0.721 0.836) #(0.914 0.949 0.996) #(0.992 0.996 0.996) #(0.353 0.534 0.725) #(0.345 0.53 0.721) #(1.0 1.0 1.0)))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 14:10'!
arrowDoubleDown
	^ Form
		extent: 12@6
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 1711418368 4278893824 4278893824 1711418368 16777215 16777215 16777215 16777215 16777215 16777215 1644306688 3540342528 3590744064 4278961664 4278961664 3590744064 3540342528 1644306688 16777215 16777215 16777215 16777215 33554432 3120842496 4278962176 4278962688 4278962688 4278962176 3120842496 33554432 16777215 16777215 16777215 16777215 16777215 402722560 3590744064 4278962688 4278962688 3590744064 402722560 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1308764928 3959984384 3959984384 1308764928 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2315466752 2315466752 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 14:09'!
arrowDoubleUp
	^ Form
		extent: 12@6
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 2315466752 2315466752 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1308764928 3959984384 3959984384 1308764928 16777215 16777215 16777215 16777215 16777215 16777215 16777215 402722560 3590744064 4278962688 4278962688 3590744064 402722560 16777215 16777215 16777215 16777215 16777215 33554432 3120842496 4278962176 4278962688 4278962688 4278962176 3120842496 33554432 16777215 16777215 16777215 16777215 1644306688 3540342528 3590744064 4278961664 4278961664 3590744064 3540342528 1644306688 16777215 16777215 16777215 16777215 16777215 16777215 1711418368 4278893824 4278893824 1711418368 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 13:49'!
arrowDown
	^ Form
		extent: 12@12
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1157900544 3154467840 3154467840 1157900544 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1711483648 4278893824 4278893824 1711483648 16777215 16777215 16777215 16777215 16777215 16777215 1661149440 3624228608 3657853952 4278961664 4278961664 3657853952 3624228608 1661149440 16777215 16777215 16777215 16777215 16777216 3070510592 4278962176 4278962688 4278962688 4278962176 3070510592 16777216 16777215 16777215 16777215 16777215 16777215 352324608 3573966336 4278962688 4278962688 3573966336 352324608 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1258499072 3959984128 3959984128 1258499072 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2315532032 2315532032 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 13:48'!
arrowUp
	^ Form
		extent: 12@12
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 2315532032 2315532032 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1275276288 3959984384 3959984384 1275276288 16777215 16777215 16777215 16777215 16777215 16777215 16777215 369104640 3573967104 4278962688 4278962688 3573967104 369104640 16777215 16777215 16777215 16777215 16777215 16777216 3087288576 4278962176 4278962688 4278962688 4278962176 3087288576 16777216 16777215 16777215 16777215 16777215 1610818304 3540342528 3590744320 4278961664 4278961664 3590744064 3540342528 1610818304 16777215 16777215 16777215 16777215 16777215 16777215 1711483648 4278893824 4278893824 1711483648 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1157900544 3154467840 3154467840 1157900544 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 13:46'!
arrowUpAndDown
	^ Form
		extent: 12@12
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 2315532032 2315532032 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1308830464 3959984128 3959984128 1308830464 16777215 16777215 16777215 16777215 16777215 16777215 16777215 402658560 3590744064 4278962688 4278962688 3590744064 402658560 16777215 16777215 16777215 16777215 16777215 33554432 3120842496 4278962176 4278962688 4278962688 4278962176 3120842496 33554432 16777215 16777215 16777215 16777215 1644372480 3540342528 3590744064 4278961664 4278961664 3590744064 3540342528 1644372480 16777215 16777215 16777215 16777215 16777215 16777215 1711483648 4278893824 4278893824 1711483648 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1711483648 4278893824 4278893824 1711483648 16777215 16777215 16777215 16777215 16777215 16777215 1644372480 3540342528 3590744064 4278961664 4278961664 3590744064 3540342528 1644372480 16777215 16777215 16777215 16777215 33554432 3120842496 4278962176 4278962688 4278962688 4278962176 3120842496 33554432 16777215 16777215 16777215 16777215 16777215 402658560 3590744064 4278962688 4278962688 3590744064 402658560 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1308830464 3959984128 3959984128 1308830464 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2315532032 2315532032 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/28/2009 16:04'!
blank
	^ Form extent: 12 @ 12 depth: 8! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/30/2011 12:44'!
bookIcon
	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 284817913 552924404 0 0 0 0 0 0 0 0 0 817149108 3747766882 4287730065 2679749049 549766340 0 0 0 0 0 0 1086110908 4016202338 4287137928 4288914339 4288914339 4289111718 3216290996 1086505666 0 0 0 816754350 4014952271 4287137928 4289309097 4289769648 4289111718 4288453788 4288453788 4288453788 2947658161 0 814846353 4283782485 4287072135 4288059030 4288059030 4288387995 4289243304 4289309097 4287927444 4287598479 2411050421 1081900156 4283585106 4286611584 4287532686 4287532686 4287466893 4287466893 4287401100 4287401100 4287401100 4288716960 2946868645 3211290728 4288651167 4287269514 4287006342 4287006342 4287006342 4286940549 4286940549 4287203721 4289177511 3483213213 281725642 2677183122 4293190884 4292861919 4289177511 4286874756 4286611584 4286611584 4287006342 4289638062 4020084125 549042617 0 282054607 2677643673 4289572269 4293256677 4292796126 4288980132 4287137928 4290164406 4020215711 816754350 0 0 0 0 551082200 2677643673 4289572269 4293256677 4292401368 4289177511 1085584564 0 0 0 0 0 0 0 551213786 2677643673 4288651167 1623244992 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 8/2/2007 19:32'!
breakpoint
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 437918234 437918234 437918234 437654804 319885069 26 437590295 404100630 100859930 437524241 269290764 100860442 437327375 235736076 67305498 437261581 218893324 67305754 437130258 303174162 84082970 436931081 134678279 196890 437918234 437918234 196890 454761243 454761242 196890 454761243 454761242 196634 454761243 454761242 26)
	offset: 0@0)
	colorsFromArray: #(#(0.349 0.212 0.098) #(0.329 0.2 0.094) #(0.376 0.232 0.109) #(0.694 0.462 0.271) #(0.608 0.271 0.204) #(0.545 0.185 0.113) #(0.784 0.322 0.294) #(0.721 0.023 0.023) #(0.788 0.055 0.055) #(0.848 0.106 0.106) #(0.875 0.137 0.137) #(0.914 0.208 0.208) #(0.953 0.298 0.298) #(0.953 0.318 0.318) #(0.953 0.333 0.333) #(0.953 0.349 0.349) #(0.953 0.365 0.365) #(0.953 0.388 0.388) #(0.922 0.427 0.427) #(0.953 0.482 0.482) #(0.949 0.542 0.538) #(0.957 0.592 0.592) #(0.953 0.624 0.62) #(0.984 0.879 0.879) #(0.988 0.898 0.898) #(0.992 0.918 0.918) #(1.0 1.0 1.0) #( )))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:32'!
byteCodeSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4292664540 4290559164 4289506476 4289506476 4289506476 4289506476 4289703855 4290822336 4292006610 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4292598747 4278717966 4279323720 4279323720 4279323720 4279323720 4279323463 4279318839 4279050528 4279575586 4285494644 4292203989 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278314710 4278675039 4282206793 4292598747 4292664540 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278494874 4279051556 4279051813 4279063631 4278307516 4278321133 4278320876 4279121973 4289835441 4292664540 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4286743170 4291611852 4287598479 4279121202 4278321133 4278321133 4278744429 4286874756 4292664540 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4287335307 4292664540 4289309097 4279185197 4278321133 4278321133 4279129424 4288585374 4292664540 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278557071 4278785043 4278785300 4279188279 4278434477 4278321133 4278303148 4279180058 4292072403 4292664540 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278318564 4278256130 4288059030 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278438074 4279133535 4279133535 4278551675 4278309314 4278321133 4278367913 4278984221 4288914339 4292664540 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4284506208 4288124823 4285757303 4279048472 4278313168 4278321133 4278299551 4282667858 4292664540 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4287335307 4292664540 4292664540 4284901994 4278423172 4278321133 4278317536 4279048472 4292664540 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278678893 4286743170 4291743438 4289177511 4280167210 4278308030 4278321133 4278318821 4279180315 4292664540 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278494874 4279051556 4279051812 4279257927 4278427540 4278321133 4278321133 4278365344 4281746756 4292664540 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4292598747 4278785814 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278321133 4278319078 4278426512 4279180572 4290624957 4292664540 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4292598747 4278717966 4279323720 4279323720 4279323720 4279323720 4279323720 4279321664 4279183656 4278785043 4283061845 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4292664540 4290888129 4289967027 4289967027 4289967027 4289967027 4289967027 4290361785 4291611852 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:37'!
byteCodeUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4290032820 4288322202 4287401100 4287401100 4287401100 4287401100 4287598479 4288519581 4289506476 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4289967027 4278782217 4281084972 4281084972 4281084972 4281084972 4281019179 4280427042 4279571733 4279769112 4284374622 4289638062 4290032820 4290032820 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4285756275 4281742902 4281874488 4289967027 4290032820 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4283782485 4279703319 4279769112 4281216558 4284835173 4286611584 4286545791 4280295456 4287730065 4290032820 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4285229931 4289177511 4285887861 4280163870 4286611584 4286611584 4282203453 4285295724 4290032820 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4285690482 4290032820 4287269514 4280032284 4286611584 4286611584 4281216558 4286677377 4290032820 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4283387727 4279045389 4279111182 4280427042 4284308829 4286611584 4284308829 4279374354 4289506476 4290032820 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286282619 4278321666 4286282619 4290032820 4290032820 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4284835173 4281808695 4281808695 4282664004 4285098345 4286611584 4284243036 4279440147 4286940549 4290032820 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4283321934 4286348412 4284506208 4279308561 4285558896 4286611584 4283848278 4282335039 4290032820 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4285690482 4290032820 4290032820 4283782485 4282861383 4286611584 4286151033 4279308561 4290032820 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4282203453 4285229931 4289309097 4287137928 4280295456 4284900966 4286611584 4286282619 4279374354 4290032820 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4283782485 4279703319 4279769112 4281019179 4283453520 4286611584 4286611584 4283914071 4281545523 4290032820 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4289967027 4279176975 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286348412 4283321934 4279440147 4288387995 4290032820 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4289967027 4278782217 4281084972 4281084972 4281084972 4281084972 4281084972 4280821800 4279834905 4279045389 4282598211 4288124823 4290032820 4290032820 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4290032820 4288585374 4287795858 4287795858 4287795858 4287795858 4287795858 4288124823 4289177511 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:57'!
classVarsSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292598747 4290822336 4288585374 4286677377 4287795858 4289572269 4292467161 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292532954 4286414209 4278979864 4279111728 4279046746 4278389373 4278783848 4279177799 4279111452 4284045925 4292269782 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4292664540 4292664540 4291282887 4280361518 4278915157 4278259429 4278259967 4278259967 4278259967 4278259967 4278259967 4278259694 4278980405 4289638062 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4292664540 4292664540 4281677379 4278455444 4278259967 4278259967 4278258881 4279243853 4279045668 4279111722 4279178063 4278324393 4279243848 4289638062 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4292664540 4287072138 4278914886 4278259967 4278259967 4278587028 4279900967 4288716960 4291940817 4291611852 4289045925 4281808966 4278255874 4289967027 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4292664540 4280427316 4278259153 4278259967 4278259689 4279111454 4291677645 4292664540 4292664540 4292664540 4292664540 4292664540 4291414473 4292664540 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4292664540 4278782484 4278259964 4278259967 4278258333 4284177251 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4290953922 4279243312 4278259967 4278259967 4278586741 4287072135 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4290888129 4279243313 4278259967 4278259967 4278652533 4287072135 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4292598747 4278782484 4278259964 4278259967 4278258333 4284243044 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4292664540 4280361523 4278259156 4278259967 4278259689 4279177247 4291743438 4292664540 4292664540 4292664540 4292664540 4292664540 4291743438 4292664540 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4292664540 4286677381 4278914891 4278259967 4278259967 4278587025 4280032555 4289177511 4292072403 4291611852 4289045925 4282335309 4278321667 4290098613 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4292664540 4292664540 4281414207 4278389916 4278259967 4278259967 4278258876 4279243851 4278914077 4279111717 4279243852 4278324129 4279243591 4289638062 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4292664540 4292664540 4291151301 4280032553 4278915165 4278259690 4278259967 4278259967 4278259967 4278259967 4278259967 4278259699 4279046200 4289638062 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292467161 4285953658 4278979863 4279243319 4279112545 4278520965 4278849651 4279243855 4279045659 4283651166 4292269782 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292401368 4290361785 4288124823 4286282619 4287335307 4289111718 4292269782 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:57'!
classVarsUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289967027 4288519581 4286677377 4285164138 4286019447 4287466893 4289835441 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289967027 4285032552 4279242768 4280032284 4281479730 4282400832 4281808695 4280821800 4279374354 4283387727 4289703855 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4290032820 4290032820 4288914339 4280361249 4281216558 4285756275 4286611584 4286611584 4286611584 4286611584 4286611584 4286019447 4280163870 4287598479 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4281545523 4283190348 4286611584 4286611584 4284572001 4281019179 4279637526 4279834905 4281084972 4283782485 4280887593 4287598479 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4290032820 4285558896 4280690214 4286611584 4286611584 4283124555 4280032284 4286808963 4289440683 4289177511 4287072135 4281611316 4278255873 4287861651 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4290032820 4280624421 4285098345 4286611584 4285887861 4279440147 4289243304 4290032820 4290032820 4290032820 4290032820 4290032820 4288980132 4290032820 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4290032820 4279045389 4286479998 4286611584 4283387727 4283321934 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4288651167 4280098077 4286611584 4286611584 4282203453 4285493103 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4288585374 4280163870 4286611584 4286611584 4282203453 4285493103 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4289967027 4279045389 4286479998 4286611584 4283387727 4283453520 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4290032820 4280558628 4285164138 4286611584 4285887861 4279505940 4289309097 4290032820 4290032820 4290032820 4290032820 4290032820 4289309097 4290032820 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4290032820 4285295724 4280887593 4286611584 4286611584 4283058762 4280163870 4287137928 4289572269 4289177511 4287072135 4282071867 4278321666 4287927444 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4290032820 4290032820 4281282351 4283321934 4286611584 4286611584 4284374622 4280953386 4279374354 4279703319 4281019179 4283519313 4280887593 4287598479 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4290032820 4290032820 4288782753 4280098077 4281479730 4285887861 4286611584 4286611584 4286611584 4286611584 4286611584 4286216826 4280361249 4287598479 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289835441 4284703587 4279242768 4280295456 4281677109 4282729797 4282137660 4281150765 4279374354 4282992969 4289703855 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289769648 4288190616 4286348412 4284769380 4285690482 4287137928 4289703855 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:02'!
collection
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 168952850 171324982 909522486 255008812 271977989 285543990 706029348 70649368 724044854 254681884 271986469 689508662 135534100 137758237 890965046 909522486 909513472 436212534 909508866 151126326 909522486 909511457 807338806 909522486 909521969 841353526 909522486 909511458 504824630 909522486 909511943 755436854 909522486 909522486 909522486 909522486)
	offset: 0@0)
	colorsFromArray: #(#(0.565 0.764 0.538) #(0.992 0.98 0.934) #(0.957 0.879 0.549) #(0.953 0.867 0.514) #(1.0 0.569 0.286) #(0.577 0.772 0.553) #(0.557 0.761 0.53) #(0.957 0.875 0.538) #(1.0 0.949 0.914) #(0.937 0.827 0.369) #(1.0 0.953 0.922) #(0.953 0.871 0.53) #(0.542 0.753 0.518) #(0.992 0.98 0.926) #(0.937 0.965 0.934) #(1.0 0.678 0.466) #(1.0 0.667 0.451) #(0.408 0.678 0.372) #(1.0 0.694 0.494) #(0.93 0.961 0.926) #(1.0 0.682 0.478) #(0.918 0.631 0.447) #(1.0 0.557 0.271) #(0.848 0.757 0.384) #(0.545 0.745 0.506) #(0.561 0.686 0.522) #(0.392 0.671 0.357) #(0.466 0.659 0.423) #(0.887 0.53 0.298) #(0.514 0.71 0.474) #(0.807 0.737 0.458) #(0.887 0.796 0.423) #(0.91 0.628 0.443) #(0.93 0.84 0.466) #(0.894 0.804 0.435) #(0.831 0.553 0.372) #(0.823 0.542 0.357) #(0.643 0.772 0.604) #(0.804 0.733 0.443) #(0.871 0.588 0.408) #(0.498 0.698 0.462) #(0.612 0.733 0.573) #(1.0 0.577 0.306) #(0.639 0.764 0.6) #(0.926 0.569 0.337) #(0.937 0.823 0.353) #(0.937 0.581 0.349) #(0.419 0.686 0.388) #(0.883 0.811 0.53) #(0.894 0.823 0.534) #(0.848 0.776 0.494) #(0.973 0.612 0.38) #(0.941 0.831 0.384) #(0.573 0.694 0.534) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:33'!
decompileSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4291217094 4289506476 4289506476 4289506476 4289638062 4290361785 4290953922 4292269782 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4280890147 4280567056 4280830993 4280830993 4280764945 4280434192 4280103695 4279311371 4280034838 4284573533 4290888129 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4284612353 4284612353 4284612353 4284612353 4284612353 4284214785 4282029316 4279377164 4287138439 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4284016385 4281430026 4281430793 4281897729 4283288321 4284612353 4284612353 4284016641 4279708172 4289177511 4292664540 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4281941557 4287335307 4285230697 4280626975 4280701707 4284413441 4284612353 4283354113 4279968790 4292072403 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292598747 4284112983 4281430793 4284612353 4284612353 4281232137 4287006342 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292664540 4292269782 4279376653 4284546305 4284612353 4282427393 4284179031 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292664540 4292664540 4281088036 4283751937 4284612353 4283552769 4281548588 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292664540 4292664540 4280956707 4283817729 4284612353 4283552769 4281614381 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292664540 4292203989 4279310860 4284612097 4284612353 4282427393 4284179031 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4283916369 4292664540 4292664540 4292598747 4284047190 4281497096 4284612353 4284612353 4281232137 4287072135 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4282493441 4281941557 4287335307 4285230697 4280561182 4280899852 4284413697 4284612353 4283354625 4279968790 4292072403 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4284016385 4281430026 4281430793 4281897729 4283288321 4284612353 4284612353 4284082433 4279839757 4289177511 4292664540 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4280495644 4283950337 4284612353 4284612353 4284612353 4284612353 4284612353 4284612353 4284148993 4281896708 4279509005 4287138439 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4280955940 4280567056 4280830993 4280830993 4280764945 4280434192 4280103695 4279311115 4280100631 4284705119 4290888129 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4291414473 4289967027 4289967027 4289967027 4290098613 4290559164 4291085508 4292269782 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:39'!
decompileUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4288848546 4287401100 4287401100 4287401100 4287598479 4288124823 4288651167 4289703855 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4280624421 4280821800 4281084972 4281084972 4281019179 4280558628 4280163870 4279308561 4279900698 4283519313 4288585374 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286019447 4283190348 4279440147 4285558896 4290032820 4290032820 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4285822068 4282071867 4282203453 4283058762 4284900966 4286611584 4286611584 4285822068 4279834905 4287203721 4290032820 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4281413937 4285690482 4284045657 4280361249 4281150765 4286282619 4286611584 4284900966 4279834905 4289572269 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4289967027 4283124555 4282137660 4286611584 4286611584 4281940281 4285361517 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4290032820 4289703855 4279374354 4286545791 4286611584 4283716692 4283190348 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4290032820 4290032820 4280821800 4285493103 4286611584 4285164138 4281150765 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4290032820 4290032820 4280756007 4285558896 4286611584 4285164138 4281216558 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4290032820 4289638062 4279308561 4286545791 4286611584 4283716692 4283190348 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4282992969 4290032820 4290032820 4289967027 4283190348 4282203453 4286611584 4286611584 4281940281 4285427310 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4283782485 4281413937 4285690482 4284045657 4280361249 4281413937 4286348412 4286611584 4284966759 4279834905 4289572269 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4285822068 4282071867 4282203453 4283058762 4284900966 4286611584 4286611584 4285887861 4279966491 4287203721 4290032820 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4280295456 4285756275 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286019447 4282992969 4279505940 4285558896 4290032820 4290032820 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4280690214 4280821800 4281084972 4281084972 4281019179 4280558628 4280163870 4279308561 4279966491 4283650899 4288585374 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4288980132 4287795858 4287795858 4287795858 4287927444 4288322202 4288716960 4289703855 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/31/2011 17:27'!
dirtyPackageIcon

	^ (Form
		extent: 15@16
		depth: 32
		fromArray:    #(16777215 16777215 16777215 16777215 16777215 16777215 55924053 417994005 50331647 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 33554432 465965843 3031638305 3903537987 3402577205 1055007009 55924053 16777215 16777215 16777215 16777215 16777215 16777215 33554432 211096853 2898203925 3903533104 4286542707 4286545791 4286874242 4037368410 3520342827 602025004 75530368 16777215 16777215 16777215 67108864 1907822094 3651740708 4254094677 4107417399 4122498132 4286807935 4189741923 4141438293 4238769019 3970982755 2898412355 399008868 41975936 50331648 3569165862 4155256623 4285098345 4285690482 4286019447 4239415384 4242881853 4191310675 4287269514 4287730065 4288848546 4290879648 4140590437 212511402 16777215 3417454134 4220740451 4173088326 4254618194 4106502465 4123936326 4287004286 4189741923 4141438550 4239162492 4191255676 4207711637 4057304204 284159983 16777215 3433903670 4285164138 4285754990 4240068945 4190259015 4287196782 4286545791 4286939521 4173685089 4258814040 4288185990 4288585374 3989996162 234881023 16777215 3618122282 4284571744 4285032552 4154738503 4286280049 4189085535 4190129742 4173682262 4220874350 4123479116 4286743170 4287269514 3990118753 150994943 16777215 3751747873 4218959157 4235610184 4170400322 4285229931 4285558896 4257240919 4285493103 4285822068 4123411524 4288113515 4107945542 4091689787 83886079 16777215 3548454687 4282203453 4233968957 4270077237 4285551186 4284966759 4290072142 4285229931 4286277479 4242418475 4123019079 4286609271 3854453836 83886079 16777216 3664647188 4280756007 4281742902 4284427822 4285086523 4286790202 4289611848 4290390056 4290652200 4291308588 4285690482 4285953654 3870967366 67108863 117440512 3313569037 4263906830 4280163613 4282654238 4282203453 4283319878 4289282112 4286729806 4284900966 4290194476 4285361517 4253703003 3486721317 41975936 16777216 134217728 1603340296 4016639245 4281337864 4280690214 4281611316 4287577405 4284835173 4284835173 4239861543 3820561958 2127435286 75513920 16777215 16777215 16777215 33554432 218103808 2543520266 4149480717 4280424986 4286460980 4285292640 4004129836 2832208402 296026112 16777215 16777215 16777215 16777215 16777215 16777215 16777215 50331648 372899840 3012103437 4187497251 3083409432 565772288 16777216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 134217728 33554432 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/7/2011 19:12'!
emptyPackageIcon

	^ (Form
		extent: 14@16
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 33554432 61516458 61516458 16777216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 87241523 1012027986 3211488107 2927262330 613125003 61516458 16777216 16777215 16777215 16777215 16777215 16777216 50331648 541344836 2539346779 4201672816 3530321004 3782637174 4135353468 2407102841 379099288 93952409 16777215 16777215 16777216 252710928 2085704017 3966002276 3344982112 1582519123 109084800 290147147 2070637419 3783097725 3968502410 2323677312 243302528 16777215 67108864 3277478490 4284900966 3797769565 1330071367 138428480 55924053 55924053 208300650 1919576682 4170421139 4272795053 3348008590 164021958 16777215 4134366573 3848824679 3781979244 3681644913 2992857955 1280463442 1365139038 3128325750 3868036493 3851916950 3970081185 3937382319 234881023 16777215 4150749031 3966528620 4268715887 3698224750 4017452405 4252728187 4252991359 3951396229 3599140229 4287203721 4137722016 3903498922 218103807 16777215 4099562074 1684300900 1802004584 3899617135 4184829807 3648550775 3598745471 4202330746 3598548349 1754567828 2492896918 3700790677 150994943 16777215 4047980359 1599625304 16777215 158429553 3261885548 4151604340 4286019190 2557768820 264027324 117440511 2055570821 3531768450 83886079 16777215 4197725236 1750028111 16777215 16777215 2741265508 4167921005 4285756018 1466986608 33554431 50331647 2172419196 3715857275 83886079 16777215 4212989213 3627431478 826820680 16777215 2673235542 3982516063 3698356079 1248422249 16777215 510553710 3178460019 3698816887 67108863 16777215 2586586156 4195751446 4247004196 3091218496 3209185352 4166078544 4235095405 1432774246 2003331176 4134234987 3849351280 1601993852 33554431 16777215 16777215 473183284 3274123047 4263123482 4280953386 4215094589 4285427053 4167394661 3831981927 2188077931 244486802 33554431 16777215 16777215 16777215 16777215 16777215 1093874483 3760267553 4213581093 4268649837 2758108517 492921185 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1832598331 1014528120 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:10'!
exception
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 1583238196 1191577949 759500554 1583225870 390089009 36066088 1578711384 857557019 906518110 1581393173 991970905 1549688414 722677332 570761514 1583242846 1327383559 1091971346 5322527 792346372 337270359 1297099812 1011548469 286015067 654532190 1583242842 941838926 1432247902 1583242763 221384798 1583242846 1583224899 1029594718 1583242846 1583231050 1583242846 1583242846)
	offset: 0@0)
	colorsFromArray: #(#(0.906 0.764 0.392) #(0.945 0.867 0.6) #(0.918 0.776 0.306) #(0.969 0.922 0.815) #(0.945 0.831 0.443) #(0.953 0.84 0.443) #(0.934 0.823 0.388) #(0.953 0.819 0.286) #(0.98 0.949 0.855) #(0.93 0.815 0.376) #(0.992 0.98 0.941) #(0.894 0.733 0.302) #(0.945 0.792 0.4) #(0.898 0.725 0.286) #(0.949 0.863 0.423) #(0.965 0.91 0.737) #(0.984 0.961 0.906) #(0.914 0.772 0.365) #(0.91 0.768 0.384) #(0.941 0.844 0.415) #(0.953 0.844 0.498) #(0.965 0.871 0.4) #(0.953 0.836 0.474) #(0.945 0.859 0.439) #(0.949 0.867 0.651) #(0.988 0.965 0.867) #(0.949 0.815 0.455) #(0.957 0.855 0.542) #(0.953 0.875 0.514) #(0.957 0.836 0.341) #(0.953 0.867 0.474) #(0.914 0.78 0.474) #(0.945 0.8 0.263) #(0.934 0.811 0.431) #(0.941 0.792 0.216) #(0.93 0.788 0.443) #(0.965 0.914 0.796) #(0.965 0.891 0.51) #(0.898 0.733 0.22) #(0.906 0.764 0.435) #(0.992 0.984 0.953) #(0.898 0.737 0.275) #(0.957 0.894 0.71) #(0.992 0.977 0.914) #(0.926 0.815 0.569) #(0.918 0.788 0.333) #(0.973 0.902 0.561) #(0.918 0.788 0.286) #(0.957 0.891 0.725) #(0.937 0.815 0.396) #(0.902 0.757 0.396) #(0.965 0.867 0.369) #(0.937 0.84 0.384) #(0.934 0.836 0.526) #(0.91 0.764 0.306) #(0.887 0.721 0.333) #(0.914 0.764 0.357) #(0.941 0.855 0.412) #(0.949 0.855 0.462) #(0.949 0.811 0.232) #(0.957 0.891 0.635) #(0.945 0.863 0.659) #(0.941 0.776 0.408) #(0.953 0.855 0.474) #(0.945 0.844 0.427) #(0.941 0.78 0.236) #(0.957 0.891 0.608) #(0.875 0.69 0.216) #(0.969 0.883 0.451) #(0.906 0.761 0.286) #(0.957 0.848 0.498) #(0.934 0.836 0.396) #(0.961 0.84 0.415) #(0.941 0.831 0.408) #(0.977 0.941 0.855) #(0.949 0.875 0.604) #(0.965 0.91 0.655) #(0.922 0.757 0.404) #(0.941 0.851 0.635) #(0.965 0.914 0.698) #(0.879 0.69 0.247) #(0.898 0.741 0.353) #(0.891 0.717 0.302) #(0.973 0.934 0.804) #(0.953 0.831 0.279) #(1.0 0.996 0.992) #(0.941 0.796 0.443) #(0.941 0.804 0.486) #(0.98 0.922 0.573) #(0.914 0.772 0.345) #(0.98 0.945 0.859) #(0.902 0.725 0.322) #(0.969 0.918 0.772) #(0.926 0.8 0.357) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 8/2/2007 19:32'!
flag
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 437918234 437918234 437918234 436470535 101584139 387389210 436404481 17105924 303634202 436666638 218827016 35198490 437126412 185075720 1644314 437060363 168298504 1644570 436930320 269422351 370743322 437326099 320082453 387520538 437918234 437918234 387520538 454761243 454761242 387520538 454761243 454761242 387520282 454761243 454761242 387389210)
	offset: 0@0)
	colorsFromArray: #(#(0.22 0.396 0.585) #(0.898 0.945 0.996) #(0.228 0.498 0.761) #(0.608 0.796 0.98) #(0.635 0.804 0.98) #(0.655 0.819 0.98) #(0.47 0.729 0.973) #(0.542 0.768 0.977) #(0.251 0.631 0.961) #(0.267 0.639 0.961) #(0.275 0.643 0.961) #(0.286 0.647 0.961) #(0.302 0.659 0.965) #(0.326 0.667 0.965) #(0.353 0.678 0.965) #(0.396 0.714 0.965) #(0.419 0.729 0.969) #(0.239 0.686 0.93) #(0.243 0.624 0.772) #(0.236 0.682 0.851) #(0.228 0.667 0.788) #(0.224 0.616 0.671) #(0.384 0.228 0.082) #(0.349 0.212 0.098) #(0.329 0.2 0.094) #(0.694 0.462 0.271) #(1.0 1.0 1.0) #( )))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 18:50'!
greenArrowUpAndDown
	^ Form
		extent: 9@15
		depth: 32
		fromArray:  #(16777215 16777215 16777215 906042112 3791859456 906042112 16777215 16777215 16777215 16777215 16777215 268435456 3557049600 4278962432 3557049600 268435456 16777215 16777215 16777215 16777216 3137548288 4278894336 4278962688 4278894336 3137548288 16777216 16777215 16777215 2348951296 4161381376 4278962688 4278962688 4278962688 4161381376 2348951296 16777215 1342316032 3926358272 4278962688 4278962688 4278962688 4278962688 4278962688 3926358272 1342316032 3858831104 3842402048 3842402048 4262115584 4278962688 4262115584 3842402048 3842402048 3858831104 251658240 268435456 1140850688 4194866688 4278962688 4194866688 1140850688 268435456 251658240 16777215 16777215 939524096 4194866688 4278962688 4194866688 939524096 16777215 16777215 251658240 268435456 1140850688 4194866688 4278962688 4194866688 1140850688 268435456 251658240 3858831104 3842402048 3842402048 4262115584 4278962688 4262115584 3842402048 3842402048 3858831104 1342316032 3926358272 4278962688 4278962688 4278962688 4278962688 4278962688 3926358272 1342316032 16777215 2348951296 4161381376 4278962688 4278962688 4278962688 4161381376 2348951296 16777215 16777215 16777216 3137548288 4278894336 4278962688 4278894336 3137548288 16777216 16777215 16777215 16777215 268435456 3557049600 4278962432 3557049600 268435456 16777215 16777215 16777215 16777215 16777215 906042112 3791859456 906042112 16777215 16777215 16777215)
		offset: 0@0! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/1/2011 15:26'!
groupIcon

	^ (Form
		extent: 15@16
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 16777215 741343023 3275816768 3075604305 610139997 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 206881045 2468937512 4198039352 4282777413 4283629394 4133486431 2422472547 160417763 16777215 16777215 16777215 16777215 16777215 16777215 1593774888 3892256563 3483734080 3963682109 4282777413 4283563857 3915905900 3816339156 3866464511 1668517887 16777215 16777215 16777215 704196930 3271492893 4294906665 4294909748 4294913088 4143399757 3482178394 3546861469 4234117372 4285237503 4286026495 4286881023 3448151551 544905471 16777215 2212050759 3705883738 3892062268 4294909748 4261359168 3506413903 4043306825 3959223899 3718624710 4285237503 4286026495 3933375999 3813831421 1295737599 16777215 2261264440 4291180100 4225057616 3505218398 3640584759 4294965305 4294965317 4294965585 4294965598 3673156994 3613359861 4248921854 4282673663 1329686527 16777215 2327257906 4289868607 4290721090 3821495878 4041136203 3623152977 4294965316 4261411153 3623876694 4110415943 4015421164 4283133695 4283988479 1397584383 16777215 2255301983 4187107390 4289344061 3887095105 4291281462 4292070714 4007252563 3942249295 4294965308 4294965575 4050224622 4284448511 4068575729 1386704574 16777215 2467771800 4146608763 3898423902 3969339963 4289900083 4290820917 4274767168 4294965068 4294965582 4294965594 4051670252 3704655548 4194271886 1526686578 16777215 2567710594 4279970659 4280431990 4180689000 4269180974 4289439538 4290491968 4294965343 4294965602 4173456753 4058746767 4294936466 4294939806 1593798010 67108864 2919241572 4278982722 4279641432 4280168537 4280713254 4282219052 4288322877 4292864882 4286898294 4286775170 4276918936 4294941604 4294944944 1694069631 83886080 1879052875 4177530951 4278653495 4279377983 4279984923 4280448802 4282093368 4287035781 4287299466 4288151447 4277119914 4294946743 3824456348 669148016 16777216 150994944 587202568 3288339543 4227928107 4279059213 4279654422 4281433136 4288216727 4288610206 4289462187 4109085865 2195417203 150994944 16777216 16777215 16777215 33554432 234881024 1207970826 3858781696 4278664199 4280771878 4289396393 4255841706 3111708280 407587627 33554432 16777215 16777215 16777215 16777215 16777215 16777215 67108864 352321536 2046839040 4028261914 3734040464 1028699728 67108864 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 117440512 251658240 117440512 16777216 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:56'!
instVarsSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4289506476 4289506476 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4290361785 4279634185 4283175185 4283175185 4279568649 4290427578 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4289967027 4282781712 4294902017 4294902017 4282716176 4289967027 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4290361785 4279634185 4283175185 4283175185 4279568649 4290427578 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4290361785 4289967027 4289967027 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:56'!
instVarsUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray: #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287861651 4287401100 4287401100 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4288124823 4279045389 4281084972 4281084972 4279045389 4288190616 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4287795858 4280821800 4286611584 4286611584 4280821800 4287861651 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4288124823 4279045389 4281084972 4281084972 4279045389 4288190616 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4288190616 4287795858 4287795858 4288190616 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:19'!
magnitude
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 874447653 738461995 85013556 875824136 573444634 471217204 875826957 607204404 875115572 875836464 489816628 875836468 875836468 50409268 875836468 875836468 268902708 875836468 875836418 101004340 875836468 875836448 167851060 873804852 875825163 204747815 874722356 875763995 321259818 335557684 875042605 102243847 930868 875836468 875836468 875836468)
	offset: 0@0)
	colorsFromArray: #(#(0.372 0.372 0.372) #(0.608 0.608 0.608) #(0.961 0.961 0.961) #(0.506 0.506 0.506) #(0.588 0.588 0.588) #(0.415 0.415 0.415) #(0.419 0.419 0.419) #(0.384 0.384 0.384) #(0.745 0.745 0.745) #(0.561 0.561 0.561) #(0.447 0.447 0.447) #(0.435 0.435 0.435) #(0.427 0.427 0.427) #(0.545 0.545 0.545) #(0.522 0.522 0.522) #(0.902 0.902 0.902) #(0.761 0.761 0.761) #(0.53 0.53 0.53) #(0.686 0.686 0.686) #(0.628 0.628 0.628) #(0.181 0.181 0.181) #(0.204 0.204 0.204) #(0.604 0.604 0.604) #(0.455 0.455 0.455) #(0.408 0.408 0.408) #(0.341 0.341 0.341) #(0.659 0.659 0.659) #(0.333 0.333 0.333) #(0.663 0.663 0.663) #(0.624 0.624 0.624) #(0.396 0.396 0.396) #(0.875 0.875 0.875) #(0.542 0.542 0.542) #(0.592 0.592 0.592) #(0.569 0.569 0.569) #(0.236 0.236 0.236) #(0.565 0.565 0.565) #(0.494 0.494 0.494) #(0.62 0.62 0.62) #(0.953 0.953 0.953) #(0.733 0.733 0.733) #(0.502 0.502 0.502) #(0.298 0.298 0.298) #(0.451 0.451 0.451) #(0.585 0.585 0.585) #(0.439 0.439 0.439) #(0.698 0.698 0.698) #(0.714 0.714 0.714) #(0.721 0.721 0.721) #(0.855 0.855 0.855) #(0.474 0.474 0.474) #(0.871 0.871 0.871) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:13'!
morph
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 1578631802 292362797 539127618 1895825665 2117994270 1445606482 202325275 1997372285 33573212 859313989 1763509875 1213866361 1064308758 192424752 1645101626 793665883 476466020 85208644 1751792704 621947215 1414349622 527711064 676669009 1346794755 1617375851 1095982919 656635516 1819423020 354700362 1695037706 154613091 420699479 75263577 2139062143 2139062143 2139062143)
	offset: 0@0)
	colorsFromArray: #(#(0.557 0.714 0.898) #(0.526 0.686 0.887) #(0.557 0.706 0.887) #(0.494 0.604 0.796) #(0.494 0.6 0.792) #(0.585 0.811 1.0) #(0.879 0.93 0.883) #(0.514 0.671 0.867) #(0.84 0.867 0.902) #(0.581 0.667 0.804) #(0.474 0.577 0.753) #(0.729 0.851 0.674) #(0.51 0.678 0.883) #(0.565 0.71 0.918) #(0.733 0.894 1.0) #(0.538 0.694 0.883) #(0.455 0.741 1.0) #(0.553 0.69 0.871) #(0.969 0.867 0.78) #(0.506 0.635 0.815) #(0.757 0.906 1.0) #(0.851 0.879 0.922) #(0.655 0.844 1.0) #(0.836 0.918 0.992) #(0.604 0.741 0.902) #(0.518 0.631 0.804) #(0.542 0.678 0.855) #(0.549 0.698 0.883) #(0.753 0.875 0.725) #(0.815 0.894 0.823) #(0.51 0.667 0.863) #(0.639 0.733 0.91) #(0.522 0.659 0.84) #(0.686 0.757 0.867) #(0.542 0.671 0.836) #(1.0 0.949 0.612) #(0.848 0.859 0.894) #(0.988 0.949 0.918) #(1.0 0.682 0.514) #(0.984 0.871 0.415) #(1.0 0.796 0.674) #(0.977 0.914 0.867) #(0.518 0.671 0.859) #(0.585 0.776 0.518) #(0.836 0.879 0.922) #(0.534 0.671 0.851) #(0.706 0.757 0.855) #(0.643 0.745 0.879) #(0.819 0.918 1.0) #(0.827 0.871 0.906) #(0.458 0.721 0.404) #(0.62 0.737 0.891) #(0.51 0.631 0.8) #(0.577 0.663 0.848) #(0.506 0.612 0.776) #(0.565 0.671 0.84) #(0.926 0.961 0.992) #(0.581 0.659 0.792) #(0.545 0.639 0.792) #(0.4 0.686 0.353) #(0.811 0.898 0.827) #(0.561 0.706 0.883) #(0.518 0.674 0.871) #(0.659 0.757 0.891) #(0.887 0.945 0.902) #(1.0 0.84 0.717) #(0.717 0.776 0.863) #(0.678 0.745 0.859) #(0.538 0.628 0.776) #(0.898 0.945 0.992) #(1.0 0.918 0.549) #(0.996 0.961 0.757) #(0.863 0.93 0.992) #(0.474 0.628 0.827) #(0.844 0.871 0.914) #(0.62 0.807 0.581) #(0.848 0.867 0.91) #(0.988 0.977 0.898) #(0.804 0.914 1.0) #(0.98 0.977 0.934) #(0.957 0.84 0.365) #(0.961 0.93 0.714) #(0.596 0.678 0.815) #(1.0 0.6 0.314) #(0.953 0.937 0.823) #(1.0 0.538 0.243) #(0.502 0.659 0.855) #(0.498 0.596 0.768) #(0.549 0.792 0.577) #(0.612 0.682 0.807) #(0.914 0.957 0.992) #(0.706 0.863 1.0) #(0.482 0.616 0.8) #(0.498 0.624 0.792) #(0.694 0.757 0.863) #(1.0 0.737 0.569) #(0.631 0.721 0.902) #(0.522 0.772 1.0) #(0.549 0.792 1.0) #(0.553 0.647 0.823) #(0.836 0.926 1.0) #(0.84 0.863 0.891) #(0.423 0.717 0.423) #(0.788 0.898 0.733) #(0.612 0.729 0.887) #(0.918 0.953 0.922) #(0.934 0.965 0.934) #(0.616 0.831 0.628) #(0.53 0.643 0.807) #(0.545 0.686 0.863) #(0.502 0.596 0.753) #(0.616 0.702 0.823) #(0.772 0.898 1.0) #(0.581 0.686 0.844) #(0.851 0.891 0.934) #(0.937 0.965 0.992) #(0.729 0.859 0.686) #(0.671 0.745 0.879) #(0.682 0.749 0.879) #(0.545 0.698 0.898) #(0.388 0.682 0.341) #(0.534 0.639 0.8) #(0.561 0.702 0.883) #(0.553 0.706 0.91) #(0.486 0.588 0.776) #(0.542 0.698 0.887) #(0.522 0.678 0.875) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/30/2011 19:10'!
packageIcon

	^ (Form
		extent: 15@16
		depth: 32
		fromArray:  #(16777215 16777215 16777215 16777215 16777215 16777215 55924053 75530368 50331647 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 33554432 138428480 1750488662 3547295599 2256173690 261724569 55924053 16777215 16777215 16777215 16777215 16777215 16777215 33554432 103492395 1178944837 3361890914 4286085240 4286545791 4286808963 3900275065 1819834488 162179754 75530368 16777215 16777215 16777215 67108864 741618740 2874693720 4235029869 3514399097 3783229311 4286677377 4119234182 3499200913 4203580813 3683026566 1736672131 245671076 41975936 50331648 1902206815 3948896095 4285098345 4285690482 4286019447 4185685116 3213527690 3817441673 4287269514 4287730065 4288848546 4289638062 3180762774 212511402 16777215 2523490665 4084692598 3631641716 4235161455 3497621881 3783229311 4286677377 4119299975 3482555283 4203778192 3919684001 4004358826 3786387375 284159983 16777215 2556847718 4285164138 4285558896 3665656699 3732371319 4286151033 4286545791 4286808963 3968502410 3515912079 4287532686 4288585374 3701974951 234881023 16777215 2639878489 4284506208 4285032552 3715067759 4285822068 3850272125 3883761021 3632563075 4202527868 3582034305 4286743170 4287269514 3583218579 150994943 16777215 2672643405 3863957327 4200291163 3814941539 4285229931 4285558896 4185421687 4285493103 4285822068 3564928124 4286414205 3498542983 3196421509 83886079 16777215 2822651454 4282203453 4182395466 4081929549 4284374622 4284966759 4268715630 4285229931 4285493103 3698027371 3698948473 4286282619 3480976251 83886079 16777216 3039636781 4280756007 4281742902 4265360444 4283058762 4283519313 4284966502 4284243036 4266939476 4233977181 4285690482 4285953654 3480647286 67108863 117440512 2518687776 4246148887 4280098077 4280821800 4282203453 4282992969 4284374365 4284637794 4284900966 4267071062 4285361517 4235095662 2305452650 41975936 16777216 134217728 873731092 3659670050 4245885715 4280690214 4281611316 4283913814 4284835173 4284835173 4065744470 3294255706 844255826 55924053 16777215 16777215 16777215 33554432 218103808 1461131031 3978305568 4280098077 4249635659 4284835173 3730463322 1246514252 100663296 16777215 16777215 16777215 16777215 16777215 16777215 16777215 50331648 285212672 2115903006 3645129539 1833979984 150994944 16777216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 134217728 33554432 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/30/2011 14:23'!
refreshIcon
	^(Form
		extent: 16@16
		depth: 32
		fromArray: #( 0 0 0 0 0 0 0 895969127 526080859 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1884706390 4168710521 2288675434 271330348 0 0 0 0 0 0 0 0 0 828465505 2609087363 3615917702 4269439610 4285887861 4285624689 3899156584 1766607948 67569415 0 0 0 0 0 50529027 2306242166 4237069452 4286940549 4286611584 4286282619 4285887861 4285558896 4285229931 4268189543 2235514687 0 0 0 0 0 2590862701 4287598479 4287269514 4270097540 3329652342 3312217196 4285887861 4285558896 3345179491 1011567435 0 0 0 0 0 1263423054 4287532686 4287532686 3867378563 1096835168 0 1885166941 3681579120 1549227863 50923785 0 0 0 0 0 0 3061545851 4287795858 4236937866 811951461 0 0 641547581 137441585 0 0 0 0 0 0 0 34936085 4102720138 4287795858 3011016824 0 0 0 0 0 0 0 0 0 0 0 0 272317243 4287861651 4287795858 2489607268 0 0 0 0 0 0 0 0 68095759 0 0 0 204682035 4287730065 4287795858 2658432116 0 0 0 0 0 0 0 34014983 3965146967 4283979864 3125694030 0 0 3767044232 4287795858 3884287365 137244206 0 0 0 0 0 0 1129863256 4284769380 4284506208 2739423304 0 0 2189459584 4287795858 4287532686 2541123190 16843009 0 0 0 0 305805882 3597166696 4284703587 4250885983 910114623 0 0 273698896 3834218889 4287532686 4287335307 3094442353 1094532413 101255433 286199567 1582124365 3731318631 4284966759 4284703587 2689946965 0 0 0 0 879126118 3985082247 4287269514 4286940549 4286611584 4285624689 4285558896 4285624689 4285229931 4284966759 3227212635 220998700 0 0 0 0 0 509698401 2977659771 4286743170 4286545791 4286282619 4285887861 4285558896 4100417383 2170116441 103295016 0 0 0 0 0 0 0 0 575820370 1734895720 2121298032 2037017194 1448564567 255013683 0 0 0 0 0)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/31/2011 01:59'!
removeIcon
	^ (Form
	extent: 16@16
	depth: 32
	fromArray:  #(0 0 0 0 0 16777216 975118106 1948196125 2233408797 505551386 0 0 0 0 0 0 0 0 0 740105501 2485067036 3913366574 4287266903 4291870588 4290358386 4234896198 2770871586 723394078 0 0 0 0 0 169482778 2803834139 4266346036 4290226543 4292129381 4291006529 4287127849 4290939191 4289826121 4292857218 4270292053 3056281379 991829530 0 0 0 2048727835 4289170770 4293777803 4291932517 4286537258 4278912771 4278190080 4279044356 4285747232 4289428791 4293645446 4293515148 4285162053 1461525786 0 0 2233014039 4292059214 4291203136 4290485594 4293186183 4288648552 4283518790 4284439625 4290950264 4292989063 4292791942 4294041488 4289240168 2535004182 0 0 1141837583 4079033886 4283716440 4291862608 4291794755 4292721001 4294896278 4294436244 4293515404 4294436244 4291016058 4286086513 4079889188 1712262925 0 0 134217728 3676117787 4280495698 4280627542 4282731358 4290877268 4294104192 4289439097 4284839294 4283921301 4284976569 4284516277 2786662166 469762048 0 0 0 3407682073 4283195017 4283194246 4282338678 4281351266 4282406780 4283791527 4284188861 4284124357 4283993287 4282936985 2249528595 0 0 0 0 3122338329 4283195018 4283194246 4283194246 4283194246 4283198876 4283927751 4283927751 4283927751 4283927751 4282408577 1746145553 0 0 0 0 2837125656 4283063944 4283194246 4283194246 4283194246 4283463079 4283927751 4283927751 4283927751 4283927751 4281880424 1225657870 0 0 0 0 2518292504 4282932356 4283194246 4283194246 4283194246 4283594409 4283927751 4283927751 4283927751 4283927751 4264641108 688260614 0 0 0 0 2199459607 4282800510 4283194246 4283194246 4283194246 4283395998 4283927751 4283927751 4283927751 4283927751 4062984519 436207616 0 0 0 0 1192366610 4248059475 4283195017 4283194246 4283194246 4283066516 4283927751 4283927751 4283927751 4283729855 3676448299 285212672 0 0 0 0 67108864 1494289934 3827639852 4282932356 4283194246 4282803083 4283927751 4283729598 4282408577 4230492216 2434077971 67108864 0 0 0 0 0 0 503908617 2887325720 4265496687 4282340983 4281682014 4062323235 2836928279 1225394698 268435456 0 0 0 0 0 0 0 0 67108864 1662326034 2904102936 2216105237 604440327 67108864 0 0 0 0 0)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/13/2011 11:45'!
separatorIcon

	^ (Form
		extent: 24@5
		depth: 32
		fromArray: #(16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1329216058 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1329216058 3869089181 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 4291019715 3869089181 1329216058 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1463828544 1329216058 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:02'!
sourceSelectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray:  #(4104759721 4241872341 4241938134 4242003927 4242135513 4258978522 4259175901 4259241694 4259373280 4259504866 4259570659 4259768038 4276676840 4276808426 4276940012 4277137391 4277268977 4277400563 4277663735 4294572537 4294638330 4294835709 4294835709 4260952312 4170026381 4291480266 4292796126 4292796126 4292730333 4292861919 4292861919 4292993505 4292927712 4292993505 4293059298 4293125091 4293125091 4293190884 4293190884 4293322470 4293322470 4293454056 4293454056 4293519849 4293651435 4293651435 4294309365 4277926907 4186474632 4290624957 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277926907 4186211460 4290361785 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293651435 4277795321 4185816702 4290164406 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4290559164 4288322202 4286677377 4287072135 4288059030 4289835441 4292401368 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293519849 4277597942 4202264953 4290032820 4292664540 4292664540 4292664540 4292664540 4292664540 4290756543 4282860089 4280753420 4284695566 4286534405 4286140423 4284826893 4282330640 4279504905 4283386433 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260689140 4201935988 4289901234 4292664540 4292664540 4292664540 4292664540 4291940817 4280688920 4288702210 4294812161 4294943489 4294943489 4294943489 4294943489 4294943489 4294812161 4279570699 4292664540 4292664540 4292664540 4292664540 4292664540 4293454056 4260491761 4201541230 4289703855 4292664540 4292664540 4292664540 4292664540 4286018931 4285877510 4294943489 4294615041 4285417737 4281739280 4280293645 4282002192 4284695307 4290081793 4279570699 4292664540 4292664540 4292664540 4292664540 4292664540 4293322470 4260360175 4201146472 4289440683 4292664540 4292664540 4292664540 4292664540 4283188796 4290738689 4294943489 4287848196 4283386692 4290822336 4292467161 4290822336 4287598479 4282728245 4282202159 4292664540 4292664540 4292664540 4292664540 4292664540 4293322470 4243385580 4217528930 4289177511 4292664540 4292664540 4292664540 4292664540 4282201643 4291921409 4294943489 4288110851 4282136625 4289177511 4292401368 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243253994 4217134172 4288980132 4292664540 4292664540 4292664540 4292664540 4284702552 4288045315 4294943489 4294746369 4288833538 4283053328 4279767818 4281609506 4285821550 4290822336 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4293190884 4243056615 4216673621 4288848546 4292664540 4292664540 4292664540 4292664540 4290822336 4280096525 4291724289 4294943489 4294943489 4294943489 4294943489 4292381185 4287257092 4280227852 4286281843 4292664540 4292664540 4292664540 4292664540 4292664540 4293125091 4242990822 4233121872 4288519581 4292664540 4292664540 4292664540 4292664540 4292664540 4289309097 4280623127 4283119119 4288702210 4292841217 4294943489 4294943489 4294943489 4293892353 4281541901 4289111718 4292664540 4292664540 4292664540 4292664540 4293125091 4225950434 4232595528 4288387995 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292467161 4288914339 4284570966 4281280541 4280885005 4287651076 4294943489 4294943489 4289950209 4283912520 4292664540 4292664540 4292664540 4292664540 4293059298 4225884641 4232134977 4288059030 4292664540 4292664540 4292664540 4292664540 4291480266 4291151301 4292664540 4292664540 4292664540 4292664540 4290690750 4281412643 4291198721 4294943489 4292249857 4282004264 4292664540 4292664540 4292664540 4292664540 4292993505 4225687262 4231740219 4287861651 4292664540 4292664540 4292664540 4292664540 4283386174 4279373319 4283123260 4288322202 4290822336 4292467161 4290032820 4280886300 4291330049 4294943489 4290410241 4283583554 4292664540 4292664540 4292664540 4292664540 4292927712 4208778460 4247925298 4287532686 4292664540 4292664540 4292664540 4292664540 4283385916 4290607361 4289884673 4284235791 4281673744 4279702025 4281870608 4287388937 4294943489 4294943489 4285549063 4286282360 4292664540 4292664540 4292664540 4292664540 4292993505 4208712667 4247398954 4287335307 4292664540 4292664540 4292664540 4292664540 4283385916 4288176385 4294680577 4294943489 4294943489 4294943489 4294943489 4294943489 4294877697 4288636418 4280754713 4292072403 4292664540 4292664540 4292664540 4292664540 4292861919 4208581081 4246938403 4287006342 4292664540 4292664540 4292664540 4292664540 4288979874 4282465072 4279702026 4283184655 4285089547 4286862853 4286534407 4284367117 4280819213 4282925625 4290756543 4292664540 4292664540 4292664540 4292664540 4292664540 4292861919 4208449495 4263189275 4286677377 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292138196 4289309097 4287927444 4286479998 4286743170 4288453788 4290822336 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292730333 4191540693 4262728724 4286479998 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191474900 4262136587 4286151033 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292664540 4292796126 4191343314 4262136587 4282269246 4286151033 4286479998 4286677377 4287006342 4287335307 4287532686 4287861651 4288059030 4288387995 4288519581 4288848546 4288980132 4289177511 4289440683 4289703855 4289901234 4290032820 4290164406 4290361785 4290624957 4291480266 4174434512 4229042706 4262136587 4262136587 4262728724 4263189275 4246938403 4247398954 4247925298 4231740219 4232134977 4232595528 4233121872 4216673621 4217134172 4217528930 4201146472 4201541230 4201935988 4202264953 4185816702 4186211460 4186474632 4170026381 4054164901)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/12/2011 17:01'!
sourceUnselectedIcon

	^ (Form
		extent: 24@24
		depth: 32
		fromArray:  #(4103575447 4240688067 4240819653 4241017032 4241148618 4258057420 4258320592 4258452178 4258583764 4258781143 4258912729 4259175901 4276150496 4276282082 4276545254 4276742633 4276940012 4277071598 4277400563 4294375158 4294506744 4294835709 4294835709 4260754933 4168907900 4289769648 4290822336 4290822336 4290822336 4290953922 4291019715 4291151301 4291151301 4291217094 4291282887 4291414473 4291480266 4291546059 4291611852 4291677645 4291743438 4291875024 4291940817 4292072403 4292203989 4292203989 4293585642 4277795321 4185356151 4288651167 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277795321 4185158772 4288387995 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292203989 4277597942 4184895600 4288256409 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4288322202 4286479998 4285164138 4285493103 4286282619 4287730065 4289769648 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4292072403 4277334770 4201343851 4288124823 4290032820 4290032820 4290032820 4290032820 4290032820 4288453788 4281742902 4279703319 4281742902 4282532418 4282335039 4281808695 4280624421 4278979596 4282137660 4290032820 4290032820 4290032820 4290032820 4290032820 4291940817 4260425968 4201080679 4288059030 4290032820 4290032820 4290032820 4290032820 4289440683 4279966491 4283519313 4286545791 4286611584 4286611584 4286611584 4286611584 4286611584 4286545791 4279111182 4290032820 4290032820 4290032820 4290032820 4290032820 4291875024 4260162796 4200685921 4287861651 4290032820 4290032820 4290032820 4290032820 4284506208 4282203453 4286611584 4286414205 4282071867 4280295456 4279571733 4280427042 4281677109 4284177243 4279111182 4290032820 4290032820 4290032820 4290032820 4290032820 4291743438 4259965417 4200356956 4287664272 4290032820 4290032820 4290032820 4290032820 4281940281 4284506208 4286611584 4283124555 4282269246 4288519581 4289901234 4288519581 4285887861 4281545523 4281216558 4290032820 4290032820 4290032820 4290032820 4290032820 4291677645 4242925029 4216805207 4287401100 4290032820 4290032820 4290032820 4290032820 4281084972 4285098345 4286611584 4283190348 4281216558 4287137928 4289769648 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291611852 4242727650 4216476242 4287203721 4290032820 4290032820 4290032820 4290032820 4283256141 4283124555 4286611584 4286479998 4283585106 4280953386 4279176975 4280624421 4284308829 4288519581 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4291546059 4242530271 4216081484 4287137928 4290032820 4290032820 4290032820 4290032820 4288519581 4279440147 4284966759 4286611584 4286611584 4286611584 4286611584 4285295724 4282861383 4279505940 4284637794 4290032820 4290032820 4290032820 4290032820 4290032820 4291480266 4242398685 4232529735 4286874756 4290032820 4290032820 4290032820 4290032820 4290032820 4287269514 4279900698 4280953386 4283519313 4285558896 4286611584 4286611584 4286611584 4286085240 4280163870 4287137928 4290032820 4290032820 4290032820 4290032820 4291414473 4225358297 4232069184 4286743170 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289835441 4286940549 4283256141 4280361249 4279834905 4283058762 4286611584 4286611584 4284111450 4282532418 4290032820 4290032820 4290032820 4290032820 4291282887 4225226711 4231674426 4286479998 4290032820 4290032820 4290032820 4290032820 4289045925 4288782753 4290032820 4290032820 4290032820 4290032820 4288387995 4280558628 4284703587 4286611584 4285229931 4280887593 4290032820 4290032820 4290032820 4290032820 4291217094 4224963539 4231345461 4286216826 4290032820 4290032820 4290032820 4290032820 4282071867 4278979596 4281940281 4286479998 4288519581 4289835441 4287927444 4280163870 4284769380 4286611584 4284308829 4282269246 4290032820 4290032820 4290032820 4290032820 4291151301 4207988944 4247530540 4285953654 4290032820 4290032820 4290032820 4290032820 4282071867 4284440415 4284045657 4281545523 4280229663 4279176975 4280361249 4282927176 4286611584 4286611584 4282071867 4284769380 4290032820 4290032820 4290032820 4290032820 4291151301 4207857358 4247069989 4285756275 4290032820 4290032820 4290032820 4290032820 4282071867 4283190348 4286479998 4286611584 4286611584 4286611584 4286611584 4286611584 4286545791 4283453520 4279966491 4289572269 4290032820 4290032820 4290032820 4290032820 4291019715 4207725772 4246675231 4285493103 4290032820 4290032820 4290032820 4290032820 4287006342 4281413937 4279176975 4280953386 4281874488 4282664004 4282532418 4281545523 4279834905 4281742902 4288453788 4290032820 4290032820 4290032820 4290032820 4290032820 4290953922 4207528393 4262926103 4285229931 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4289638062 4287269514 4286151033 4284966759 4285229931 4286611584 4288519581 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190553798 4262531345 4285032552 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190422212 4262005001 4284703587 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290032820 4290822336 4190224833 4262005001 4281545523 4284703587 4285032552 4285229931 4285493103 4285756275 4285953654 4286216826 4286479998 4286743170 4286874756 4287137928 4287203721 4287401100 4287664272 4287861651 4288059030 4288124823 4288256409 4288387995 4288651167 4289769648 4173316031 4228779534 4262005001 4262005001 4262531345 4262926103 4246675231 4247069989 4247530540 4231345461 4231674426 4232069184 4232529735 4216081484 4216476242 4216805207 4200356956 4200685921 4201080679 4201343851 4184895600 4185158772 4185356151 4168907900 4052980627)
		offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:19'!
string
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 673716502 100672805 623061032 673717016 118757928 587409448 673710082 33825576 354166824 673717518 268698408 19277864 673714447 504037672 638134312 673720360 302655016 606152744 673720360 673588264 555886632 673720360 673456424 572991528 673720360 671621672 656418856 673720360 673654568 538912808 673720360 671948840 84682792 673720360 673128232 320284712)
	offset: 0@0)
	colorsFromArray: #(#(0.439 0.721 0.937) #(0.447 0.674 0.93) #(0.573 0.784 0.953) #(0.451 0.682 0.937) #(0.534 0.761 0.949) #(0.435 0.631 0.926) #(0.439 0.729 0.945) #(0.573 0.788 0.953) #(0.443 0.651 0.926) #(0.443 0.663 0.93) #(0.427 0.671 0.93) #(0.494 0.733 0.945) #(0.431 0.631 0.926) #(0.435 0.643 0.926) #(0.498 0.745 0.945) #(0.478 0.694 0.934) #(0.569 0.78 0.953) #(0.941 0.965 0.992) #(0.941 0.961 0.992) #(0.431 0.628 0.926) #(0.538 0.764 0.949) #(0.447 0.682 0.937) #(0.435 0.706 0.937) #(0.431 0.628 0.918) #(0.522 0.768 0.949) #(0.827 0.898 0.977) #(0.455 0.694 0.937) #(0.419 0.71 0.937) #(0.447 0.682 0.93) #(0.455 0.698 0.937) #(0.443 0.71 0.937) #(0.435 0.635 0.926) #(0.435 0.639 0.926) #(0.443 0.659 0.926) #(0.439 0.651 0.926) #(0.451 0.686 0.937) #(0.443 0.659 0.93) #(0.439 0.717 0.937) #(0.443 0.671 0.93) #(0.435 0.647 0.926) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 17:57'!
testGreen
    ^(Form
	extent: 12@12
	depth: 32
	fromArray:   #(16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215 16777215 436207616 3204448256 4278323202 4280376350 4283209800 4283603789 4281625137 4278454788 3204448256 436207616 16777215 16777216 3204448256 4279053323 4284135253 4285913199 4286964095 4287686539 4287686539 4286173300 4279974425 3204448256 16777216 1694498816 4278390018 4281819188 4281322278 4281584939 4283421512 4286701692 4287686539 4287686539 4286502265 4278718727 1694498816 3003121664 4278532866 4279526927 4278962688 4278962688 4278962688 4280077330 4285521256 4287686539 4287686539 4282680896 3003121664 3858759680 4278596868 4279588369 4278962688 4278962688 4278962688 4278962688 4279880718 4286505081 4287686539 4284724574 3858759680 3858759680 4278596100 4279775511 4279091970 4278962688 4278962688 4278962688 4278962688 4282700348 4286964095 4284330585 3858759680 3003121664 4278531331 4279838232 4280186137 4278962688 4278962688 4278962688 4278962688 4280863775 4285913199 4281432365 3003121664 1694498816 4278258432 4279710997 4280959017 4280909604 4279288326 4278962688 4278962688 4280928544 4284924000 4278718727 1694498816 16777216 3204448256 4278592773 4280634914 4281948471 4282806595 4282814529 4282884930 4284523356 4279448081 3204448256 16777216 16777215 436207616 3204448256 4278257409 4279649811 4280902950 4281167401 4279980312 4278388995 3204448256 436207616 16777215 16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 17:54'!
testNotRun
    ^(Form
	extent: 12@12
	depth: 32
	fromArray:  #(16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215 16777215 436207616 3204448256 4278584838 4282795590 4286348412 4286611584 4283848278 4278716424 3204448256 436207616 16777215 16777216 3204448256 4280295456 4287927444 4289967027 4290690750 4291217094 4291217094 4289703855 4281216558 3204448256 16777216 1694498816 4278782217 4283453520 4287664272 4287861651 4288848546 4290559164 4291217094 4291217094 4290032820 4279111182 1694498816 3003121664 4280756007 4282861383 4286743170 4286743170 4286743170 4287269514 4289967027 4291217094 4291217094 4285361517 3003121664 3858759680 4280492835 4282203453 4286743170 4286743170 4286743170 4286743170 4287137928 4290493371 4291217094 4288059030 3858759680 3858759680 4280361249 4280821800 4286479998 4286743170 4286743170 4286743170 4286743170 4288453788 4290690750 4287795858 3858759680 3003121664 4280492835 4280361249 4283716692 4286743170 4286743170 4286743170 4286743170 4287598479 4289967027 4284374622 3003121664 1694498816 4278650631 4280953386 4281874488 4284440415 4286545791 4286743170 4286743170 4287466893 4288585374 4279111182 1694498816 16777216 3204448256 4279834905 4282269246 4283256141 4284572001 4285822068 4286611584 4287203721 4280756007 3204448256 16777216 16777215 436207616 3204448256 4278519045 4281611316 4283387727 4283782485 4282203453 4278650631 3204448256 436207616 16777215 16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 17:58'!
testRed
    ^(Form
	extent: 12@12
	depth: 32
	fromArray:   #(16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215 16777215 436207616 3204448256 4278714882 4284227102 4288170056 4288367949 4285149489 4278846468 3204448256 436207616 16777215 16777216 3204448256 4281076491 4290205013 4292374383 4292968319 4293364619 4293364619 4291851380 4281997593 3204448256 16777216 1694498816 4279042562 4284494900 4291503654 4291636011 4292036680 4292902012 4293364619 4293364619 4292180345 4279305991 1694498816 3003121664 4282057218 4284878607 4291428352 4291428352 4291428352 4291564050 4292700264 4293364619 4293364619 4286988352 3003121664 3858759680 4281664516 4283830545 4291428352 4291428352 4291428352 4291428352 4291563022 4292901241 4293364619 4290076254 3858759680 3858759680 4281467908 4281407255 4290970114 4291428352 4291428352 4291428352 4291428352 4291968060 4292968319 4289878361 3858759680 3003121664 4281664259 4280686616 4285864217 4291428352 4291428352 4291428352 4291428352 4291567391 4292374383 4286131501 3003121664 1694498816 4278910976 4281668885 4282394921 4286522404 4290905606 4291428352 4291428352 4291371040 4290797664 4279305991 1694498816 16777216 3204448256 4280616197 4283310626 4284036919 4285612867 4287643969 4288889410 4288896092 4281471249 3204448256 16777216 16777215 436207616 3204448256 4278649089 4282782483 4284818982 4285409577 4283504664 4278780675 3204448256 436207616 16777215 16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215)
	offset: 0@0)! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 4/6/2011 17:58'!
testYellow
    ^(Form
	extent: 12@12
	depth: 32
	fromArray:  #(16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215 16777215 436207616 3204448256 4278782211 4285164839 4289375827 4289572953 4286020153 4278913797 3204448256 436207616 16777215 16777216 3204448256 4281545744 4291612771 4293915774 4294376077 4294705048 4294705048 4293191809 4282467102 3204448256 16777216 1694498816 4279176964 4285164603 4293850685 4294047809 4294113371 4294376074 4294705048 4294705048 4293521030 4279505928 1694498816 3003121664 4282862090 4286151963 4294377244 4294377244 4294377244 4294311212 4294376312 4294705048 4294705048 4288059722 3003121664 3858759680 4282335499 4284835867 4294377244 4294377244 4294377244 4294377244 4294311465 4294376327 4294705048 4291349354 3858759680 3858759680 4282072330 4281808922 4293785117 4294377244 4294377244 4294377244 4294377244 4294113616 4294376077 4291218021 3858759680 3003121664 4282467082 4280887578 4287204646 4294377244 4294377244 4294377244 4294377244 4294113847 4293915774 4287270200 3003121664 1694498816 4279111170 4282137882 4282795820 4287862577 4293653536 4294377244 4294377244 4293784887 4292139373 4279505928 1694498816 16777216 3204448256 4281019657 4283914536 4284506684 4286283082 4288783436 4290362703 4289836389 4282006550 3204448256 16777216 16777215 436207616 3204448256 4278716418 4283519770 4285756975 4286415155 4284375328 4278848004 3204448256 436207616 16777215 16777215 16777215 16777216 1694498816 3003121664 3858759680 3858759680 3003121664 1694498816 16777216 16777215 16777215)
	offset: 0@0)! !

Object subclass: #NautilusWrapper
	instanceVariableNames: 'selectedPackage selectedCategory selectedMethod selectedClass selectedGroup showPackages showGroups showHierarchy showComment showInstance showCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/13/2011 16:35'!
with: aNautilus

	^ self new with: aNautilus! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedCategory

		^ selectedCategory! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedCategory: anObject
	
		selectedCategory := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedClass

		^ selectedClass! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedClass: anObject
	
		selectedClass := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedGroup

		^ selectedGroup! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedGroup: anObject
	
		selectedGroup := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedMethod

		^ selectedMethod! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedMethod: anObject
	
		selectedMethod := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedPackage

		^ selectedPackage! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
selectedPackage: anObject
	
		selectedPackage := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showCategories

		^ showCategories! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showCategories: anObject
	
		showCategories := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showComment

		^ showComment! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showComment: anObject
	
		showComment := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showGroups

		^ showGroups! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showGroups: anObject
	
		showGroups := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showHierarchy

		^ showHierarchy! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showHierarchy: anObject
	
		showHierarchy := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showInstance

		^ showInstance! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showInstance: anObject
	
		showInstance := anObject! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showPackages

		^ showPackages! !

!NautilusWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/13/2011 16:34'!
showPackages: anObject
	
		showPackages := anObject! !

!NautilusWrapper methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/13/2011 16:37'!
with: aNautilus
	
	self 
		selectedPackage: aNautilus selectedPackage;
		selectedCategory: aNautilus selectedCategory;
		selectedMethod: aNautilus selectedMethod;
		selectedClass: aNautilus selectedClass;
		selectedGroup: aNautilus selectedGroup;
		showPackages: aNautilus showPackages;
		showGroups: aNautilus showGroups;
		showHierarchy: aNautilus showHierarchy;
		showComment: aNautilus showComment;
		showInstance: aNautilus showInstance;
		showCategories: aNautilus showCategories.! !

!ClassDescription methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 4/7/2011 17:11'!
correspondingTestClass

	(self name endsWith: 'Test')
		ifTrue: [ ^ self ]
		ifFalse: [| symbol |
			symbol := Symbol readFromString: ('#', self name, 'Test').
			^ Smalltalk at: symbol ifAbsent: [ nil ]]! !
NautilusIcons initialize!
Nautilus initialize!
